<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Accounts extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		//$this->load->model('billingModel/Billing_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('gatewayModel/Gateway_model');		
		$this->load->model('accountsModel/Accounts_fetch_model');		
		$this->load->model('diagnosticsModel/Diagnostics_fetch_model');		
	}
	//************************accounts dash board start**********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('accounts/accounts_dashboard',$userModuleData);
	}
		//************************accounts dash board End **********
	function billList()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();				
		$data['all_staff']=$this->Common_fetch_model->fetch_all_employee_name(3);//staff type				
		$this->load->view('accounts/bill_list',$data);
	}
	function get_opd_bill_list()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));		
		
		$services=$this->input->post('services');		
		$payment_mode=$this->input->post('payment_mode');		
		$employee=$this->input->post('employee');		
		$response=$this->Accounts_fetch_model->fetch_payment_list($from_date,$to_date,$payment_mode,$employee);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				if($record->payment_mode==1)
					$payment_mode_text="Cash";
				else if($record->payment_mode==2)
					$payment_mode_text="Debit Card";
				else if($record->payment_mode==3)
					$payment_mode_text="Credit Card";
				else if($record->payment_mode==4)
					$payment_mode_text="Cheque";
				else if($record->payment_mode==5)
					$payment_mode_text="UPI/Wallet";				
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->bill_prefix?><?=$record->uid?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$record->net_amount?></td>
				<td><?=$payment_mode_text?></td>
				<td>
				<a href="<?=base_url()?>Billing/printBill/<?=$record->uid?>" target="blank" title="Reprint">
					<i class="fa fa-print" aria-hidden="true"></i>
				</a>
				
				</td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	
	function serviceWiseDSR()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);					
		$this->load->view('accounts/service_wise_dsr',$data);
	}

	function get_service_wise_dsr()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		$all_services=$this->Common_fetch_model->fetch_all_service_list_items();		
				
		//$response=$this->Accounts_fetch_model->fetch_payment_list($from_date,$to_date,$payment_mode,$employee);				
		$sl=0;
		if($all_services)
		{
			$sum=0;
			foreach($all_services as $record)
			{	
				if($record->uid!=107 && $record->uid!=114)
				{
					$total_net=$this->Accounts_fetch_model->fetch_service_total_bill_net($record->uid,$from_date,$to_date,'billing');	//(service_uid,fromdate,todate)			
				}
				if($record->uid==107 || $record->uid==114)
				{
					$total_net=$this->Accounts_fetch_model->fetch_service_total_bill_net($record->uid,$from_date,$to_date,'billing_ipd');	//(service_uid,fromdate,todate)			
				}
				$total_discount=$this->Accounts_fetch_model->fetch_total_bill_discount($record->uid,$from_date,$to_date);	//(service_uid,fromdate,todate)			
				
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><a href="javascript:void(0)" onclick="service_details_show(<?=$record->uid?>,'<?=$from_date?>','<?=$to_date?>')"><?=$record->misc_name?></a></td>
				<td><?=$total_net->total_service_net?></td>
				<td><?=$total_discount->total_service_discount?></td>
			  </tr>

			<?php
				$sum+=$total_net->total_service_net;
				$disc_sum+=$total_discount->total_service_discount;
			}
			?>			
			<tr>
				<td>&nbsp;</td>
				<td><b>Total Amount</b></td>
				<td ><b><?=$sum?></b></td>
				<td ><b><?=$disc_sum?></b></td>
			</tr>
			<?php
		}
		else
		{?>
			  <tr>
				<td colspan="5"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function userWiseDSR()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);					
		$this->load->view('accounts/user_wise_dsr',$data);
	}
	function get_user_wise_dsr()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		$clinic_id=$_SESSION['clinicId'];
		$all_logged_employee=$this->Accounts_fetch_model->fetch_all_logged_employee($clinic_id);		
		//print_r($all_logged_employee);die();		
		//$response=$this->Accounts_fetch_model->fetch_payment_list($from_date,$to_date,$payment_mode,$employee);				
		$sl=0;
		if($all_logged_employee)
		{
			$sum=0;
			foreach($all_logged_employee as $record)
			{	
				$total_cash=$this->Accounts_fetch_model->fetch_user_net_by_mode($record->employee_uid,1,$clinic_id,$from_date,$to_date);	//(employee id,payment mode)			
				$total_debit_card=$this->Accounts_fetch_model->fetch_user_net_by_mode($record->employee_uid,2,$clinic_id,$from_date,$to_date);	//(employee id,payment mode)			
				$total_credit_card=$this->Accounts_fetch_model->fetch_user_net_by_mode($record->employee_uid,3,$clinic_id,$from_date,$to_date);	//(employee id,payment mode)			
				$total_cheque=$this->Accounts_fetch_model->fetch_user_net_by_mode($record->employee_uid,4,$clinic_id,$from_date,$to_date);	//(employee id,payment mode)			
				$total_upi_wallet=$this->Accounts_fetch_model->fetch_user_net_by_mode($record->employee_uid,5,$clinic_id,$from_date,$to_date);	//(employee id,payment mode)			
		
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->full_name?></td>
				<td><?=$total_cash->net_amount?></td>
				<td><?=$total_debit_card->net_amount+$total_credit_card->net_amount?></td>
				<td><?=$total_cheque->net_amount?></td>
				<td><?=$total_upi_wallet->net_amount?></td>
				<td ><I><?=($total_cash->net_amount+($total_debit_card->net_amount+$total_credit_card->net_amount)+$total_cheque->net_amount+$total_upi_wallet->net_amount)?></I></td>
				
			  </tr>

			<?php
				$sum_cash+=$total_cash->net_amount;
				$sum_card+=($total_debit_card->net_amount+$total_credit_card->net_amount);
				$sum_cheque+=$total_cheque->net_amount;
				$sum_upi_wallet+=$total_upi_wallet->net_amount;
			}
			?>			
			<tr>
				<td>&nbsp;</td>
				<td><b>Total Amount</b></td>
				<td ><b><?=$sum_cash?></b></td>
				<td ><b><?=$sum_card?></b></td>
				<td ><b><?=$sum_cheque?></b></td>
				<td ><b><?=$sum_upi_wallet?></b></td>
				<td ><b><?=($sum_cash+$sum_card+$sum_cheque+$sum_upi_wallet)?></b></td>
			</tr>
			<?php
		}
		else
		{?>
			  <tr>
				<td colspan="6"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function billMaster()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();				
		$data['all_staff']=$this->Common_fetch_model->fetch_all_employee_name(3);//staff type				
		$this->load->view('accounts/bill_master',$data);
	}
	function get_bill_master_list()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));		
	
		$response=$this->Accounts_fetch_model->fetch_bill_master_list($from_date,$to_date);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				
			?>
			  <tr style="<?=($record->cancel_flag==1)?'background-color:#fea1a1':''?>">
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->bill_prefix?><?=$record->uid?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$record->gross_amount?></td>
				<td><?=$record->discount_amount?></td>
				<td><?=$record->net_amount?></td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function receiptMaster()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();				
		$data['all_staff']=$this->Common_fetch_model->fetch_all_employee_name(3);//staff type				
		$this->load->view('accounts/receipt_master',$data);
	}
	function get_receipt_master_list()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));		
	
		$payment_mode=$this->input->post('payment_mode');		
	
		$response=$this->Accounts_fetch_model->fetch_receipt_master_list($from_date,$to_date,$payment_mode);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				if($record->payment_mode==1)
					$payment_mode_text="Cash";
				else if($record->payment_mode==2)
					$payment_mode_text="Debit Card";
				else if($record->payment_mode==3)
					$payment_mode_text="Credit Card";
				else if($record->payment_mode==4)
					$payment_mode_text="Cheque";
				else if($record->payment_mode==5)
					$payment_mode_text="UPI/Wallet";				
			?>
			  <tr style="<?=($record->cancel_flag==1)?'background-color:#fea1a1':''?>">
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->voucher_date))?></td>
				<td><?=$record->receipt_prefix?><?=$record->uid?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$payment_mode_text?></td>
				<td><?=$record->net_amount?></td>
				<td><?=$record->card_instrument_no?></td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function get_service_details_breakup()
	{
		$from_date=$this->input->post('from_date');
		$to_date=$this->input->post('to_date');
		$service_id=$this->input->post('service_id');		
	
		$response=$this->Accounts_fetch_model->fetch_service_details_breakup($from_date,$to_date,$service_id);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				//if consultation
				if($service_id==101)//then get doctor name as item
				{
					$doctorItmData=$this->Common_fetch_model->fetch_doctor_name_by_id($record->doctor_id);
					$itmName=$doctorItmData->full_name;
				}
				else if($service_id==103 || $service_id==104)//then get doctor name as item
				{
					$doctorItmData=$this->Diagnostics_fetch_model->fetch_investigation_record($record->item_id);
					$itmName=$doctorItmData->test_name;
				}
				else
				{
					$doctorItmData=$this->Common_fetch_model->fetch_item_by_id($record->item_id);
					$itmName=$doctorItmData->item_name;
				}					
			?>
			  <tr style="<?=($record->cancel_flag==1)?'background-color:#fea1a1':''?>">
				<td><?=++$sl?></td>
				<td><?=$itmName?></td>
				<td><?=$record->bill_date?></td>
				<td><?=$record->bill_no?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$record->service_amount?></td>
				<td><?=$record->discount_amount?></td>
				<td><?=$record->gross_amount?></td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}		
	}
	function itemWiseReceipt()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);					
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list();
		$this->load->view('accounts/item_wise_receipt',$data);
	}
	function get_items()
	{
		$service_id=$this->input->post('service_id');		
		$billing_type=$this->input->post('billing_type');		

		//if consultation
		if($service_id==101)//then get doctor name as item
		{
			$doctorItmData=$this->Common_fetch_model->fetch_departmental_doctors_name(0);
			echo '<option value="-1">-Select-</option>';
			foreach($doctorItmData as $record)
			{
				?>
				<option value="<?=$record->uid?>"><?=$record->full_name?></option>
				<?php
			}				
		}
		else if($service_id==103 || $service_id==104)//then get doctor name as item
		{
			if($service_id==103)
				$doctorItmData=$this->Diagnostics_fetch_model->fetch_all_investigation(0,'test_name','ASC',1);
			if($service_id==104)
				$doctorItmData=$this->Diagnostics_fetch_model->fetch_all_investigation(0,'test_name','ASC',2);			
			echo '<option value="-1">-Select-</option>';
			foreach($doctorItmData as $record)
			{
				?>
				<option value="<?=$record->uid?>"><?=$record->test_name?></option>
				<?php
			}			
		}
		else
		{
			$doctorItmData=$this->Common_fetch_model->fetch_item_by_service_id($service_id);
			echo '<option value="-1">-Select-</option>';
			foreach($doctorItmData as $record)
			{
				?>
				<option value="<?=$record->uid?>"><?=$record->item_name?></option>
				<?php
			}			

		}					
		
	}
	function get_item_wise_receipt()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));			
		$billing_type=$this->input->post('billing_type');		
		$item=$this->input->post('item');		
		$service_id=$this->input->post('service_id');		
	
		if($billing_type=="opd")
			$response=$this->Accounts_fetch_model->fetch_item_wise_receipt($from_date,$to_date,$item,$service_id,'billing');				
		if($billing_type=="ipd")
			$response=$this->Accounts_fetch_model->fetch_item_wise_receipt($from_date,$to_date,$item,$service_id,'billing_ipd');						

		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				//if consultation
				if($record->service_uid==101)//then get doctor name as item
				{
					$doctorItmData=$this->Common_fetch_model->fetch_doctor_name_by_id($record->doctor_id);
					$itmName=$doctorItmData->full_name;
				}
				else if($record->service_uid==103 || $record->service_uid==104)//then get doctor name as item
				{
					$doctorItmData=$this->Diagnostics_fetch_model->fetch_investigation_record($record->item_id);
					$itmName=$doctorItmData->test_name;
				}
				else
				{
					$doctorItmData=$this->Common_fetch_model->fetch_item_by_id($record->item_id);
					$itmName=$doctorItmData->item_name;
				}					
			?>
			  <tr style="<?=($record->cancel_flag==1)?'background-color:#fea1a1':''?>">
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->bill_no?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$record->service_amount?></td>
				<td><?=$record->discount_amount?></td>
				<td><?=$record->gross_amount?></td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}		
	}
	function doctorWiseReport()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);					
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('accounts/doctor_wise_report',$data);		
	}
	function get_item_doctor_wise_report()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));			
		$billing_type=$this->input->post('billing_type');		
		$item=$this->input->post('item');		
		$service_id=$this->input->post('service_id');		
		$doctors=$this->input->post('doctors');		
	
		if($billing_type=="opd")
			$response=$this->Accounts_fetch_model->fetch_doctor_wise_report($from_date,$to_date,$item,$service_id,$doctors,'billing');				
		if($billing_type=="ipd")
			$response=$this->Accounts_fetch_model->fetch_doctor_wise_report($from_date,$to_date,$item,$service_id,$doctors,'billing_ipd');						

		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{	
				//if consultation
				if($record->service_uid==101)//then get doctor name as item
				{
					$doctorItmData=$this->Common_fetch_model->fetch_doctor_name_by_id($record->doctor_id);
					$itmName=$doctorItmData->full_name;
				}
				else if($record->service_uid==103 || $record->service_uid==104)//then get doctor name as item
				{
					$doctorItmData=$this->Diagnostics_fetch_model->fetch_investigation_record($record->item_id);
					$itmName=$doctorItmData->test_name;
				}
				else
				{
					$doctorItmData=$this->Common_fetch_model->fetch_item_by_id($record->item_id);
					$itmName=$doctorItmData->item_name;
				}					
			?>
			  <tr style="<?=($record->cancel_flag==1)?'background-color:#fea1a1':''?>">
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->bill_no?></td>
				<td><?=$itmName?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->full_name?></td>
				<td><?=$record->service_amount?></td>
				<td><?=$record->discount_amount?></td>
				<td><?=$record->gross_amount?></td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}				
	}

}

?>