<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Admin extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		//$this->load->model('billingModel/Billing_model');
		$this->load->model('adminModel/Admin_fetch_model');
		$this->load->model('adminModel/Admin_insert_model');
		$this->load->model('accountsModel/Accounts_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************billing dash board start**********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('admin/admin_dashboard',$userModuleData);
	}
		//************************opd dash board End **********
	function chargeList()
	{
		$no_of_record=100;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_charge_list']=$this->Admin_fetch_model->fetch_charge_list($no_of_record);//descending order				
		$this->load->view('admin/charge_list',$data);
	}
	function addCharges($update_charge_id='')
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$except_service_arr=[103,104];
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list($except_service_arr);//fetch except this service id	
		if($update_charge_id!='')
		{
			$edit_charge_id=base64_decode($update_charge_id);
			$data['charge_record']=$this->Admin_fetch_model->fetch_charge_record($edit_charge_id);						
		}	
			$this->load->view('admin/add_charge',$data);
	}
	public function add_charge_record()
	{	
	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('item_name', 'Item Name', 'required');
		$this->form_validation->set_rules('amount', 'Amount', 'required');
		
	    if($this->form_validation->run()!= FALSE)
        {	
		$uid=base64_decode($this->input->post('uid'));//used to edit
		$item_name=$this->input->post('item_name');
		$service_uid=$this->input->post('service_uid');
		$charge_category=$this->input->post('charge_category');
		$amount=$this->input->post('amount');
		$clinic_uid=$this->input->post('clinic_uid');
		if(!empty($this->input->post('show_app')))
			$show_app=$this->input->post('show_app');
		else
			$show_app=0;
		if(!empty($this->input->post('active_flag')))		
			$active_flag=$this->input->post('active_flag');
		else
			$active_flag=0;

		//$generic_id_arr=$this->input->post('generic_id_arr');
		//$generic_id_arr=explode(",",$generic_id_arr);		

			$insertdata=array(
						"item_name"=>$item_name,
						"service_uid"=>$service_uid,
						"charge_category"=>$charge_category,
						"amount"=>$amount,
						"clinic_uid"=>$clinic_uid,
						"show_app"=>$show_app,
						"active_flag"=>$active_flag
						);
						$last_inserted_charge_id=0;
						if($uid=="")
							$this->Common_insert_model->save_data($insertdata,'charges');
						else
							$this->Common_insert_model->update_data($insertdata,'charges','uid',$uid);

					
					$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Admin/addCharges");
		}
		else
		{
			$this->add_charge_record();
		}		
	}
	function billCancell()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_charge_list']=$this->Admin_fetch_model->fetch_charge_list($no_of_record);//descending order				
		$this->load->view('admin/bill_cancell',$data);
	}
	function doctorFees()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);	
		$data['all_departments']=$this->Common_fetch_model->fetch_department($_SESSION['clinicId']);
		$this->load->view('admin/doctor_fees',$data);
	}
	function clinicSetting()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);	
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$this->load->view('admin/clinic_setting',$data);
	}
	function update_doctor_fees()
	{
		$doctor_uid=$this->input->post('doctors');
		$department_id=$this->input->post('departmentID');
		$opcFees=$this->input->post('opcFees');
		$ipcFees=$this->input->post('ipcFees');
		$reportingFees=$this->input->post('reportingFees');
		$econsultancyFees=$this->input->post('econsultancyFees');
		$clinic_uid=$_SESSION['clinicId'];
		
		//check any doctor fess available or not
		$response=$this->Common_fetch_model->get_doctor_fees($doctor_uid);
		
		$insertdata=array(
			"doctor_uid"=>$doctor_uid,
			"department_uid"=>$department_id,
			"clinic_uid"=>$clinic_uid,
			"consultation_fees"=>$opcFees,
			"consultation_ip_fees"=>$ipcFees,
			"reporting_fees"=>$reportingFees,
			"econsultancy_fees"=>$econsultancyFees,
			"employee_uid"=>$_SESSION['loggedUserId'],
			"entry_date_time"=>date('Y-m-d H:i:s')
			);
			if(!empty($response))//update			
				$this->Admin_insert_model->update_doctor_fees($insertdata);
			else//insert
				$this->Common_insert_model->save_data($insertdata,'clinic_dept_doc_fees');
			$this->session->set_flashdata('success', 'Data Saved...');				
			redirect(base_url()."Admin/doctorFees");
		
	}
    function update_clinic()
	{
		$uid=$this->input->post('clinic_uid');
		$cin=$this->input->post('cin');
		$gst=$this->input->post('gst');
		$registration=$this->input->post('registration');
		$phone=$this->input->post('phone');
		$email=$this->input->post('email');
		$website=$this->input->post('website');
		$active_flag=$this->input->post('active_flag');
		$print_with_header_flag=$this->input->post('print_with_header_flag');
		$category=$this->input->post('category');
		
		$insertdata=array(
		    "uid"=>$uid,
			"cin"=>$cin,
			"gst"=>$gst,
			"registration"=>$registration,
			"phone"=>$phone,
			"email"=>$email,
			"website"=>$website,
			"active_flag"=>$active_flag,
			"print_with_header_flag"=>$print_with_header_flag,
			"category"=>$category
			);
						
			$this->Admin_insert_model->update_clinic($insertdata);
			$this->session->set_flashdata('success', 'Data Saved...');				
			redirect(base_url()."Admin/clinicSetting");
		
	}
	function cancelBill()
	{
		$bill_no=$this->input->post('bill_no');
		$bill_type=$this->input->post('bill_type');
		$purpose=$this->input->post('purpose');
		
		if($bill_type=="OPD" || $bill_type=="DIALYSIS")
			$table="billing";
		else if($bill_type=="IPD")
			$table="billing_ipd";		
		
		$cancel_date_new = str_replace('/', '-', $this->input->post('cancel_date'));
		$cancel_date2 = str_replace("'", '', $cancel_date_new);
		$cancel_date=date('Y-m-d',strtotime($cancel_date2));			
				
		//update cancel flag
		$data=array(
				"cancel_flag"=>1,				
				"cancel_purpose"=>$purpose,				
				"cancel_date"=>$cancel_date				
			);
		$this->Common_insert_model->update_data($data,'billing_master','uid',$bill_no);
		$data=array(
				"cancel_flag"=>1			
			);
		$this->Common_insert_model->update_data($data,$table,'billmast_uid',$bill_no);
		$data=array(
				"cancel_flag"=>1			
			);
		$this->Common_insert_model->update_data($data,'bill_receipt','billmast_uid',$bill_no);		
		$this->billCancell();
	}
	function get_cancel_bill()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from'));
		$date_from = str_replace("'", '', $date_from_new);
		$date_from=date('Y-m-d',strtotime($date_from));	

		$date_to_new = str_replace('/', '-', $this->input->post('date_to'));
		$date_to = str_replace("'", '', $date_to_new);
		$date_to=date('Y-m-d',strtotime($date_to));	

		$response=$this->Admin_fetch_model->fetch_cancel_bill($date_from,$date_to);				
		if(!empty($response))
		{
			foreach($response as $record)
			{
				?>
			  <tr>
				<td><?=date('d-m-Y',strtotime($record->cancel_date))?></td>
				<td><?=$record->bill_prefix?><?=$record->uid?></td>			
				<td><?=$record->cancel_purpose?></td>
			  </tr>			
				
				<?php
			}
		}
		
	}
	function chart()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);	
		$data['all_departments']=$this->Common_fetch_model->fetch_department($_SESSION['clinicId']);
		$this->load->view('admin/chart',$data);
	}
	function get_patient_appo_stat()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from'));
		//$date_from = str_replace("'", '', $date_from_new);
		$date_from=date('Y-m-d',strtotime($date_from_new));	

		$date_to_new = str_replace('/', '-', $this->input->post('date_to'));
		//$date_to = str_replace("'", '', $date_to_new);
		$date_to=date('Y-m-d',strtotime($date_to_new));	

		$response_new=$this->Admin_fetch_model->fetch_patient_appo_stat($date_from,$date_to,1);				
		$response_followup=$this->Admin_fetch_model->fetch_patient_appo_stat($date_from,$date_to,2);				
		echo "{";
			echo '"new_patient":"'.$response_new->no_of_record.'",';
			echo '"followup_patient":"'.$response_followup->no_of_record.'"';
		echo "}";
		
		
/*

		$date_from_new = str_replace('/', '-', $this->input->post('date_from'));
		//$date_from = str_replace("'", '', $date_from_new);
		$date_from=date('Y-m-d',strtotime($date_from_new));	

		$date_to_new = str_replace('/', '-', $this->input->post('date_to'));
		//$date_to = str_replace("'", '', $date_to_new);
		$date_to=date('Y-m-d',strtotime($date_to_new));	

		//$response_new=$this->Admin_fetch_model->fetch_patient_appo_stat($date_from,$date_to,1);				
		//$response_followup=$this->Admin_fetch_model->fetch_patient_appo_stat($date_from,$date_to,2);				
		$response=$this->Admin_fetch_model->fetch_patient_appo_stat($date_from,$date_to);				
		foreach($response as $record)
		{
			if($record->app_type==1)
				$text="New";
			else if($record->app_type==2)
				$text="Followup";
			$data[]=array(
				'Type' => $text,
				'Value' => 1
			);
		}
		echo json_encode($data);
*/		
		
		
	}
	function get_service_wise_dsr_statistics()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('date_from') );
		$to_date_new = str_replace('/', '-', $this->input->post('date_to') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		$all_services=$this->Common_fetch_model->fetch_all_service_list_items();		
				
		//$response=$this->Accounts_fetch_model->fetch_payment_list($from_date,$to_date,$payment_mode,$employee);				

		if(!empty($all_services))
		{
			$sum=0;
			$disc_sum=0;
			foreach($all_services as $record)
			{	
				if($record->uid!=107 && $record->uid!=114)
				{
					$total_net=$this->Accounts_fetch_model->fetch_service_total_bill_net($record->uid,$from_date,$to_date,'billing');	//(service_uid,fromdate,todate)			
				}
				if($record->uid==107 || $record->uid==114)
				{
					$total_net=$this->Accounts_fetch_model->fetch_service_total_bill_net($record->uid,$from_date,$to_date,'billing_ipd');	//(service_uid,fromdate,todate)			
				}
				$total_discount=$this->Accounts_fetch_model->fetch_total_bill_discount($record->uid,$from_date,$to_date);	//(service_uid,fromdate,todate)			

				$sum+=$total_net->total_service_net;
				if(!empty($sum))
				{
					$disc_sum+=$total_discount->total_service_discount;
				}
				
				
			$data[]=array(
				'Service' => $record->misc_name,
				'Amount' => (($total_net->total_service_net)-(!empty($total_discount)?$total_discount->total_service_discount:0))
			);				
				
			}
		}
		 
		echo json_encode($data);
			
	}
	function get_monthly_patient_stat()
	{
		
		//current year
		$year=date('Y');
		$from_date=$year."-04-01";
		$to_date=($year+1)."-03-31";

		for($month=4;$month<=15;$month++)
		{	
		
			$response=$this->Admin_fetch_model->fetch_monthly_patient_stat($from_date,$to_date,$month);
			switch($month)
			{
				case 4:
					$m="Apr";
					break;
				case 5:
					$m="May";
					break;
				case 6:
					$m="Jun";
					break;
				case 7:
					$m="Jul";
					break;
				case 8:
					$m="Aug";
					break;
				case 9:
					$m="Sep";
					break;
				case 10:
					$m="Oct";
					break;
				case 11:
					$m="Nov";
					break;
				case 12:
					$m="Dec";
					break;
				case 13:
					$m="Jan";
					break;
				case 14:
					$m="Feb";
					break;
				case 15:
					$m="Mar";
					break;					
			}				
				
			$data[]=array(
				'Month' => $m,
				'Patient' => $response->no_of_record
			);				
			
		}

	 
		echo json_encode($data);		
	}
	function get_date_wise_transaction_statistics()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('date_from') );
		$to_date_new = str_replace('/', '-', $this->input->post('date_to') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Accounts_fetch_model->fetch_date_wise_total_payment($from_date,$to_date,$_SESSION['clinicId']);				

		if(!empty($response))
		{
			foreach($response as $record)
			{	
				$data[]=array(
					'Date' => date('d',strtotime($record->voucher_date))."/".date('m',strtotime($record->voucher_date)),
					'Amount' => $record->net_amount
				);
			}
		}
		 
		echo json_encode($data);		
	}

}

?>