<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Appointment extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		$this->load->model('appointmentModel/Appointment_fetch_model');
		//$this->load->model('systemModel/Systems_fetch_model');
		//$this->load->model('adminModel/Admin_fetch_model');
		//$this->load->model('pharmacyModel/Pharmacy_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************appointment dash board start**********
	public function manageAppointment()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$userModuleData['country']=$this->Common_fetch_model->fetch_country();
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department_by_clinic(101);
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('appointment/appointment_add',$userModuleData);
	}
		//************************appointment dash board End **********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$userModuleData['country']=$this->Common_fetch_model->fetch_country();
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department_by_clinic(101);
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('appointment/appointment_list',$userModuleData);
	}
	function get_data()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id);
		foreach($response as $record)
		{
		?>
		  <tr>
			<td><?=date('d-m-Y',strtotime($record->approve_date))?></td>
			<td><?=$record->doctor_id?></td>
			<td><?=$record->name?></td>
			<td><?=$record->whatsapp_num?></td>
			<td>
			<a href="javascript:void()" onclick="set_present('<?=$record->appo_uid?>')"><i class="far fa-check-circle" <?=($record->present_flag==1)?'style="color:green;font-weight:bold"':''?>></i></a>
			<a href="#"><i class="far fa-edit"></i></a> <a href="#"><i class="far fa-trash-alt"></i></a>
			</td>
		  </tr>			
		<?php
			
		}
	}
	function set_present()
	{
		$appointment_no=$this->input->post('appoint_id');
			
		$data=array(
			"present_flag"=>1
		);
		
		//update field value for repoting status updated to 'present'
		$this->Common_insert_model->update_data($data,'user_appointment','appo_uid',$appointment_no);
				
		//patient convert to master tbl
		$responseData=$this->Appointment_fetch_model->fetch_appointment_record($appointment_no);						

		if($responseData->present_flag==1 && $responseData->isset_patient_flag==0 && $responseData->patient_uid==0)
		{
			//generate patient id
			//$patient_uid=$this->Common_fetch_model->generate_patient_uid($responseData->name,$responseData->whatsapp_num);
		
				$insertdata=array(
					//"uid"=>$patient_uid,
					//"age"=>$responseData->age,
					"full_name"=>$responseData->name,
					"sex"=>$responseData->gender,
					"dob"=>$responseData->dob,
					"mobile"=>$responseData->whatsapp_num,
					"phone"=>$responseData->alternate_mobile,
					"email"=>$responseData->email,
					"city"=>$responseData->city,
					"pin"=>$responseData->pin,
					"occupation"=>$responseData->occupation,
					"referred_by"=>$responseData->referred_by,
					"country"=>$responseData->country,
					"category"=>$responseData->patient_category,
					"patient_type"=>$responseData->patient_type,
					"Month_of_registration"=>date("m"),
					"Year_of_registration"=>date("Y"),
					"employee_uid"=>$_SESSION['loggedUserId'],
					"registered_user_uid"=>$responseData->user_uid,
					"entry_date_time"=>date('Y-m-d H:m')
					);

					$patient_uid=$this->Common_insert_model->save_data($insertdata,'patient');
				
				
//----------------------temp  code------------------------------------------

				$insertdata2=array(
					"patientUid"=>$patient_uid,
					//"age"=>$responseData->age,
					"isset_patient"=>1,
					"patientName"=>$responseData->name,
					"patientSex"=>$responseData->gender,
					"patientDOB"=>$responseData->dob,
					"PatientMobile"=>$responseData->whatsapp_num,
					"patientPhone"=>$responseData->alternate_mobile,
					"patientEmail"=>$responseData->email,
					"patientCity"=>$responseData->city,
					"PatientPin"=>$responseData->pin,
					"occupation"=>$responseData->occupation,
					"referred_by"=>$responseData->referred_by,
					"patientCountry"=>$responseData->country
					//"category"=>$responseData->patient_category,
					//"patient_type"=>$responseData->patient_type,
					//"employee_uid"=>$_SESSION['loggedUserId'],
					//"registered_user_uid"=>$responseData->user_uid,
					//"entry_date_time"=>date('Y-m-d H:m')
					);
						//print_r($insertdata2);die();
					$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
								
					$insertdata3=array(
					"patient_uid"=>$patient_uid,
					"isset_patient_flag"=>1
					);				
					$this->Common_insert_model->update_data($insertdata3,'user_appointment','appo_uid',$appointment_no);
					
//----------------------temp code-------------------------------------------
				
				
				//echo $patient_uid;
				//die(0);
				//update present flag
				echo $patient_uid;
		}
		if($responseData->present_flag==1 && $responseData->patient_uid!=0 && $responseData->isset_patient_flag==0)
		{
				//fetch patient id from old patient table
				$this->load->model('billingModel/Billing_fetch_model');
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($responseData->patient_uid);
				
				if(!empty($old_patient_list))
				{
					//if age available of old patient then work with age
					if($old_patient_list->patientDOB=="" || $old_patient_list->patientDOB=="1970-01-01")
					{
						$cur_age=$old_patient_list->patientAge;
						//dob calculation from age as 1st jan of year
						$current_year=date('Y');
						$past_year=$current_year-$cur_age;
						$calculated_dob=$past_year."-01-01";				
					}
					else
					{
						$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
						$today = date("Y-m-d");
						$diff = date_diff(date_create($dateOfBirth), date_create($today));
						$cur_age=$diff->format('%y');
						
						$calculated_dob=$old_patient_list->patientDOB;
					}
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
						
					$salutation=$old_patient_list->patientSalutation;
					$patient_name=$old_patient_list->patientName;
					$gender=$old_patient_list->patientSex;		
					$dob=$calculated_dob;		
					$blood_group=$old_patient_list->patientBlood;		
					$mobile=$old_patient_list->PatientMobile;		
					$alternative_no=$old_patient_list->patientPhone;		
					$address1=$old_patient_list->patientAdd1;
					$address2=$old_patient_list->patientAdd2;
					$city=$old_patient_list->patientCity;		
					$state_code=10037;//$old_patient_list->PatientState;		
					$district=1003710;//$old_patient_list->patientDist;		
					$country_code=76;//$old_patient_list->patientCountry;		
					$pin=$old_patient_list->PatientPin;	
					$patient_type=$old_patient_list->patientName;	
					$email_id=$old_patient_list->patientEmail;
					$ps=$old_patient_list->patientPs;
					
					$guardian_name=$old_patient_list->patientGurdian;
					$relation_guardian=$old_patient_list->patientRelation;
					$aadhaar=$old_patient_list->patientAadhaar;
					$passport=$old_patient_list->patientPassport;
					$visa=$old_patient_list->patientVisa;
					$race=$old_patient_list->patientRace;
					$occupation=$old_patient_list->occupation;
					$photo_url=$old_patient_list->photo_url;
					$fcm_reg=$old_patient_list->fcm_reg;
					$religion=$old_patient_list->patientReligion;
					
					$data=array(
						"old_puid"=>$responseData->patient_uid,
						
						"salutation"=>$salutation,
						"full_name"=>$patient_name,
						"sex"=>$gender,
						"dob"=>$dob,
						"blood_group"=>$blood_group,
						"mobile"=>$mobile,
						"phone"=>$alternative_no,
						"address1"=>$address1,
						"address2"=>$address2,
						"city"=>$city,
						"state_code"=>$state_code,
						"district"=>$district,
						"country"=>$country_code,
						"pin"=>$pin,
						"email"=>$email_id,
						"police_station"=>$ps,
						"Month_of_registration"=>date("m"),
						"Year_of_registration"=>date("Y"),
						"employee_uid"=>$_SESSION['loggedUserId'],
						"entry_date_time"=>date('Y-m-d H:i:s'),

						"referred_by"=>$responseData->referred_by,
						"category"=>$responseData->patient_category,
						"patient_type"=>$responseData->patient_type,						
						
						"guardian_name"=>$guardian_name,				
						"relation_guardian"=>$relation_guardian,				
						"aadhaar"=>$aadhaar,				
						"passport"=>$passport,				
						"visa"=>$visa,				
						"race"=>$race,				
						"occupation"=>$responseData->occupation,//$occupation,				
						"photo_url"=>$photo_url,				
						"religion"=>$religion,				
						"fcm_reg"=>$fcm_reg
					
					);
					$patient_uid_new=$this->Common_insert_model->save_data($data,'patient');
				}
				else				
				{

					$insertdata=array(
						"old_puid"=>$responseData->patient_uid,
						//"age"=>$responseData->age,
						"full_name"=>$responseData->name,
						"sex"=>$responseData->gender,
						"dob"=>$responseData->dob,
						"mobile"=>$responseData->whatsapp_num,
						"phone"=>$responseData->alternate_mobile,
						"email"=>$responseData->email,
						"city"=>$responseData->city,
						"pin"=>$responseData->pin,
						"occupation"=>$responseData->occupation,
						"referred_by"=>$responseData->referred_by,
						"country"=>$responseData->country,
						"category"=>$responseData->patient_category,
						"patient_type"=>$responseData->patient_type,
						"employee_uid"=>$_SESSION['loggedUserId'],
						"registered_user_uid"=>$responseData->user_uid,
						"Month_of_registration"=>date("m"),
						"Year_of_registration"=>substr($responseData->patient_uid,0,4),
						"entry_date_time"=>date('Y-m-d H:m')
						);
						$patient_uid_new=$this->Common_insert_model->save_data($insertdata,'patient');
						

				}
				
				$insertdata_old=array(
				"patient_uid_new"=>$patient_uid_new,
				"isset_patient"=>1,
				"occupation"=>$responseData->occupation,
				"referred_by"=>$responseData->referred_by					
				);				
				$this->Common_insert_model->update_data_prevDb($insertdata_old,'patient_mast','patientUid',$responseData->patient_uid);
				
				$insertdata2=array(
					"patient_uid"=>$patient_uid_new,
					"isset_patient_flag"=>1
					);				
					$this->Common_insert_model->update_data($insertdata2,'user_appointment','appo_uid',$appointment_no);
								
				echo $patient_uid_new;
		}
		
		
		//$patient_uid=$this->convert_to_patient($appointment_no);
		
		//patient visit info saved into visit_register
		   //$data=$this->Appointment_fetch_model->insert_visit_no_in_visit_register($patient_uid);
		//	echo $patient_uid;
		//return $patient_uid;
		
		
		
	}//end of function
	function convert_to_patient($appointment_no)
	{
		//$appo_no=base64_decode($this->input->post('appo_no'));
		//$pid=base64_decode($this->input->post('pid'));
		//$pflag=base64_decode($this->input->post('pflag'));
		

		//new generated patient id	
	}
	
	function approve()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department();
		$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('appointment/approve_data',$userModuleData);		
	}
	function get_data_for_patient_approve()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		
		$search_date_new = str_replace('/', '-', $this->input->post('search_date') );
		$search_date=date('Y-m-d',strtotime($search_date_new));
		
		$response=$this->Appointment_fetch_model->fetch_get_data_for_patient_approve($clinic_id,$search_date,$doctor_id);
		foreach($response as $record)
		{
			if($record->app_mode==1)
				{
					$appMode="Clinic";
				}	
				if($record->app_mode==2)
				{
					$appMode="Online";
				}	
			if($record->approve_date!="" && (date('Y-m-d',strtotime($record->approve_date))<date('Y-m-d')) )
			{
			?>
			  <tr style="background:#e5d7d1">
				<td><input type="checkbox" name="pids_to_approve[]" value="<?=$record->appo_uid?>" disabled></td>
				<td><?=date('d-m-Y',strtotime($record->approve_date))?></td>
				<?php
				//get doctor name
				$doctor=$this->Common_fetch_model->fetch_doctor_name_by_id($record->doctor_id);
				
				?>
				<td><?=$doctor->full_name?></td>
				<td><?=$record->name?></td>
				<td><?=$record->whatsapp_num?></td>
				<td><?=$appMode?></td>
				<td>
					<input type="date" id="approve_date" name="approve_date[]" value="<?=($record->approve_date!="")?date('Y-m-d',strtotime($record->approve_date)):''?>" disabled>
				</td>
				<td>
					<input type="time" id="approve_time" name="approve_time[]" placeholder="HH:MM AM/PM" value="<?=($record->approve_time!="")?$record->approve_time:''?>" disabled>
				</td>
			  </tr>				
			<?php				
			}
			else
			{
		?>
		  <tr <?=($record->approve_date!="")?'style="background:#cfface"':''?>>
			<td><input type="checkbox" name="pids_to_approve[]" value="<?=$record->appo_uid?>" <?=($record->approve_date!="")?'checked':''?> <?=($record->approve_date!="")?'style="pointer-events: none;"':''?>></td>
			<td><?=date('d-m-Y',strtotime($record->approve_date))?></td>
			<?php
			//get doctor name
			$doctor=$this->Common_fetch_model->fetch_doctor_name_by_id($record->doctor_id);
			?>
			<td><?=$doctor->full_name?></td>
			<td><?=$record->name?></td>
			<td><?=$record->whatsapp_num?></td>
			<td><?=$appMode?></td>
			<td>
				<input type="date" id="approve_date" name="approve_date[]" value="<?=($record->approve_date!="")?date('Y-m-d',strtotime($record->approve_date)):''?>">
			</td>
			<td>
				<input type="time" id="approve_time" name="approve_time[]" placeholder="HH:MM AM/PM" value="<?=($record->approve_time!="")?$record->approve_time:''?>">
			</td>
		  </tr>			
		<?php
			}
			
		}
	}
	function approved_date_assign()
	{
		$pids_to_approve=$this->input->post('pids_to_approve');
		$temp_approve_date=$this->input->post('approve_date');		
		$approve_date=array_filter($temp_approve_date, 'strlen');
		
		$temp_approve_time=$this->input->post('approve_time');
		$approve_time=array_filter($temp_approve_time, 'strlen');//remove empty array element
		
		$data = array();
		if(count($pids_to_approve)==count($approve_date) && count($pids_to_approve)==count($approve_time))
		{
			if(count($pids_to_approve)>0)
			{
				for($i=0;$i<count($pids_to_approve);$i++)
				{
					$data[] = array(
					"appo_uid"=>$pids_to_approve[$i],
					'approve_date' => $approve_date[$i],
					'approve_time' => $approve_time[$i]
					);	
				}
				$this->Common_insert_model->update_batch_data($data,'user_appointment','appo_uid');
				$this->session->set_flashdata('success', 'Data Saved...');				
				redirect(base_url()."Appointment/approve");			
			}
			else
			{
				redirect(base_url()."Appointment/approve");
			}
		}
		else
		{
			$this->session->set_flashdata('error', 'Tables value mismatched.Try Again.');
			redirect(base_url()."Appointment/approve");
		}
	}
	
	function save_appointment()
	{
		$appo_mode=$this->input->post('appo_mode');
		$appo_clinic=$this->input->post('appo_clinic');
		$appo_department_id=$this->input->post('appo_departmentsID');
		$appo_doctor_id=$this->input->post('appo_doctorsID');
		$visit_type=$this->input->post('visit_type');
		$isset_patient_flag=$this->input->post('isset_patient_flag');

		$date_new = str_replace('/', '-', $this->input->post('prefered_date') );
		$prefered_date=date('Y-m-d',strtotime($date_new));		
		$prefered_time=date('H:i:s',strtotime($this->input->post('prefered_time')));
		
		$pid=$this->input->post('pid');
		$pname=$this->input->post('pname');
		
		//if pid is not available then generate new patient id
		//if($pid=="")
		//{
		//	$pid=date('Y').date('m').date('d').date('s').rand(1001,9999);
		//}
		
		$age=$this->input->post('age');
		$ageflag=$this->input->post('ageflag');
				
		if($ageflag==1)
		{
			$current_year=date('Y');
			$past_year=$current_year-$age;
			$dob=$past_year."-01-01";
		}
		if($ageflag==2)
		{
			$dob_new = str_replace('/', '-', $this->input->post('dob') );
			$dob=date("Y-m-d",strtotime($dob_new));
				
		}		
		$gender=$this->input->post('gender');
		$mobile=$this->input->post('mobile');
		$alter_mobile=$this->input->post('alter_mobile');
		$email_id=$this->input->post('email_id');
		$city=$this->input->post('city');
		$pin=$this->input->post('pin');
		$country_code=$this->input->post('country_code');
		$patient_category=$this->input->post('patient_category');
		$patient_type=$this->input->post('patient_type');
		$occupation=$this->input->post('occupation');
		$referred_by=$this->input->post('referred_by');
		$insertdata=array(
			"name"=>$pname,
			"gender"=>$gender,
			"request_date"=>$prefered_date,
			"request_time"=>$prefered_time,
			"approve_date"=>$prefered_date, // for nephrocare
			"approve_time"=>$prefered_time, // for nephrocare
			"clinic_id"=>$appo_clinic,
			"doctor_id"=>$appo_doctor_id,
			"app_type"=>$visit_type,
			"patient_category"=>$patient_category,
			"patient_type"=>$patient_type,
			"whatsapp_num"=>$mobile,
			"alternate_mobile"=>$alter_mobile,
			"email"=>$email_id,
			"dob"=>$dob,
			"city"=>$city,
			"pin"=>$pin,
			"occupation"=>$occupation,
			"referred_by"=>$referred_by,
			"country"=>$country_code,
			"isset_patient_flag"=>$isset_patient_flag,
			"app_mode"=>$appo_mode
			);
		//for followup patient
		if($visit_type==2)
		{
			$insertdata['patient_uid']=$pid;
		}
		

		$this->Common_insert_model->save_data($insertdata,'user_appointment');
		
//--------------------temp code, in future it will be deleted---------------------------------------
		//if($visit_type==1)//if new patient



//--------------------temp code---------------------------------------
		
		
		redirect(base_url()."Appointment/manageAppointment?stat=105");		
	}
	function get_patient_details()
	{
		$pid=$this->input->post('pid');
		//chech new software database
		$responseData=$this->Common_fetch_model->get_patient_basic_details($pid);								
		
		if(empty($responseData))//if not record found
		{
			//search previous db
			$prevResponseData=$this->Appointment_fetch_model->fetch_patient_record_from_prevdb($pid);								
			if(!empty($prevResponseData))
			{
				/*$dateOfBirth = date('Y-m-d',strtotime($prevResponseData->patientDOB));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');*/
				
				if($prevResponseData->patientDOB=="" || $prevResponseData->patientDOB=="1970-01-01")
				{
					$cur_age=$prevResponseData->patientAge;
					//dob calculation from age as 1st jan of year
					$current_year=date('Y');
					$past_year=$current_year-$cur_age;
					$calculated_dob=$past_year."-01-01";				
				}
				else
				{
					$dateOfBirth = date('Y-m-d',strtotime($prevResponseData->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$calculated_dob=$prevResponseData->patientDOB;
				}				
							
				
				echo "{";
				echo '"mobile":"'.$prevResponseData->PatientMobile.'",';
				echo '"patient_name":"'.$prevResponseData->patientName.'",';
				echo '"age":"'.$cur_age.'",';
				echo '"dob":"'.$calculated_dob.'",';
				echo '"gender":"'.$prevResponseData->patientSex.'",';
				echo '"alternative_no":"'.$prevResponseData->patientPhone.'",';
				echo '"email_id":"'.$prevResponseData->patientEmail.'",';
				echo '"address1":"'.$prevResponseData->patientAdd1.'",';
				echo '"address2":"'.$prevResponseData->patientAdd2.'",';
				echo '"blood_group":"'.$prevResponseData->patientBlood.'",';
				echo '"ps":"'.$prevResponseData->patientPs.'",';
				echo '"district":"'.$prevResponseData->patientDist.'",';
				echo '"state":"'.$prevResponseData->PatientState.'",';				
				echo '"pin":"'.$prevResponseData->PatientPin.'",';
				echo '"city":"'.$prevResponseData->patientCity.'",';
				echo '"occupation":"'.$prevResponseData->occupation.'",';
				echo '"referred_by":"'.$prevResponseData->referred_by.'",';
				echo '"country":"'.$prevResponseData->patientCountry.'"';
				echo "}";				
			}
			else
			{
				
			}
		}
		else
		{//if data available in new database

				$dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');				
				echo "{";
				echo '"mobile":"'.$responseData->mobile.'",';
				echo '"patient_name":"'.$responseData->full_name.'",';
				echo '"age":"'.$cur_age.'",';
				echo '"dob":"'.$responseData->dob.'",';
				echo '"gender":"'.$responseData->sex.'",';
				echo '"blood_group":"'.$responseData->blood_group.'",';
				echo '"address1":"'.$responseData->address1.'",';
				echo '"address2":"'.$responseData->address2.'",';
				echo '"ps":"'.$responseData->police_station.'",';
				echo '"district":"'.$responseData->district.'",';
				echo '"state":"'.$responseData->state_code.'",';
				echo '"alternative_no":"'.$responseData->phone.'",';
				echo '"email_id":"'.$responseData->email.'",';
				echo '"pin":"'.$responseData->pin.'",';
				echo '"city":"'.$responseData->city.'",';
				echo '"occupation":"'.$responseData->occupation.'",';
				echo '"referred_by":"'.$responseData->referred_by.'",';
				echo '"country":"'.$responseData->country.'"';
				echo "}";			
		}
		
	}


	function get_detail_appointment_data()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		$appointment_mode=$this->input->post('appointment_mode');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id,0,$appointment_mode);
		$sl=0;
		if(!empty($response))
		{
			foreach($response as $record)
			{
			switch($record->patient_type)
			{
				case 1:
				$pat_type="Normal";
				break;
				case 2:
				$pat_type="Dialysis";
				break;
				case 3:
				$pat_type="KT Wt";
				break;
				case 4:
				$pat_type="Post KT";
				break;
				default:
				$pat_type="Others";
				break;
			}
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->patient_uid ?> </br> <?=$record->name ?></td>
				
				<td><?=$record->whatsapp_num?><br/><?=$record->email?> </td>
				<td><?=date('d-m-Y',strtotime($record->approve_date))?><br/>
					<?=date('h:i:s A',strtotime($record->approve_time))?>
				</td>
				<td><?=$record->city?></td>
				<td><?=(($record->app_type==1)?"New":(($record->app_type==2)?"Follow up":""))?></br><?=(($record->app_mode==1)?"Offline":(($record->app_mode==2)?"Online":""))?></td>
				<td><?=($record->patient_category==1)?"General":(($record->patient_category==2)?"VIP":"referral")?> </br> <?=$pat_type?></td>
				<td><?=$record->referred_by?></td>
				<td><?=$record->clinic_name?></td>
				<?php
				//check patient has done billing or not
				$responseAppoInBill=$this->Appointment_fetch_model->check_for_appointmentId_in_billing($record->appo_uid);				
				if(empty($responseAppoInBill))
				{
				?>
				<td><?=$record->call_status?>
				<br/>
				<a href="javascript:void(0)"  data-toggle="tooltip" data-placement="top" title="<?=($record->note!="")?$record->note:'N/F'?>" ><i class="fa fa-commenting"></i></a>
				<i class="fa fa-volume-control-phone" title="Confirmed"></i>			
				</td>
				<?php
				}
				else
				{
					?>
					<td><?php echo "Billing Done";?>
					<a href="javascript:void(0)"  data-toggle="tooltip" data-placement="top" title="<?=($record->note!="")?$record->note:'N/F'?>" ><i class="fa fa-commenting"></i></a>
					<br/>
					<i class="fa fa-volume-control-phone" title="Confirmed"></i>
					<i class="fa fa-long-arrow-right" title="Confirmed"></i>
					<i class="fa fa-file-pdf-o" title="Billing Done"></i>					
					</td>
					<?php
				}
				?>

				<td>
				<!--<a href="javascript:void()" onclick="set_present('<?=$record->appo_uid?>')"><i class="far fa-check-circle" <?=($record->present_flag==1)?'style="color:green;font-weight:bold"':''?>></i></a>-->
				<a href="javascript:void(0)" onclick="change_call_status(<?=$record->appo_uid?>)"><i class="fa fa-volume-control-phone" aria-hidden="true" title="Update Call status"></i></a>
				<a href="javascript:void(0)" onclick="change_dialysis_date(<?=$record->appo_uid?>)"><i class="far fa-edit"></i></a> <a href="#"><i class="far fa-trash-alt"></i></a>
				</td>
			  </tr>			
			<?php
				
			}
		}
	}
	function save_date_time_changes()	
	{
		$new_time=date('H:i:s',strtotime($this->input->post('new_time')));
		$new_date_new = str_replace('/', '-', $this->input->post('new_date') );
		$new_date=date('Y-m-d',strtotime($new_date_new));	

		$pt_name=$this->input->post('pt_name');
		$pt_gender=$this->input->post('pt_gender');
		$pt_mobile=$this->input->post('pt_mobile');
		
		$dob_new = str_replace('/', '-', $this->input->post('dob') );
		$dob=date('Y-m-d',strtotime($dob_new));
												
		
		$pt_alternative_mobile=$this->input->post('pt_alternative_mobile');							
		$pt_email=$this->input->post('pt_email');							
		$pt_city=$this->input->post('pt_city');							
		$pt_pin=$this->input->post('pt_pin');							
		$pt_category=$this->input->post('pt_category');							
		$pt_type=$this->input->post('pt_type');							
		$pt_occupation=$this->input->post('pt_occupation');							
		$pt_referred_by=$this->input->post('pt_referred_by');		
		
		$request_appointment_id=$this->input->post('request_appointment_id');
		$data=array(
		"approve_time"=>$new_time,
		"approve_date"=>$new_date,

		"whatsapp_num"=>$pt_mobile,
		"name"=>$pt_name,
		"dob"=>$dob,
		"gender"=>$pt_gender,
		"alternate_mobile"=>$pt_alternative_mobile,
		"email"=>$pt_email,
		"pin"=>$pt_pin,
		"city"=>$pt_city,
		"patient_category"=>$pt_category,
		"patient_type"=>$pt_type,
		"occupation"=>$pt_occupation,
		"referred_by"=>$pt_referred_by		
		);			
		$this->Common_insert_model->update_data($data,'user_appointment','appo_uid',$request_appointment_id);
				
	}
	function save_call_status_changes()	
	{
		$request_appointment_id=$this->input->post('request_appointment_id');
		$call_status=$this->input->post('call_status');
		$note=$this->input->post('note');
		
		$data=array(
		"call_status"=>$call_status,		
		"note"=>$note		
		);				
		$this->Common_insert_model->update_data($data,'user_appointment','appo_uid',$request_appointment_id);
				
	}
	function get_appointment_details()
	{
		$request_appointment_id=$this->input->post('request_appointment_id');
		$responseData=$this->Appointment_fetch_model->fetch_appointment_record($request_appointment_id);						
		
		if(!empty($responseData))
		{
			$dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
			$today = date("Y-m-d");
			$diff = date_diff(date_create($dateOfBirth), date_create($today));
			$cur_age=$diff->format('%y');		
			echo "{";
			echo '"approve_date":"'.date('d-m-Y',strtotime($responseData->approve_date)).'",';
			echo '"approve_time":"'.date('H:i:s',strtotime($responseData->approve_time)).'",';
			echo '"mobile":"'.$responseData->whatsapp_num.'",';
			echo '"patient_name":"'.$responseData->name.'",';
			echo '"age":"'.$cur_age.'",';
			echo '"dob":"'.$responseData->dob.'",';
			echo '"gender":"'.$responseData->gender.'",';
			echo '"alternative_mobile":"'.$responseData->alternate_mobile.'",';
			echo '"email_id":"'.$responseData->email.'",';
			echo '"pin":"'.$responseData->pin.'",';
			echo '"city":"'.$responseData->city.'",';
			echo '"patient_category":"'.$responseData->patient_category.'",';
			echo '"patient_type":"'.$responseData->patient_type.'",';
			echo '"occupation":"'.$responseData->occupation.'",';
			echo '"referred_by":"'.$responseData->referred_by.'"';
			echo "}";
		}
	}
	public function calender()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('appointment/calender',$userModuleData);
	}	
}

?>