<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Billing extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		//$this->load->model('billingModel/Billing_model');
		$this->load->model('billingModel/Billing_fetch_model');
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************billing dash board start**********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('billing/billing_dashboard',$userModuleData);
	}
		//************************opd dash board End **********
	function opdBilling()
	{
		
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		//$data['all_departments']=$this->Common_fetch_model->fetch_department_by_clinic($_SESSION['clinicId']);
		$data['all_departments']=$this->Common_fetch_model->fetch_department($_SESSION['clinicId']);
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['all_admin_items']=$this->Common_fetch_model->fetch_all_admin_items_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['package_name']=$this->Common_fetch_model->fetch_all_package_name_list();		
		$data['service_charge_name']=$this->Common_fetch_model->fetch_all_service_charge_items_list();		
		$data['employee_level_discount']=$this->Common_fetch_model->fetch_employee_level_discount($_SESSION['loggedUserId']);		
		$data['admin_employee']=$this->Common_fetch_model->fetch_all_employee_name_has_discount_permission(3);//$type=pass any type if req.		
		$this->load->view('billing/billing_opd',$data);
	}
    
	
	 
	function billList()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);	
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list();				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();				
		$data['all_staff']=$this->Common_fetch_model->fetch_all_employee_name(3);//staff type				
		$this->load->view('billing/bill_list',$data);
	}
	
	//remove this comment when bellow same function will be removed
/*	function get_patient_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');

		$patient_list=$this->Common_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);	

		if($param_flag==2)//for search by name or/And mobile
		{
			foreach($patient_list as $record)
			{
				//$curryear=date('Y-m-d');
				//$curryear=date_create_from_format('Y-m-d');
				if(($record->dob!=""))
				{
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($record->dob));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
				}
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($record->sex);
				?>
				  <tr>
					<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->uid?>,'<?=$record->full_name?>','<?=$sexage?>',<?=$record->mobile?>)"><?=$record->uid?></a></td>
					<td><?=$record->full_name?></td>
					<td><?=$record->mobile?></td>
				  </tr>			
			<?php
			}
		}
		if($param_flag==1)//for search by patient id only
		{
			$dateOfBirth = date('Y-m-d',strtotime($patient_list[0]->dob));
			$today = date("Y-m-d");
			$diff = date_diff(date_create($dateOfBirth), date_create($today));
			$cur_age=$diff->format('%y');
			
			$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list[0]->sex);
			
			echo "{";
			echo '"uid":"'.$patient_list[0]->uid.'",';
			echo '"full_name":"'.$patient_list[0]->full_name.'",';
			echo '"agesex":"'.$sexage.'",';
			echo '"mobile":"'.$patient_list[0]->mobile.'"';
			echo "}";
		}
	}*/
//------------------temp code-----------------------------------------//	
	function get_patient_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');
		
		///$patient_list=$this->Common_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);	
		
		if($param_flag==2)//for search by name or/And mobile
		{		
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record_from_prevdb($patient_name,$mobile);
			if(!empty($patient_list))
			{
				foreach($patient_list as $record)
				{
					//$curryear=date('Y-m-d');
					//$curryear=date_create_from_format('Y-m-d');
					if(($record->patientDOB!=""))
					{
					  //current age calculate
					  $dateOfBirth = date('Y-m-d',strtotime($record->patientDOB));
					  $today = date("Y-m-d");
					  $diff = date_diff(date_create($dateOfBirth), date_create($today));
					  $cur_age=$diff->format('%y');
					  $sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($record->patientSex);
					}
					else
					{
						$sexage="0 Yrs/".$this->Common_fetch_model->fetch_sex_txt($record->patientSex);
					}
					
					
					
					?>
					  <tr>
					  <?php
						if($record->patient_uid_new>0)
						{	
						?>
						<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->patient_uid_new;?>,'<?=$record->patientName?>','<?=$sexage?>',<?=$record->PatientMobile?>,<?=$record->isset_patient ?>)"><?=$record->patient_uid_new?></a></td>
						<td><?=$record->patientUid?></td>
						<?php
						}
						if($record->patient_uid_new==0)
						{
						?>
						<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->patientUid;?>,'<?=$record->patientName?>','<?=$sexage?>',<?=$record->PatientMobile?>,<?=$record->isset_patient ?>)"><?=$record->patientUid?></a></td>
						<td><?=$record->patient_uid_new?></td>
						<?php
						}
						?>
						
						<td><?=$record->patientName?></td>
						<td><?=$record->PatientMobile?></td>
					  </tr>			
				<?php
				}
			}
			
		}
		if($param_flag==1)//for search by patient id only
		{
			//check first our new database for data
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record($patient_id);		
			if(!empty($patient_list))
			{
			
				$dateOfBirth = date('Y-m-d',strtotime($patient_list->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list->sex);
				
				echo "{";
				echo '"uid":"'.$patient_list->uid.'",';
				echo '"full_name":"'.$patient_list->full_name.'",';
				echo '"agesex":"'.$sexage.'",';
				echo '"mobile":"'.$patient_list->mobile.'"';
				echo "}";
			}
			else
			{//if data found on new db then search old database
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_id);			
				if(!empty($old_patient_list))
				{
					$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
					echo "{";
					echo '"uid":"'.$old_patient_list->patientUid.'",';
					echo '"full_name":"'.$old_patient_list->patientName.'",';
					echo '"agesex":"'.$sexage.'",';
					echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
					echo "}";
				}
			}
		}
	}
//------------------temp code-----------------------------------------//	
	function save_bill()
	{
		$service_array=$this->input->post('service_array');
		$pid=$this->input->post('pid');
		$appoint_id=$this->input->post('appoint_id');
		$total_amount=$this->input->post('total_amount');
		$special_discount_amount=$this->input->post('discount_amount');
		$advance_amount=$this->input->post('advance_amount');
		$payble_amount=$this->input->post('payble_amount');
		$treating_doctor=$this->input->post('consulting_doctor');
		$agent=$this->input->post('agent_code');
		$special_discount_reason=$this->input->post('special_discount_reason');
		$special_discount_approved_by=$this->input->post('special_discount_approved_by');

		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('pid', 'Patient ID', 'required|numeric');
		$this->form_validation->set_rules('payble_amount', 'Service Added', 'required');
	    if($this->form_validation->run()!= FALSE)
        {

		
			$payment_data_array=$this->input->post('payment_data_arr');
			
			
		//------------------temp code-----------------------//
		//check patient already exist in new db or not
		//$response=$this->Billing_fetch_model->fetch_patient_reg_record($pid);
		//print_r($response);die();
	/*	if(empty($response))
		{
		    //is our new patient table has no patient record then insert it
		    	
		    	//fetch patient details from old datapase
		    	$response_data=$this->Billing_fetch_model->patient_details_fetch($pid,0);
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($response_data[0]->patientDOB));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
		    	
				$new_insertdata=array(
						"uid"=>$response_data[0]->patientUid,
						"salutation"=>$response_data[0]->patientSalutation,
						"full_name"=>$response_data[0]->patientName,
						"sex"=>$response_data[0]->patientSex,
						//"age"=>$cur_age,
						"dob"=>$response_data[0]->patientDOB,
						"mobile"=>$response_data[0]->PatientMobile,
						"email"=>$response_data[0]->patientEmail,
						"phone"=>$response_data[0]->patientPhone,
						"address1"=>$response_data[0]->patientAdd1,
						"address2"=>$response_data[0]->patientAdd2,
						"pin"=>$response_data[0]->PatientPin
						);
					//save data
					$this->Common_insert_model->save_data($new_insertdata,'patient');
		    
		}		
	*/	
		
		//------------------temp code-----------------------//			
			
			

			$pay_net=0;
			for($r=0;$r<count($payment_data_array);$r++)
			{
				$payment_arr_record=explode(",",base64_decode($payment_data_array[$r]));
				$pay_net+=$payment_arr_record[3];
			}
			if($payble_amount!=$pay_net || empty($service_array))//if payable amount not equal to paid amount then redirect the page
			{
				redirect(base_url()."Billing/opdBilling?stat=PAYERR");
			}
			else
			{
		
							
						
						$patient_details=$this->Common_fetch_model->get_patient_basic_details($pid);
						$patient_mobile=$patient_details->mobile;
						$patient_full_name=$patient_details->full_name;		
						//$bill_no=$this->generate_bill_no($patient_mobile,$patient_full_name);
						
						//save into billing master
							$data3=array(
								"bill_prefix"=>"NCSLKOP/",
								"patient_uid"=>$pid,
								"appointmentBooking_uid"=>$appoint_id,
								"clinic_uid"=>$_SESSION['clinicId'],
								"treating_doctor"=>$treating_doctor,
								"bill_section"=>1,//opd
								"employee_uid"=>$_SESSION['loggedUserId'],
								"gross_amount"=>$total_amount,
								"discount_amount"=>$special_discount_amount,
								"net_amount"=>$payble_amount,
								"discount_reason"=>$special_discount_reason,
								"discount_approved_by"=>$special_discount_approved_by,
								"entry_date_time"=>date('Y-m-d H:m:s'),
								"bill_date"=>date('Y-m-d')
							);

							//insert record to billing table
							$billmast_uid=$this->Common_insert_model->save_data($data3,'billing_master');
							$billno="NCSLKOP/".$billmast_uid;			
						
						//billing table insert start
						//count no of record in service array
						$service_array_len=count($service_array);
						$service_arr_net_amount=0;
						$inv_counter=0;
						for($i=0;$i<$service_array_len;$i++)
						{
							$serv_arr_record=explode(",",$service_array[$i]);

							$service_date_new = str_replace('/', '-', $serv_arr_record[6]);
							$service_date_temp = str_replace("'", '', $service_date_new);
							$service_date=date('Y-m-d',strtotime($service_date_temp));
							
							if($serv_arr_record[0]==103 || $serv_arr_record[0]==104)
								$agent_id=$agent;
							else
								$agent_id=-1;							
							
							if($serv_arr_record[1]==-1)
								$doc=0;
							else
								$doc=$serv_arr_record[2];
							
							$data=array(
								"billmast_uid"=>$billmast_uid,
								"bill_no"=>$billno,
								"department_id"=>$serv_arr_record[1],
								"doctor_id"=>$doc,
								"service_uid"=>$serv_arr_record[0],
								"patient_uid"=>$pid,
								"clinic_uid"=>$_SESSION['clinicId'],
								"agent_uid"=>$agent_id,
								"employee_uid"=>$_SESSION['loggedUserId'],
								"service_amount"=>$serv_arr_record[3],
								"discount_amount"=>$serv_arr_record[4],
								"gross_amount"=>$serv_arr_record[5],
								"discount_reason"=>$serv_arr_record[7],
								"discount_approved_by"=>$serv_arr_record[8],
								"date_of_service"=>$service_date,
								"bill_date"=>date('Y-m-d')
							);
							
							$data += ["item_id" => $serv_arr_record[9]];	
							
							//no of investigation count in a bill 
							if($serv_arr_record[0]==103 || $serv_arr_record[0]==104)//lab
								$inv_counter++;
							
							//insert record to billing table
							$this->Common_insert_model->save_data($data,'billing');
							$service_arr_net_amount+=$serv_arr_record[5];
						}
						
						
						//generate lab no			
						

						if($inv_counter>0)//if investigation available in a bill then generate lab no
						{
									
							$yr=date('y');
							$dt=date('d');
							$mt=date('m');
							$dtchkformat=$dt.$mt.$yr;
							$response=$this->Common_fetch_model->autoID_flag_check($dtchkformat);
							if(empty($response))
							{
									//if($response->issetFlag==0)
									//{	
										$labformat="1".$yr.$mt.$dt."0001";
										//setting autoincrement id for lab no
										$this->Common_insert_model->alterTableForAutoIncrement('bill_lab',$labformat);//table name,autoincrement value to be set
										$data=array(
											"issetFlag"=>1,
											"autoid_condition"=>$dtchkformat
										);					
										$this->Common_insert_model->save_data($data,'auto_id_set');//,'autoid_condition',$dtchkformat);
									//}	

							}//if(empty($response))
									
							$labData=array(
								"bill_no"=>$billno,
								"billmast_uid"=>$billmast_uid
							);
							$this->Common_insert_model->save_data($labData,'bill_lab');					
					
						}

								
						//count no of record in payment_data_arr
						$payment_array_len=count($payment_data_array);
						$payment_arr_net_amount=0;		
						for($j=0;$j<$payment_array_len;$j++)
						{
							$payment_arr_record=explode(",",base64_decode($payment_data_array[$j]));
							

							$instrument_date_new = str_replace('/', '-', $payment_arr_record[1]);
							$instrument_date_temp = str_replace("'", '', $instrument_date_new);
							$instrument_date=date('Y-m-d',strtotime($instrument_date_temp));			
							
							$pdata=array(
									"receipt_prefix"=>"NCSLKOPR/",
									"billmast_uid"=>$billmast_uid,
									"bill_no"=>$billno,
									"payment_mode"=>$payment_arr_record[0],
									//"discount_type"=>$payment_arr_record[3],
									//"discount"=>$payment_arr_record[3],
									"net_amount"=>$payment_arr_record[3],
									"card_instrument_no"=>$payment_arr_record[2],
									//"instrument_bank"=>$instrument_bank,
									"instrument_date"=>$instrument_date,
									"voucher_date"=>date('Y-m-d'),
									"voucher_time"=>date('H:i:s'),
									"patient_uid"=>$pid,
									"employee_uid"=>$_SESSION['loggedUserId'],
									"entry_date_time"=>date('Y-m-d H:i:s')					
								);			

							$this->Common_insert_model->save_data($pdata,'bill_receipt');
							$payment_arr_net_amount+=$payment_arr_record[3];

						}
						
						
						//update payment flag
						$pflagData=array(
								"payment_flag"=>1				
							);
						$this->Common_insert_model->update_data($pflagData,'billing','billmast_uid',$billmast_uid);

						//set temp session to print bill
						$this->session->set_flashdata('temp_print_bill_no', $billmast_uid);
								
						redirect(base_url()."Billing/opdBilling");
			}
		
		}//end validation
		else
		{
			$this->opdBilling();
		}

	}
/* 	function generate_bill_no($mobile,$str) 
	{ 
		NCSLKOP/1000001
		$mobilesum = 0; 
		$sumletter = 0; 
		for ($i = 0; $i < (strlen($mobile)); $i++)
		{ 
		  //  echo $num[$i];
			$mobilesum += ($mobile[$i]); 
		} 

		$a = 31; 
		$n = strlen($str); 
		for ($i = 0; $i < $n; $i++)  
		{ 
		 //  print((ord($str[$i])&($a))." "); 
		$sumletter=$sumletter+(ord($str[$i])&($a));
		} 
		$bill_no=$mobilesum.$sumletter.time();
		return $bill_no;

	} */
	function get_appo_data()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		if($this->input->post('dialysis_patient'))
			$dialysis_patient=$this->input->post('dialysis_patient');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		if($this->input->post('dialysis_patient'))//if dialysis patient
			$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id,$dialysis_patient);
		else
			$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id);
		$sl=0;
		foreach($response as $record)
		{
				$dateOfBirth = date('Y-m-d',strtotime($record->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
			
		?>
		  <tr>
			<td><?=++$sl?></td>
			<td><?=$record->name?></td>
			<td><?=$cur_age?></td>			
			<td><?=$record->whatsapp_num?></td>
			<td>
			<a href="javascript:void()" onclick="<?=($record->present_flag==1)?'select_appo_patient('.$record->patient_uid.');set_appo_id_to_store('.$record->appo_uid.')':'set_present('.$record->appo_uid.')'?>" data-dismiss="modal"><i class="fa fa-check-square" aria-hidden="true" title="Select Patient"></i></a>
			
			</td>
		  </tr>			
		<?php
			
		}
	} 	
	function printBill($bill)
	{
		
		$bill_no=$bill;
/*		
		//check for lab no existance in table lab sequence
		$lab_records=$this->Billing_fetch_model->get_lab_records($bill_no);
		if($lab_records==true)
		{
			$data['lab_no_data']=array("lab_no"=>$lab_records->lab_no);
		}*/

		//get patient personal details and invoice no and invoice date
		$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);

		//get patient personal details and invoice no and invoice date
		$data['patient_personal_invoice_record']=$this->Billing_fetch_model->fetch_patient_invoice_details($bill_no);
		$data['bill_master_record']=$this->Billing_fetch_model->fetch_bill_master_details($bill_no);
		$data['bill_lab_record'] =(object) array('lab_uid' => "NA");
		//get service id by bill no
		$service_id=$this->Billing_fetch_model->fetch_service_id_by_bill_no($bill_no);
		//print_r($service_id);die();
		//$selected_service_id=$service_id->service_uid;
		//$patient_services=[];
		$data['service_given']=$this->Billing_fetch_model->fetch_service_id_by_bill_no($bill_no);		
		//$i=0;
		foreach($service_id as $row)
		{	//echo $row->service_uid;	
			//get patient service details
			//$data['patient_service_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,$selected_service_id);
			//print_r($this->Billing_fetch_model->fetch_patient_service_details($bill_no,$row->service_uid));
			//$patient_services[]=($this->Billing_fetch_model->fetch_patient_service_details($bill_no,$row->service_uid));
			//print_r($patient_services);
		//}
			switch($row->service_uid)
			{
				case 101: // Consultation
					$data['consultation_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,101);
					break;
				case 102: // Administrative
					$data['administrative_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,102);
					break;
				case 103: // Diagnostics LAB
					$data['investigation_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,103);
					$data['bill_lab_record']=$this->Billing_fetch_model->fetch_bill_lab_details($bill_no);
					break;
				case 104: // Diagnostics NON LAB
					$data['investigationNL_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,104);
					$data['bill_lab_record']=$this->Billing_fetch_model->fetch_bill_lab_details($bill_no);
					break;
				case 105: // Dialysis
					$data['dialysis_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,105);
					break;		
				case 106: // Procedure
					$data['procedure_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,106);
					break;
				case 107: // OT
					$data['ot_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,107);
					break;
				case 108: // Hospital services
					$data['hospital_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,108);
					break;
				case 109: // BED
					$data['BED_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,109);
					break;
				case 110: // 
					$data['servicecharge_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,110);
					break;
				case 111: // Pharmacy
					$data['pharmacy_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,111);
					break;
				case 112: // Consumable
					$data['consumable_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,112);
					break;
				case 113: // Miscellaneous
					$data['miscellaneous_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,113);
					break;
				case 114: // Packages
					$data['packages_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,114);
					break;
				case 115: // Instrument
					$data['instrument_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,115);
					break;	
				default:					
					break;
			}
				
		}
		//$data['patient_service_details']=$patient_services;
		//get patient payment details
		$data['patient_payment_details']=$this->Billing_fetch_model->fetch_patient_payment_details($bill_no);
		$data['patient_billing_master_details']=$this->Billing_fetch_model->fetch_patient_billing_master_details($bill_no);

		$this->load->view('billing/print_bill',$data);


	}
	function new_patient_short_registration()
	{
		$patient_name=$this->input->post('patient_name');
		$gender=$this->input->post('gender');		
		$age=$this->input->post('age');		
		$blood_group=$this->input->post('blood_group');		
		$mobile=$this->input->post('mobile');		
		$alternative_no=$this->input->post('alternative_no');		
		$address=$this->input->post('address');		
		$city=$this->input->post('city');		
		$state_code=$this->input->post('state_code');		
		$district=$this->input->post('district');		
		$country_code=$this->input->post('country_code');		
		$pin=$this->input->post('pin');	
		$patient_type=$this->input->post('patient_type');	
		$email_id=$this->input->post('email_id');
		$ps=$this->input->post('ps');
		$anniversary=$this->input->post('anniversary');
		$occupation=$this->input->post('occupation');
		$patient_category=$this->input->post('patient_category');
		
		//dob calculation from age as 1st jan of year
		$current_year=date('Y');
		$past_year=$current_year-$age;
		$dob=$past_year."-01-01";		
		
		//generate patient random id
		//$pid=date('Y').date('m').date('d').date('s').rand(1001,9999);
		//Now patient id is autoincremented
		$data=array(
				//"uid"=>$pid,
				"full_name"=>$patient_name,
				"sex"=>$gender,
				"dob"=>$dob,
				"blood_group"=>$blood_group,
				"mobile"=>$mobile,
				"phone"=>$alternative_no,
				"address1"=>$address,
				"city"=>$city,
				"state_code"=>$state_code,
				"district"=>$district,
				"country"=>$country_code,
				"patient_type"=>$patient_type,
				"category"=>$patient_category,
				"pin"=>$pin,
				"email"=>$email_id,
				"police_station"=>$ps,
				"anniversary"=>$anniversary,
				"occupation"=>$occupation,
				"Month_of_registration"=>date("m"),
				"Year_of_registration"=>date("Y"),
				"employee_uid"=>$_SESSION['loggedUserId'],
				"entry_date_time"=>date('Y-m-d H:i:s')					
			);
		$patient_uid=$this->Common_insert_model->save_data($data,'patient');
//---------------------temp code-----------------------------------------//
		$insertdata2=array(
					"patientUid"=>$patient_uid,
					//"age"=>$responseData->age,
					"isset_patient"=>1,
					"patientName"=>$patient_name,
					"patientSex"=>$gender,
					"patientBlood"=>$blood_group,
					"patientDOB"=>$dob,
					"PatientMobile"=>$mobile,
					"patientPhone"=>$alternative_no,
					"patientEmail"=>$email_id,
					"patientCity"=>$city,
					"PatientPin"=>$pin,
					"PatientState"=>$state_code,
					"patientDist"=>$district,					
					"patientCountry"=>$country_code
					);
						//print_r($insertdata2);die();
					$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
								


//---------------------temp code-----------------------------------------//		
	
		if($this->input->post('redirect_url'))
		{			
			$redirect_url=$this->input->post('redirect_url');
			redirect(base_url().$redirect_url."?stat=105");
		}
		else
			redirect(base_url()."Billing/opdBilling?stat=105");
	}
	//---------------------temp code-----------------------------------------//	
	function save_patient_from_old_new()
	{
		$pat_uid=$this->input->post('patient_id');
		$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($pat_uid);			
		if(!empty($old_patient_list))
		{
			//if age available of old patient then work with age
			if($old_patient_list->patientDOB=="" || $old_patient_list->patientDOB=="1970-01-01")
			{
				$cur_age=$old_patient_list->patientAge;
				//dob calculation from age as 1st jan of year
				$current_year=date('Y');
				$past_year=$current_year-$cur_age;
				$calculated_dob=$past_year."-01-01";				
			}
			else
			{
				$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$calculated_dob=$old_patient_list->patientDOB;
			}
			$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
			
				
			$salutation=$old_patient_list->patientSalutation;
			$patient_name=$old_patient_list->patientName;
			$gender=$old_patient_list->patientSex;		
			$dob=$calculated_dob;		
			$blood_group=$old_patient_list->patientBlood;		
			$mobile=$old_patient_list->PatientMobile;		
			$alternative_no=$old_patient_list->patientPhone;		
			$address1=$old_patient_list->patientAdd1;
			$address2=$old_patient_list->patientAdd2;
			$city=$old_patient_list->patientCity;		
			$state_code=10037;//$old_patient_list->PatientState;		
			$district=1003710;//$old_patient_list->patientDist;		
			$country_code=76;//$old_patient_list->patientCountry;		
			$pin=$old_patient_list->PatientPin;	
			$patient_type=$old_patient_list->patientName;	
			$email_id=$old_patient_list->patientEmail;
			$ps=$old_patient_list->patientPs;
			
			$guardian_name=$old_patient_list->patientGurdian;
			$relation_guardian=$old_patient_list->patientRelation;
			$aadhaar=$old_patient_list->patientAadhaar;
			$passport=$old_patient_list->patientPassport;
			$visa=$old_patient_list->patientVisa;
			$race=$old_patient_list->patientRace;
			$occupation=$old_patient_list->occupation;
			$photo_url=$old_patient_list->photo_url;
			$fcm_reg=$old_patient_list->fcm_reg;
			
			$data=array(
				"old_puid"=>$pat_uid,
				"salutation"=>$salutation,
				"full_name"=>$patient_name,
				"sex"=>$gender,
				"dob"=>$dob,
				"blood_group"=>$blood_group,
				"mobile"=>$mobile,
				"phone"=>$alternative_no,
				"address1"=>$address1,
				"address2"=>$address2,
				"city"=>$city,
				"state_code"=>$state_code,
				"district"=>$district,
				"country"=>$country_code,
				"pin"=>$pin,
				"email"=>$email_id,
				"police_station"=>$ps,
				"Month_of_registration"=>date("m"),
				"Year_of_registration"=>date("Y"),
				"employee_uid"=>$_SESSION['loggedUserId'],
				"entry_date_time"=>date('Y-m-d H:i:s'),

				"guardian_name"=>$guardian_name,				
				"relation_guardian"=>$relation_guardian,				
				"aadhaar"=>$aadhaar,				
				"passport"=>$passport,				
				"visa"=>$visa,				
				"race"=>$race,				
				"occupation"=>$occupation,				
				"photo_url"=>$photo_url,				
				"fcm_reg"=>$fcm_reg
			
			);
			$patient_uid=$this->Common_insert_model->save_data($data,'patient');
			$insertdata3=array(
					"patient_uid_new"=>$patient_uid,
					"isset_patient"=>1
					);				
					$this->Common_insert_model->update_data_prevDb($insertdata3,'patient_mast','patientUid',$pat_uid);
			
			echo "{";
			echo '"uid":"'.$patient_uid.'",';
			echo '"full_name":"'.$old_patient_list->patientName.'",';
			echo '"agesex":"'.$sexage.'",';
			echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
			echo "}";
		
		}	
	}
	function fetch_item_by_id()
	{
		$admin_item_id=$this->input->post('admin_item_id');
		$response=$this->Billing_fetch_model->fetch_item_by_id($admin_item_id);		
		echo $response->amount;
	}
	function get_opd_bill_list()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));		
		
		$services=$this->input->post('services');		
		$payment_mode=$this->input->post('payment_mode');		
		$employee=$this->input->post('employee');		
		$response=$this->Billing_fetch_model->fetch_opd_bill_list($from_date,$to_date,$services,$payment_mode,$employee);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{		
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->bill_no?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->patient_name?></td>
				<td><?=$record->gross_amount?></td>
				<td><?=($record->gross_amount)-($record->net_amount)?></td>
				<td><?=$record->net_amount?></td>
				<td>
				<a href="<?=base_url()?>Billing/printBill/<?=$record->uid?>" target="blank" title="Reprint">
					<i class="fa fa-print" aria-hidden="true"></i>
				</a>
				
				</td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function get_add_services_items()
	{
		$services=$this->input->post('services');				
		$search_item=$this->input->post('search_item');
		if($services==101)
		{
			$response=$this->Common_fetch_model->fetch_doctor_by_name($search_item);
			foreach($response as $record)
			{
				//get doctor fees
				$feesresponse=$this->Common_fetch_model->get_doctor_fees($record->uid);
				echo '<li onclick="set_item('.$record->uid.",'".$record->full_name.'\','.$feesresponse->consultation_ip_fees.')" style="cursor:pointer">'.$record->full_name.'</li>';
			}
		}
		else if($services==103 || $services==104)
		{
			$response=$this->Common_fetch_model->fetch_investigation_by_name($search_item,$services);
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->test_name.'\','.$record->fees.')" style="cursor:pointer">'.$record->test_name.'</li>';			
		}
		else if($services==111)//pharma
		{
			$response=$this->Common_fetch_model->fetch_medicine_list_by_name($search_item);
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->medicine_name.'\',0)" style="cursor:pointer">'.$record->medicine_name.'</li>';			
		}
		else if($services==105 || $services==106 || $services==114 || $services==107 || $services==108 || $services==109 || $services==112 || $services==113 || $services==115)//procedure
		{
			$response=$this->Common_fetch_model->fetch_charge_list_by_name_and_service($search_item,$services);			
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->item_name.'\','.$record->amount.')" style="cursor:pointer">'.$record->item_name.'</li>';			
		}
		//print_r($response);die();		
	}
	function get_bill_record()
	{
		$bill_no=$this->input->post('bill_no');		
		$response=$this->Billing_fetch_model->fetch_bill_master_details($bill_no);				
		if(!empty($response))
		{
			if($response->bill_section==1)
				$bill_type_txt="OPD";
			else if($response->bill_section==2)
				$bill_type_txt="IPD";
			else if($response->bill_section==3)
				$bill_type_txt="Dialysis";
			else
			{}
			echo "{";
			echo '"bill_date":"'.date('d-m-Y',strtotime($response->bill_date)).'",';
			echo '"generated_by":"'.$response->full_name.'",';
			echo '"puid":"'.$response->patient_uid.'",';
			echo '"pname":"'.$response->patient_full_name.'",';
			echo '"bill_type":"'.$bill_type_txt.'",';
			echo '"bill_amount":"'.$response->gross_amount.'",';
			echo '"bill_discount":"'.$response->discount_amount.'",';
			echo '"bill_net":"'.$response->net_amount.'",';
			echo '"cancel_flag":"'.$response->cancel_flag.'"';
			echo "}";
		}			
	}
}

?>