<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Common extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		//if(!isset($_SESSION['loggedUserId']))
		//	redirect(base_url());		

		$this->load->model('doctorModel/Doctor_fetch_model');
		//$this->load->model('systemModel/Systems_fetch_model');
		//$this->load->model('adminModel/Admin_fetch_model');
		$this->load->model('billingModel/Billing_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************medicine start**********
	function medicine_list()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_medicine_list']=$this->Common_fetch_model->fetch_medicine_list($no_of_record);//descending order				
		$this->load->view('common/medicine_list',$data);
	}
	function add_medicine($update_medicine_id='')
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//medicine form fetch
		$data['medicine_form']=$this->Common_fetch_model->fetch_medicine_form();						
		
		//if medicine need to be update
		if($update_medicine_id!='')
		{
			$edit_medicine_id=base64_decode($update_medicine_id);
			//fetch medicine details
			$data['medicine_record']=$this->Common_fetch_model->fetch_medicine_record($edit_medicine_id);						
			//fetch medicine generic details
			$data['medicine_generic_details']=$this->Common_fetch_model->fetch_medicine_generic_record($edit_medicine_id);						

		}
		
		$this->load->view('common/add_medicine',$data);
	}

	public function add_medicine_record()
	{	
	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('medicine_name', 'Medicine Name', 'required');
		$this->form_validation->set_rules('company', 'Company', 'required');
		$this->form_validation->set_rules('strength', 'Strength', 'required');
		$this->form_validation->set_rules('price', 'Price', 'required|numeric');
	    if($this->form_validation->run()!= FALSE)
        {	
		$medicine_uid=base64_decode($this->input->post('medicine_enc_id'));//used to edit
		
		$medicine_name=$this->input->post('medicine_name');
		$medicine_madeby=$this->input->post('company');
		$medicine_strength=$this->input->post('strength');
		$medicine_form=$this->input->post('medicine_form');
		$medicine_schedule=$this->input->post('schedule');
		$medicine_adult_dose=$this->input->post('adult_dose');
		$medicine_child_dose=$this->input->post('child_dose');
		$medicine_price=$this->input->post('price');
		if(!empty($this->input->post('show_pharmacy')))
			$show_pharmacy=$this->input->post('show_pharmacy');
		else
			$show_pharmacy=0;
		if(!empty($this->input->post('show_app')))
			$show_app=$this->input->post('show_app');
		else
			$show_app=0;
		if(!empty($this->input->post('active_flag')))		
			$active_flag=$this->input->post('active_flag');
		else
			$active_flag=0;

		$generic_id_arr=$this->input->post('generic_id_arr');
		$generic_id_arr=explode(",",$generic_id_arr);		

			$insertdata=array(
						"medicine_name"=>$medicine_name,
						"madeby"=>$medicine_madeby,
						"strength"=>$medicine_strength,
						"form"=>$medicine_form,
						"schedule"=>$medicine_schedule,
						"price"=>$medicine_price,
						"dosage_adult_eng"=>$medicine_adult_dose,
						"dosage_child_eng"=>$medicine_child_dose,
						"show_pharmacy"=>$show_pharmacy,
						"show_app"=>$show_app,
						"active_flag"=>$active_flag
						

						);
						$last_inserted_medicine_id=0;
						if($medicine_uid=="")
							$last_inserted_medicine_id=$this->Common_insert_model->save_data($insertdata,'medicine');
						else
							$this->Common_insert_model->update_data($insertdata,'medicine','uid',$medicine_uid);
							
					if($last_inserted_medicine_id!=0 && count($generic_id_arr)>0)
					{
						//perform medicine_generic save process
						
						$data = array();

						foreach ($generic_id_arr as $i => $name) {

							$data[] = array(
							"medicine_uid"=>$last_inserted_medicine_id,
							'generic_uid' => $generic_id_arr[$i]
							);

						};
						$this->Common_insert_model->save_batch_data($data,'medicine_generic');			
					}//end if
					else
					{
						if(count($generic_id_arr)>0)
						{
							//perform medicine_generic edit process

							//delete previous data for editing
							$this->Common_insert_model->delete_record('medicine_generic','medicine_uid',$medicine_uid);
														
							$data = array();

							foreach ($generic_id_arr as $i => $name) {

								$data[] = array(
								"medicine_uid"=>$medicine_uid,
								'generic_uid' => $generic_id_arr[$i]
								);

							};
							$this->Common_insert_model->save_batch_data($data,'medicine_generic');			
						}			
					}
					
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Common/add_medicine");
		}
		else
		{
			$this->add_medicine();
		}		
	}
	// -----------  generic Save/Edit Start      ------------------
	public function add_generic_name()
	{	
		$generic_name=$this->input->post('generic_name');
			$insertdata=array(
				"generic_name"=>$generic_name
				);

		$this->Common_insert_model->save_data($insertdata,'generic');
		
		$this->session->set_flashdata('success', 'Data Saved...');
		redirect(base_url()."Common/add_medicine");	
	}
		// -----------  Generic Save/Edit Start      ------------------
	
	function get_departmental_doctors()
	{
		$department=$this->input->post('department');
		$doctors=$this->Common_fetch_model->fetch_departmental_doctors_name($department);				
		echo '<option value="-1">--Select--</option>';
		foreach($doctors as $record)
		{
			?>
			<option value="<?=$record->uid?>"><?=$record->full_name?></option>
			<?php
		}
	}
	function fetch_doctor_fees()
	{
		$doctor_id=$this->input->post('doctor_id');
		$doctors=$this->Common_fetch_model->get_doctor_fees($doctor_id);				
		echo "{";
		echo '"consultation_fees":"'.$doctors->consultation_fees.'",';
		echo '"consultation_ip_fees":"'.$doctors->consultation_ip_fees.'",';
		echo '"e_consultation_fees":"'.$doctors->econsultancy_fees.'",';
		echo '"reporting_fees":"'.$doctors->reporting_fees.'"';		
		echo "}";
			
	}
	function fetch_generic_list()
	{
		$text=$this->input->post('text');		
		$data=$this->Common_fetch_model->fetch_generic_list($text);

			?>
			<!--<ul ><!--class="dropdown-menu total_search"-->
			<?php
		foreach($data as $record)
		{
		
			?>
			
			<li><a class="dropdown-item" href="javascript:" onclick="get_generic('<?=$record->uid?>','<?=$record->generic_name?>')"><?=$record->generic_name?></a></li>
			<?php				

		}//end of foreach
			?>		
			<!--</ul>-->
			<?php		
	}
		// -----------  Medicine Save/Edit Start      ------------------	
		//************************medicine  End **********
	function delete_list_items($record_id,$table_name,$condition_field,$redirect_url)
	{
		$data=$this->Common_insert_model->delete_record($table_name,$condition_field,base64_decode($record_id));		
		$url=base64_decode($redirect_url);
		redirect(base_url().$url);
	}
	function search_medicine()
	{
		$search_data=$this->input->post('search_data');
		$all_medicine_list=$this->Common_fetch_model->fetch_medicine_list_by_name($search_data);	
		foreach($all_medicine_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_medicine[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->medicine_name?></td>
                <td><?=$record->form?></td>
                <td><?=$record->madeby?></td>
               
                <td><a class="update-product" href="<?=base_url()?>Common/add_medicine/<?=base64_encode($record->uid)?>" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}
	function search_charge()
	{
		$search_data=$this->input->post('search_data');
		$search_on=$this->input->post('search_by');
		$all_charge_list=$this->Common_fetch_model->fetch_charge_list_by_name($search_data,$search_on);	
		foreach($all_charge_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_charge[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->item_name?></td>
                <td><?=$record->misc_name?></td>
                <td><?=$record->clinic_name?></td>
               
                <td><a class="update-product" href="<?=base_url()?>Admin/addCharges/<?=base64_encode($record->uid)?>" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}
	function delete_table_items()//bulk delete
	{
		$search_filtered_items_id=$this->input->post('search_filtered_items_id');
		$redirect_url=$this->input->post('redirect_url');
		$table_name=$this->input->post('table_name');
 		$condition_field=$this->input->post('delete_field');

		for($i=0;$i<count($search_filtered_items_id);$i++)
		{
			$data=$this->Common_insert_model->delete_record($table_name,$condition_field,base64_decode($search_filtered_items_id[$i]));				
		}
		$url=base64_decode($redirect_url);
		redirect(base_url().$url);		
	}
	function delete_data()
	{
		$row_id=base64_decode($this->input->post('rid'));
		$delete_table_name=base64_decode($this->input->post('tab'));
		$field_name=base64_decode($this->input->post('field'));
		$responseData=$this->Common_insert_model->delete_record($delete_table_name,$field_name,$row_id);//$tableName,$fieldName,$deleteID

	}
	function load_district()
	{
		$state_id=$this->input->post("state_id");
		$district=$this->Common_fetch_model->fetch_district($state_id);
		foreach($district as $key => $key_value)
		{
			?>
			<option value="<?=$key?>"><?=$key_value?></option>
			<?php			
		}		
	}
	function get_investigation_by_name()
	{
		$investigation_search_text=$this->input->post("investigation_search_text");
		$investigation_type=$this->input->post("investigation_type");
		$data=$this->Common_fetch_model->fetch_investigation_by_name($investigation_search_text,$investigation_type);		
		foreach($data as $record)
		{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="investigation_set_record('<?=base64_encode($record->uid)?>','<?=$record->test_name?>','<?=$record->fees?>')"><?=$record->test_name?></a></li>			
		<?php
			
		}//end of foreach
	
	}
	function load_departments()
	{
		$clinic_id=$this->input->post('clinic_id');
		//if($clinic_id!=0)
		//{	
			//$response=$this->Office_fetch_model->get_subjects_wt($section);
			$responseData['departments']=$this->Common_fetch_model->fetch_department_by_clinic($clinic_id);
			//print_r($response);
			echo '<select id="departmentsID" name="departmentsID" class="form-control">';
			$js = 'class="form-control"';
			echo form_dropdown('departmentsID',$responseData['departments'],'',$js);
		//}
		//else
		//{
		//	echo '<select id="'.$departmentsID.'" name="'.$departmentsID.'" class="form-control">';
		//	echo '<option value="-1">--Select--</option>';
		//	echo "</select>";
		//}	
      
		
	}
	function load_clinic()
	{
		$category_id=$this->input->post('category_id');
		if($category_id!=0)
		{	
			//$response=$this->Office_fetch_model->get_subjects_wt($section);
			$responseData['clinic']=$this->Common_fetch_model->fetch_clinic($category_id);
			//print_r($response);
			echo '<select id="clinicID" name="clinicID" class="form-control">';
			$js = 'class="form-control"';
			echo form_dropdown('clinicID',$responseData['clinic'],'',$js);
		}
		else
		{
			echo '<select id="'.$clinicID.'" name="'.$clinicID.'" class="form-control">';
			echo '<option value="0">--Select--</option>';
			echo "</select>";
		}	
      
		
	}
	
	function get_doctors()
	{
		$clinic_id=$this->input->post('clinic_id');
		$department_id=$this->input->post('department_id');
		$doctors=$this->Common_fetch_model->fetch_doctors_by_department_by_clinic($clinic_id,$department_id);//fetch only own branch				
		echo '<option value="0" selected>--Select--</option>';
		foreach($doctors as $record)
		{
			?>
			<option value="<?=$record->doctor_uid?>"><?=$record->full_name?></option>
			<?php			
		}
	}
	function get_all_doctors()
	{
		$doctors=$this->Common_fetch_model->get_all_doctors_names_notAsDropDown();//fetch only own branch				
		echo '<option value="0" selected>--Select--</option>';
		foreach($doctors as $record)
		{
			?>
			<option value="<?=$record->uid?>"><?=$record->full_name?></option>
			<?php			
		}
	}	
	function get_ward()
	{
		$building_id=$this->input->post('building_id');
		$doctors=$this->Common_fetch_model->fetch_ward_by_building($building_id);//fetch only own branch				
		echo '<option value="0" selected>--Select--</option>';
		foreach($doctors as $record)
		{
			?>
			<option value="<?=$record->ward_uid?>"><?=$record->misc_name?></option>
			<?php			
		}
	}
	function fetch_item_by_id()
	{
		$admin_item_id=$this->input->post('admin_item_id');
		$response=$this->Common_fetch_model->fetch_item_by_id($admin_item_id);		
		echo $response->amount;
	}	
	function get_patient_record()
	{
		$pid=$this->input->post('pid');
		$response=$this->Common_fetch_model->get_patient_basic_details($pid);				
		
		$dateOfBirth = date('Y-m-d',strtotime($response->dob));
		$today = date("Y-m-d");
		$diff = date_diff(date_create($dateOfBirth), date_create($today));
		$cur_age=$diff->format('%y');				
		
		echo "{";
		echo '"full_name":"'.$response->full_name.'",';		
		echo '"gender":"'.$response->sex.'",';		
		echo '"age":"'.$cur_age.'",';		
		echo '"dob":"'.$response->dob.'",';		
		echo '"mobile":"'.$response->mobile.'",';		
		echo '"alter_mobile":"'.$response->phone.'",';		
		echo '"address1":"'.$response->address1.'",';		
		echo '"address2":"'.$response->address2.'",';		
		echo '"police_station":"'.$response->police_station.'",';		
		echo '"city":"'.$response->city.'",';		
		echo '"state_code":"'.$response->state_code.'",';		
		echo '"district":"'.$response->district.'",';		
		echo '"pin":"'.$response->pin.'",';		
		echo '"country_code":"'.$response->country.'",';		
		echo '"diet":"'.$response->diet.'",';		
		echo '"blood_group":"'.$response->blood_group.'"';		
		echo "}";		
	}	
	function get_item_charge_by_id()
	{
		$item_id=$this->input->post('item_id');
		$service_uid=$this->input->post('service_uid');
		$response=$this->Common_fetch_model->fetch_item_charge_by_id($item_id,$service_uid);		
		echo "{";
		echo '"charge_amount":"'.$response->amount.'"';			
		echo "}";

	}
	function is_id_password_correct()
	{
		$user_id=$this->input->post('user_id');
		$user_password=$this->input->post('user_password');		
		$user_type=$this->input->post('user_type');		
		$response=$this->Common_fetch_model->is_id_password_correct($user_id,$user_password,$user_type);
		if($response)
		{
			echo 1;//record found
		}
		else
		{
			echo 0;//record not found
		}
		
	}
	function save_registration()
	{
		$patient_uid=$this->input->post('pid');
		$salutation=$this->input->post('salutation');
		$patient_name=$this->input->post('pname');
		$gender=$this->input->post('gender');		
		$age=$this->input->post('age');		
		$dob=$this->input->post('dob');
		$ageflag=$this->input->post('ageflag');	
		$blood_group=$this->input->post('blood_group');		
		$mobile=$this->input->post('mobile');		
		$alternative_no=$this->input->post('alter_mobile');		
		$address=$this->input->post('address1');		
		$address2=$this->input->post('address2');		
		$city=$this->input->post('city');		
		$email=$this->input->post('email_id');		
		$state_code=$this->input->post('state_code');		
		$district=$this->input->post('district');		
		$country_code=$this->input->post('country_code');		
		$pin=$this->input->post('pin');		
		$category=$this->input->post('patient_category');
	//	$patient_type=$this->input->post('type');
	//	$police_station=$this->input->post('police_station');
	//	$anniversary_new = str_replace('/', '-', $this->input->post('anniversary'));
	//	$anniversary = str_replace("'", '', $anniversary_new);
	//	$anniversary=date('Y-m-d',strtotime($anniversary));
	//	$occupation=$this->input->post('occupation');

									
	//	$referred_by=$this->input->post('referred_by');
	//	$diet=$this->input->post('diet');

		if($ageflag==1)
		{
			$current_year=date('Y');
			$past_year=$current_year-$age;
			$dob=$past_year."-01-01";
		}
		if($ageflag==2)
		{
			$dob_new = str_replace('/', '-', $this->input->post('dob') );
			$dob=date("Y-m-d",strtotime($dob_new));
				
		}		

		if($patient_uid=="")//save
		{
			$data=array(
					"salutation"=>$salutation,
					"full_name"=>$patient_name,
					"sex"=>$gender,
					"dob"=>$dob,
					"blood_group"=>$blood_group,
					"mobile"=>$mobile,
					"phone"=>$alternative_no,
					"email"=>$email,
					"address1"=>$address,
					"address2"=>$address2,
					"city"=>$city,
					"state_code"=>$state_code,
					"district"=>$district,
					"country"=>$country_code,
					"pin"=>$pin,
					"category"=>$category,
				//	"patient_type"=>$patient_type,
				//	"police_station"=>$police_station,
				//	"anniversary"=>$anniversary,
				//	"occupation"=>$occupation,
				//	"referred_by"=>$referred_by,
					//"diet"=>$diet,				
					"employee_uid"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:i:s')					
				);
				$patient_id=$this->Common_insert_model->save_data($data,'patient');

	//---------------------temp code-----------------------------------------//
/*			$insertdata2=array(
						"patientUid"=>$patient_uid,
						"isset_patient"=>1,
						"patientName"=>$patient_name,
						"patientSex"=>$gender,
						"patientBlood"=>$blood_group,
						"patientDOB"=>$dob,
						"PatientMobile"=>$mobile,
						"patientPhone"=>$alternative_no,
						"patientEmail"=>$email_id,
						"patientCity"=>$city,
						"PatientPin"=>$pin,
						"PatientState"=>$state_code,
						"patientDist"=>$district,					
						"patientCountry"=>$country_code
						);
							//print_r($insertdata2);die();
						$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
									
*/

//---------------------temp code-----------------------------------------//		
		}
		if($patient_uid!="")//edit
		{
			$data=array(
					"salutation"=>$salutation,
					"full_name"=>$patient_name,
					"sex"=>$gender,
					"dob"=>$dob,
					"blood_group"=>$blood_group,
					"mobile"=>$mobile,
					"phone"=>$alternative_no,
					"email"=>$email,
					"address1"=>$address,
					"address2"=>$address2,
					"city"=>$city,
					"state_code"=>$state_code,
					"district"=>$district,
					"country"=>$country_code,
					"pin"=>$pin,
					"category"=>$category,
					//"patient_type"=>$patient_type,
					//"police_station"=>$police_station,
					//"anniversary"=>$anniversary,
					//"occupation"=>$occupation,
					//"referred_by"=>$referred_by,
					//"diet"=>$diet,					
					"employee_uid"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:i:s')					
				);
				if($patient_uid!=0)//update against new pid
					$this->Common_insert_model->update_data($data,'patient','uid',$patient_uid);
		}		
		if($this->input->post('redirect_url'))
		{			
			$redirect_url=$this->input->post('redirect_url');
			redirect(base_url().$redirect_url."?stat=105");
		}
		else
			redirect(base_url()."Billing/opdBilling?stat=105");		
		
	}
	function get_new_pid_from_oldTable()
	{
		$new_patient_id=$this->input->post('new_patient_id');		
		$response_pidData=$this->Common_fetch_model->fetch_patient_oldPid_record_from_prevdb($new_patient_id);
		$old_patient_id=$response_pidData->patientUid;
		echo $old_patient_id;		
	}
	function check_mobile_exist()
	{
		$mobile_no=$this->input->post('mobile_no');
		$responseData=$this->Common_fetch_model->check_mobile_exist($mobile_no);
		if(!empty($responseData))
		{
			if($responseData->PatientMobile!="" || $responseData[0]->PatientMobile!=0)
				echo true;//mobile no exist
		}
	}
	function delete_validation()
	{
		$primary_table=$this->input->post('primary_table');
		$primary_table_delfldID=$this->input->post('primary_table_delfldID');
		$primary_table_delfldValue=base64_decode($this->input->post('primary_table_delfldValue'));
		$child_table_arr=$this->input->post('child_table_arr');
		$child_table_delfldID_arr=$this->input->post('child_table_delfldID_arr');
		$found_flag=0;
		for($i=0;$i<count($child_table_arr);$i++)
		{
			$response=$this->Common_fetch_model->select_record($child_table_arr[$i],$child_table_delfldID_arr[$i],$primary_table_delfldValue);
			//delete code-----------------------------------------//
			if(!empty($response))
			{
				if($response->no_of_record>0)
					$found_flag=1;
			}
		}
		if($found_flag==0)
		{
			//delete master table
			$this->Common_insert_model->delete_record($primary_table,$primary_table_delfldID,$primary_table_delfldValue);
			//delete complete
			echo 1;
		}
		else
		{
			//delete not possible, delete id is using as foreign key in other table
			echo 0;
		}
		
	}
}

?>