<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Diagnostics extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('diagnosticsModel/Diagnostics_fetch_model');
		$this->load->model('billingModel/Billing_fetch_model');
		$this->load->model('diagnosticsModel/Diagnostics_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************diagnostics dash board start**********
	function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('diagnostics/diagnostics_dashboard',$userModuleData);
	}
		//************************diagnostics dash board End **********
	function parameter()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['parameter_list']=$this->Diagnostics_fetch_model->fetch_parameter_list($no_of_record);//descending order		
		$this->load->view('diagnostics/parameter_data',$data);
	}
	function investigation()
	{
		$no_of_record=0;//means show all record
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['investigation_list']=$this->Diagnostics_fetch_model->fetch_all_investigation($no_of_record,'test_name','ASC');//descending order
		$this->load->view('diagnostics/investigation_data',$data);
	}
	function investigationAdd($update_investigation_id='')
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//medicine form fetch
		$data['medicine_form']=$this->Common_fetch_model->fetch_medicine_form();						
				
		//if medicine need to be update
		if($update_investigation_id!='')
		{
			$edit_investigation_id=base64_decode($update_investigation_id);
			//fetch investigation details
			$data['investigation_record']=$this->Diagnostics_fetch_model->fetch_investigation_record($edit_investigation_id);						
			//fetch investigation parameter details
			$data['investigation_parameter_details']=$this->Diagnostics_fetch_model->fetch_investigation_parameter_list($edit_investigation_id);						

		}		
		$this->load->view('diagnostics/investigation_add',$data);
	}
	function parameterAdd($update_parameter_id='')
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				

		//if parameter need to be update
		if($update_parameter_id!='')
		{
			$update_parameter_id=base64_decode($update_parameter_id);
			//fetch parameters details
			$data['parameter_record']=$this->Diagnostics_fetch_model->fetch_parameter_record($update_parameter_id);						

			//fetch parameter reference details
			$data['parameter_refrange_details']=$this->Diagnostics_fetch_model->fetch_parameter_refrange_details($update_parameter_id);						

		}	//print_r($data);die();		
		$this->load->view('diagnostics/parameter_add',$data);
	}	
	function search_investigation()
	{
		$search_data=$this->input->post('search_data');
		$all_medicine_list=$this->Diagnostics_fetch_model->fetch_investigation_by_name($search_data);	
		foreach($all_medicine_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_items_id[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->test_name?></td>
                <td><?=$record->category?></td>
				<td>&nbsp;</td>
                <td><a class="update-product" href="<?=base_url()?>Diagnostics/investigationAdd/<?=base64_encode($record->uid)?>" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}
	function fetch_parameter_list()
	{
		$text=$this->input->post('text');		
		$data=$this->Diagnostics_fetch_model->fetch_test_parameter_list($text);

			?>
			<!--<ul ><!--class="dropdown-menu total_search"-->
			<?php
		foreach($data as $record)
		{
		
			?>
			
			<li><a class="dropdown-item" href="javascript:" onclick="get_parameter('<?=$record->uid?>','<?=$record->parameter?>')"><?=$record->parameter?></a></li>
			<?php				

		}//end of foreach
			?>		
			<!--</ul>-->
			<?php		
	}
	public function add_investigation_record()
	{		   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('test', 'Test Name', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
			$test_enc_id=base64_decode($this->input->post('test_enc_id'));//used to edit		
			$test=$this->input->post('test');
			$abbreviations=$this->input->post('abbreviations');
			$group=$this->input->post('group');
			$department=$this->input->post('department');
			$specimen=$this->input->post('specimen');
			$patient_tag=$this->input->post('patient_tag');
			$item_code=$this->input->post('item_code');
			$criteria=$this->input->post('criteria');
			$limitation=$this->input->post('limitation');
			$category=$this->input->post('category');
			$duration=$this->input->post('duration');
			if(!empty($this->input->post('in_house')))
				$in_house=$this->input->post('in_house');
			else
				$in_house=0;
			if(!empty($this->input->post('show_app')))
				$show_app=$this->input->post('show_app');
			else
				$show_app=0;
			if(!empty($this->input->post('active_flag')))		
				$active_flag=$this->input->post('active_flag');
			else
				$active_flag=0;

			$parameter_id_arr=$this->input->post('parameter_id_arr');
			$parameter_id_arr=explode(",",$parameter_id_arr);		

			$insertdata=array(
						"test_name"=>$test,
						"abbr"=>$abbreviations,
						"group_name"=>$group,
						"department"=>$department,
						"specimen"=>$specimen,
						"patient_tag"=>$patient_tag,
						"ItemID"=>$item_code,
						"criteria"=>$criteria,
						"limitation"=>$limitation,
						"category"=>$category,
						"duration"=>$duration,
						"in_house"=>$in_house,
						"app_flag"=>$show_app,
						"show_chk"=>$active_flag

						);
						$last_inserted_investigation_id=0;

						if($test_enc_id=="")
							$last_inserted_investigation_id=$this->Common_insert_model->save_data($insertdata,'investigation');
						else
							$this->Common_insert_model->update_data($insertdata,'investigation','uid',$test_enc_id);

					if($last_inserted_investigation_id!=0 && count($parameter_id_arr)>0)
					{
						//perform medicine_generic save process
						
						$data = array();

						foreach ($parameter_id_arr as $i => $name) {

							$data[] = array(
							"investigation_uid"=>$last_inserted_investigation_id,
							'parameter_uid' => $parameter_id_arr[$i]
							);

						};
						$this->Common_insert_model->save_batch_data($data,'investigation_parameter');			
					}//end if
					else
					{
						if(count($parameter_id_arr)>0)
						{
							//perform investigation parameter edit process

							//delete previous data for editing
							$this->Common_insert_model->delete_record('investigation_parameter','investigation_uid',$test_enc_id);
														
							$data = array();

							foreach ($parameter_id_arr as $i => $name) {

								$data[] = array(
								"investigation_uid"=>$test_enc_id,
								'parameter_uid' => $parameter_id_arr[$i]
								);

							};
							$this->Common_insert_model->save_batch_data($data,'investigation_parameter');			
						}			
					}
					
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Diagnostics/investigationAdd");
		}
		else
		{
			$this->investigationAdd();
		}		
	}
	public function add_parameter_record()
	{		   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('parameter', 'Parameter', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
			$parameter_enc_id=base64_decode($this->input->post('enc_parameter_id'));//used to edit		
			$parameter=$this->input->post('parameter');
			$position=$this->input->post('position');
			$unit=$this->input->post('unit');
			$method=$this->input->post('method');
			$instrument=$this->input->post('instrument');
			$default_value=$this->input->post('default_value');
			$formula=$this->input->post('formula');

			if(!empty($this->input->post('show_app')))
				$show_app=$this->input->post('show_app');
			else
				$show_app=0;
			if(!empty($this->input->post('active_flag')))		
				$active_flag=$this->input->post('active_flag');
			else
				$active_flag=0;
			
			if(!empty($this->input->post('consultancy_priority_flag')))		
				$consultancy_priority_flag=$this->input->post('consultancy_priority_flag');
			else
				$consultancy_priority_flag=0;			

			$reference_position_arr=$this->input->post('reference_position_arr');
			$reference_position_arr=explode(",",$reference_position_arr);

			$reference_sex_arr=$this->input->post('reference_sex_arr');
			$reference_sex_arr=explode(",",$reference_sex_arr);

			$ref_range_arr=$this->input->post('ref_range_arr');
			$ref_range_arr=explode(",",$ref_range_arr);	//print_r($ref_range_arr);echo count($ref_range_arr);die();

			$insertdata=array(
						"parameter"=>$parameter,
						"parameter_position"=>$position,
						"parameter_value"=>$default_value,
						"parameter_unit"=>$unit,
						"parameter_method"=>$method,
						"parameter_instrument"=>$instrument,
						"parameter_formula"=>$formula,
						"app_flag"=>$show_app,
						"active_flag"=>$active_flag,
						"consultancy_priority_flag"=>$consultancy_priority_flag						

						);
						$last_inserted_parameter_id=0;

						if($parameter_enc_id=="")
							$last_inserted_parameter_id=$this->Common_insert_model->save_data($insertdata,'parameter');
						else
							$this->Common_insert_model->update_data($insertdata,'parameter','uid',$parameter_enc_id);

					if($last_inserted_parameter_id!=0 && $ref_range_arr[0]!="")
					{
						//perform medicine_generic save process
						
						$data = array();

						foreach ($ref_range_arr as $i => $name) {

							$data[] = array(
							"referance_range"=>$ref_range_arr[$i],
							"parameter_uid"=>$last_inserted_parameter_id,
							"ref_type"=>$reference_sex_arr[$i],
							'position' => $reference_position_arr[$i]
							);

						};
						$this->Common_insert_model->save_batch_data($data,'parameter_refrange');			
					}//end if
					
					else
					{
						//delete previous data for editing
						$this->Common_insert_model->delete_record('parameter_refrange','parameter_uid',$parameter_enc_id);
												
						if($ref_range_arr[0]!="")
						{
							//perform parameter edit process							
							$data = array();

							foreach ($ref_range_arr as $i => $name) {

								$data[] = array(
								"referance_range"=>$ref_range_arr[$i],
								"parameter_uid"=>$parameter_enc_id,
								"ref_type"=>$reference_sex_arr[$i],
								'position' => $reference_position_arr[$i]
								);

							};
							$this->Common_insert_model->save_batch_data($data,'parameter_refrange');			
						}			
					}
					
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Diagnostics/parameterAdd");
		}
		else
		{
			$this->investigationAdd();
		}		
	}	
	function investigationCharges()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_charge_list']=$this->Diagnostics_fetch_model->fetch_all_investigation_charges();//descending order				
		$this->load->view('diagnostics/charge_list',$data);
	}
	function get_investigation_name()
	{
		$search_data=$this->input->post('search_text');
		$response=$this->Diagnostics_fetch_model->fetch_investigation_by_name($search_data);
		foreach($response as $record)
		{
			?>
			<li onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->test_name?>')" style="cursor:pointer"><?=$record->test_name?></li>
			<?php
		}
	}
	function addInvestigationCharges()
	{
		$investigation_id=base64_decode($this->input->post('enc_investigation_id'));
		$investigation=$this->input->post('investigation');
		$investigation_charge=$this->input->post('investigation_charge');
		$update_flag=$this->input->post('update_flag');
			$insertdata=array(
						"investigation_uid"=>$investigation_id,
						"fees"=>$investigation_charge,
						"clinic_uid"=>$_SESSION['clinicId'],
						"employee_uid"=>$_SESSION['loggedUserId'],
						"entry_date_time"=>date('Y-m-d H:i:s')
						
						);
		if($update_flag=="0")
			$last_inserted_investigation_id=$this->Common_insert_model->save_data($insertdata,'investigation_rate');
		else			
			$this->Common_insert_model->update_data($insertdata,'investigation_rate','investigation_uid',$investigation_id);
		redirect(base_url()."Diagnostics/investigationCharges");
	}
	function get_investigation_charge()
	{
		$investigation_id=base64_decode($this->input->post('investigation_id'));
		$response=$this->Diagnostics_fetch_model->fetch_investigation_charge($investigation_id);
		if($response)
		{
		echo "{";
		echo '"charge":"'.$response->fees.'",';
		echo '"data_found_flag":"1"';
		echo "}";
		}		
		
	}
	function labList()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('diagnostics/lab_list',$data);		
	}
	function get_lab_list()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$response=$this->Diagnostics_fetch_model->fetch_lab_list($date_from,$date_to);
		if(!empty($response))
		{
			$sl=0;
			foreach($response as $record)
			{
			?>
			<tr>
			  <th scope="row"><?=++$sl?></th>
			  <td><?=$record->bill_no?></td>
			  <td><?=$record->lab_uid?></td>
			  <td><a href="javascript:void(0)" title="Show lab items" data-toggle="modal" data-target="#item_list_modal" onclick="show_items(<?=$record->billmast_uid?>)"><i class="fa fa-eye"></i></a></td>
			</tr>
			<?php
			}
		}		
		
	}
	function get_patients_lab_items()
	{
		$bill_mast_uid = $this->input->post('billMastId') ;
		
		$response=$this->Diagnostics_fetch_model->fetch_patients_lab_items($bill_mast_uid);
		echo '<tr colspan="4"><input type="hidden" name="bill_mast_id" value="'.$bill_mast_uid.'"></tr>';
		if(!empty($response))
		{
			$sl=0;
			foreach($response as $record)
			{
			?>
			<tr>
			  <th scope="row"><input type="checkbox" name="row_no_of_item_id_list[]" value="<?=$record->uid?>"></th>
			  <th scope="row"><?=++$sl?></th>
			  <td><?=$record->item_id?></td>
			  <td><?=$record->test_name?></td>
			</tr>
			<?php
			}
		}		
	}
	function print_requisition()
	{
		$bill_mast_uid = $this->input->post('bill_mast_id') ;
		$row_no_of_item_id_list = $this->input->post('row_no_of_item_id_list') ;
		for($i=0;$i<count($row_no_of_item_id_list);$i++)
		{
			$insertdata=array(
						"requisition_flag"=>1,
						);
			$this->Common_insert_model->update_data($insertdata,'billing','uid',$row_no_of_item_id_list[$i]);
					
		}
		$this->printBill($bill_mast_uid);
				
	}
	function printBill($bill)
	{
		
		$bill_no=$bill;
		//get patient personal details and invoice no and invoice date
		$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);

		//get patient personal details and invoice no and invoice date
		$data['patient_personal_invoice_record']=$this->Billing_fetch_model->fetch_patient_invoice_details($bill_no);
		$data['bill_master_record']=$this->Billing_fetch_model->fetch_bill_master_details($bill_no);
		$data['bill_lab_record'] =(object) array('lab_uid' => "NA");
		//get service id by bill no
		$service_id=$this->Billing_fetch_model->fetch_service_id_by_bill_no($bill_no);

		$data['service_given']=$this->Billing_fetch_model->fetch_service_id_by_bill_no($bill_no);		
		//$i=0;
		foreach($service_id as $row)
		{	
			switch($row->service_uid)
			{
/*				case 101: // Consultation
					$data['consultation_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,101);
					break;
				case 102: // Administrative
					$data['administrative_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,102);
					break;*/
				case 103: // Diagnostics LAB
					$data['investigation_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,103);
					$data['bill_lab_record']=$this->Billing_fetch_model->fetch_bill_lab_details($bill_no);
					break;
				case 104: // Diagnostics NON LAB
					$data['investigationNL_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,104);
					$data['bill_lab_record']=$this->Billing_fetch_model->fetch_bill_lab_details($bill_no);
					break;
/*				case 105: // Dialysis
					$data['dialysis_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,105);
					break;		
				case 106: // Procedure
					$data['procedure_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,106);
					break;
				case 107: // OT
					$data['ot_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,107);
					break;
				case 108: // Hospital services
					$data['hospital_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,108);
					break;
				case 109: // BED
					$data['BED_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,109);
					break;
				case 110: // 
					$data['servicecharge_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,110);
					break;
				case 111: // Pharmacy
					$data['pharmacy_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,111);
					break;
				case 112: // Consumable
					$data['consumable_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,112);
					break;
				case 113: // Miscellaneous
					$data['miscellaneous_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,113);
					break;
				case 114: // Packages
					$data['packages_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,114);
					break;
				case 115: // Instrument
					$data['instrument_details']=$this->Billing_fetch_model->fetch_patient_service_details($bill_no,115);
					break;*/	
				default:					
					break;
			}
				
		}
		//$data['patient_service_details']=$patient_services;
		//get patient payment details
		$data['patient_payment_details']=$this->Billing_fetch_model->fetch_patient_payment_details($bill_no);
		$data['patient_billing_master_details']=$this->Billing_fetch_model->fetch_patient_billing_master_details($bill_no);

		$this->load->view('diagnostics/print_requisition',$data);


	}	
	
}

?>