<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Dialysis extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		//$this->load->model('billingModel/Billing_model');
		$this->load->model('dialysisModel/Dialysis_fetch_model');
		$this->load->model('billingModel/Billing_fetch_model');
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************dialysis dash board start**********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('dialysis/dialysis_dashboard',$userModuleData);
	}
		//************************opd dash board End **********
	function item()
	{
		$no_of_record=100;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list($no_of_record);//descending order				
		$this->load->view('dialysis/item_list',$data);
	}	
	
	function dialysisBilling()
	{
		
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department_by_clinic(101);
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['all_admin_items']=$this->Common_fetch_model->fetch_all_admin_items_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['admin_employee']=$this->Common_fetch_model->fetch_all_employee_name_has_discount_permission(3);//$type=pass any type if req.		
		$data['employee_level_discount']=$this->Common_fetch_model->fetch_employee_level_discount($_SESSION['loggedUserId']);		
		$this->load->view('dialysis/dialysis_billing',$data);
	}
	function slotAllotment()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		//$data['all_departments']=$this->Common_fetch_model->fetch_department();
		//$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		//$data['all_admin_items']=$this->Common_fetch_model->fetch_all_admin_items_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['admin_employee']=$this->Common_fetch_model->fetch_all_employee_name(3);//$type=pass any type if req.		
		$this->load->view('dialysis/slot_allotment',$data);
	}
    function patientAdmission()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('billing/patient_admission',$data);
	}	
	 function ipdBilling()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('billing/billing_ipd',$data);
	}
	 function patientDischarge()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('billing/patient_discharge',$data);
	}
	function billList()
	{
		$no_of_record=10;
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);	
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list();				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();				
		$data['all_staff']=$this->Common_fetch_model->fetch_all_employee_name(3);//staff type				
		$this->load->view('dialysis/bill_list',$data);
	}
	function save_bill()
	{	
		$service_array=$this->input->post('service_array');
		$pid=$this->input->post('pid');
		$appoint_id=$this->input->post('appoint_id');
		$total_amount=$this->input->post('total_amount');
		$discount_amount=$this->input->post('discount_amount');
		$advance_amount=$this->input->post('advance_amount');
		$payble_amount=$this->input->post('payble_amount');

		$hd_date_new = str_replace('/', '-', ($this->input->post('hddate')));
		$hd_date = str_replace("'", '', $hd_date_new);		
		$hd_time=date('H:m:s',strtotime($this->input->post('hdtime')));

		$special_discount_reason=$this->input->post('special_discount_reason');
		$special_discount_approved_by=$this->input->post('special_discount_approved_by');


		$payment_data_array=$this->input->post('payment_data_arr');
		
		$pay_net=0;
		for($r=0;$r<count($payment_data_array);$r++)
		{
			$payment_arr_record=explode(",",base64_decode($payment_data_array[$r]));
			$pay_net+=$payment_arr_record[3];
		}
		if($payble_amount!=$pay_net || empty($service_array))//if payable amount not equal to paid amount then redirect the page
		{
			redirect(base_url()."Dialysis/dialysisBilling?stat=PAYERR");
		}
	
			
		
		$patient_details=$this->Common_fetch_model->get_patient_basic_details($pid);
		$patient_mobile=$patient_details->mobile;
		$patient_full_name=$patient_details->full_name;		
		//$bill_no=$this->generate_bill_no($patient_mobile,$patient_full_name);

			//save into billing master
				$data3=array(
					//"bill_no"=>$bill_no,
					"bill_prefix"=>"NCSLKDL/",
					"patient_uid"=>$pid,
					"appointmentBooking_uid"=>$appoint_id,
					"clinic_uid"=>$_SESSION['clinicId'],
					"treating_doctor"=>1004,//pratom sengupta
					"bill_section"=>3,//dialysis
					"employee_uid"=>$_SESSION['loggedUserId'],
					"gross_amount"=>$total_amount,
					"discount_amount"=>$discount_amount,
					"net_amount"=>$payble_amount,
					"discount_reason"=>$special_discount_reason,
					"hd_date"=>date('Y-m-d',strtotime($hd_date)),
					"hd_time"=>$hd_time,
					"discount_approved_by"=>$special_discount_approved_by,
					"entry_date_time"=>date('Y-m-d H:m:s'),
					"bill_date"=>date('Y-m-d')
				);

				//insert record to billing table
				$billmast_uid=$this->Common_insert_model->save_data($data3,'billing_master');
				$bill_no="NCSLKDL/".$billmast_uid;		


		//billing table insert start
		//count no of record in service array
		$service_array_len=count($service_array);
		$service_arr_net_amount=0;
		for($i=0;$i<$service_array_len;$i++)
		{
			$serv_arr_record=explode(",",$service_array[$i]);

			$service_date_new = str_replace('/', '-', $serv_arr_record[6]);
			$service_date_temp = str_replace("'", '', $service_date_new);
			$service_date=date('Y-m-d',strtotime($service_date_temp));
			
			if($serv_arr_record[1]==-1)
				$doc=0;
			else
				$doc=$serv_arr_record[2];
				
			$data=array(
				"billmast_uid"=>$billmast_uid,
				"bill_no"=>$bill_no,
				"department_id"=>$serv_arr_record[1],
				"doctor_id"=>$doc,
				"service_uid"=>$serv_arr_record[0],
				"patient_uid"=>$pid,
				"clinic_uid"=>$_SESSION['clinicId'],
				//"unit_uid"=>$unit_uid,
				"employee_uid"=>$_SESSION['loggedUserId'],
				"service_amount"=>$serv_arr_record[3],
				"discount_amount"=>$serv_arr_record[4],
				"gross_amount"=>$serv_arr_record[5],
				"discount_reason"=>$serv_arr_record[8],
				"discount_approved_by"=>$serv_arr_record[9],
				"date_of_service"=>$service_date,
				"bill_date"=>date('Y-m-d')
			);
	if($serv_arr_record[0]==102 || $serv_arr_record[0]==105  || $serv_arr_record[0]==106  || $serv_arr_record[0]==107 )
				$data += ["item_id" => $serv_arr_record[7]];
				
			//insert record to billing table
			$this->Common_insert_model->save_data($data,'billing');
			$service_arr_net_amount+=$serv_arr_record[5];
		}
		
		
		//get patient service IDs to generate lab no
		//$service_id_records=$this->Billing_fetch_model->get_service_records($_SESSION['order_no']);
				
/*		//get patient service IDs to generate lab no
		$service_id_records=$this->Billing_fetch_model->get_service_records($_SESSION['order_no']);

		if($service_id_records==true)
		{//if 103 service id records exist then generate lab no
			$data=array(
				"bill_no"=>$bill_no
			);
		//insert data
		 $lab_no=$this->Billing_insert_model->insert_data($data,'lab_sequence');			
			
		}*/		
		
				
		//count no of record in payment_data_arr
		$payment_array_len=count($payment_data_array);
		$payment_arr_net_amount=0;		
		for($j=0;$j<$payment_array_len;$j++)
		{
			$payment_arr_record=explode(",",base64_decode($payment_data_array[$j]));
			
			$payment_date_new = str_replace('/', '-', $payment_arr_record[1]);
			$payment_date_new_temp = str_replace("'", '', $payment_date_new);
			$instrument_date=date('Y-m-d',strtotime($payment_date_new_temp));
						
			$pdata=array(
					"receipt_prefix"=>"NCSLKDLR/",
					"billmast_uid"=>$billmast_uid,
					"bill_no"=>$bill_no,
					"payment_mode"=>$payment_arr_record[0],
					//"discount_type"=>$payment_arr_record[3],
					//"discount"=>$payment_arr_record[3],
					"net_amount"=>$payment_arr_record[3],
					"card_instrument_no"=>$payment_arr_record[2],
					//"instrument_bank"=>$instrument_bank,
					"instrument_date"=>$instrument_date,
					"voucher_date"=>date('Y-m-d'),
					"voucher_time"=>date('H:i:s'),
					"patient_uid"=>$pid,					
					"employee_uid"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:i:s')					
				);			

			$this->Common_insert_model->save_data($pdata,'bill_receipt');
			$payment_arr_net_amount+=$payment_arr_record[3];

		}
		//update payment flag
		$pflagData=array(
				"payment_flag"=>1				
			);
		$this->Common_insert_model->update_data($pflagData,'billing','billmast_uid',$billmast_uid);

		//set temp session to print bill
		$this->session->set_flashdata('temp_print_bill_no', $billmast_uid);
				
		redirect(base_url()."Dialysis/dialysisBilling");

	}
	function generate_bill_no($mobile,$str) 
	{ 
		$mobilesum = 0; 
		$sumletter = 0; 
		for ($i = 0; $i < (strlen($mobile)); $i++)
		{ 
		  //  echo $num[$i];
			$mobilesum += ($mobile[$i]); 
		} 

		$a = 31; 
		$n = strlen($str); 
		for ($i = 0; $i < $n; $i++)  
		{ 
		 //  print((ord($str[$i])&($a))." "); 
		$sumletter=$sumletter+(ord($str[$i])&($a));
		} 
		$bill_no=$mobilesum.$sumletter.time();
		return $bill_no;

	}
	function get_appo_data()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id);
		$sl=0;
		foreach($response as $record)
		{
		?>
		  <tr>
			<td><?=++$sl?></td>
			<td><?=$record->name?></td>
			<td><?=$record->age?></td>			
			<td><?=$record->whatsapp_num?></td>
			<td>
			<a href="javascript:void()" onclick="<?=($record->present_flag==1)?'select_appo_patient('.$record->patient_uid.')':''?>" data-dismiss="modal"><i class="fa fa-check-square" aria-hidden="true" title="Select Patient"></i></a>
			
			</td>
		  </tr>			
		<?php
			
		}
	} 	
	function printBill($bill)
	{
		$bill_no=$bill;

		//get patient personal details and invoice no and invoice date
		$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);

		//get patient personal details and invoice no and invoice date
		$data['patient_personal_invoice_record']=$this->Billing_fetch_model->fetch_patient_invoice_details($bill_no);
		$data['bill_master_record']=$this->Billing_fetch_model->fetch_bill_master_details($bill_no);
		//get service id by bill no
		$service_id=$this->Dialysis_fetch_model->fetch_service_id_by_bill_no($bill_no);
		//print_r($service_id);die();
		$data['service_given']=$this->Dialysis_fetch_model->fetch_service_id_by_bill_no($bill_no);		
		//$i=0;
		foreach($service_id as $row)
		{		

			switch($row->service_uid)
			{

				case 102: // Administrative
					$data['administrative_details']=$this->Dialysis_fetch_model->fetch_patient_service_details($bill_no,102);
					break;
				case 105: // Dialysis
					$data['dialysis_details']=$this->Dialysis_fetch_model->fetch_patient_service_details($bill_no,105);
					break;		
				case 106: // Procedure
					$data['procedure_details']=$this->Dialysis_fetch_model->fetch_patient_service_details($bill_no,106);
					break;
				case 107: // OT
					$data['ot_details']=$this->Dialysis_fetch_model->fetch_patient_service_details($bill_no,107);
					break;
	
				default:					
					break;
			}
				
		}
		//print_r($data);die();
		//$data['patient_service_details']=$patient_services;
		//get patient payment details
		$data['patient_payment_details']=$this->Billing_fetch_model->fetch_patient_payment_details($bill_no);
		$data['patient_billing_master_details']=$this->Billing_fetch_model->fetch_patient_billing_master_details($bill_no);

		$this->load->view('dialysis/print_bill',$data);


	}
	function new_patient_short_registration()
	{
		$patient_name=$this->input->post('patient_name');
		$gender=$this->input->post('gender');		
		$age=$this->input->post('age');		
		$blood_group=$this->input->post('blood_group');		
		$mobile=$this->input->post('mobile');		
		$alternative_no=$this->input->post('alternative_no');		
		$address=$this->input->post('address');		
		$city=$this->input->post('city');		
		$state_code=$this->input->post('state_code');		
		$district=$this->input->post('district');		
		$country_code=$this->input->post('country_code');		
		$pin=$this->input->post('pin');	
		
		//generate patient random id
		//$pid=date('Y').date('m').date('d').date('s').rand(1001,9999);
		$data=array(
				//"uid"=>$pid,
				"full_name"=>$patient_name,
				"sex"=>$gender,
				"age"=>$age,
				"blood_group"=>$blood_group,
				"mobile"=>$mobile,
				"phone"=>$alternative_no,
				"address1"=>$address,
				"city"=>$city,
				"state_code"=>$state_code,
				"district"=>$district,
				"country"=>$country_code,
				"pin"=>$pin,
				"employee_uid"=>$_SESSION['loggedUserId'],
				"entry_date_time"=>date('Y-m-d H:i:s')					
			);
		$patient_id=$this->Common_insert_model->save_data($data,'patient');
		redirect(base_url()."Dialysis/registration?stat=105");
	}
	function save_supplier_registration()
	{
		$data=$this->input->post();
		$patient_id=$this->Common_insert_model->save_data($data,'supplier_master');
		redirect(base_url()."Dialysis/supplierRegistration?stat=105");
	}	
	function fetch_item_by_id()
	{
		$admin_item_id=$this->input->post('admin_item_id');
		$response=$this->Billing_fetch_model->fetch_item_by_id($admin_item_id);		
		echo $response->amount;
	}
	
	
//-------------------------------------------------------------------//
	function get_dialysis_procedure_list()
	{
		$procedure_name=$this->input->post('dialysis_item_search_text');
		$this->load->model('dialysisModel/Dialysis_fetch_model');
		$responseData=$this->Common_fetch_model->fetch_charge_list_by_name($procedure_name,105);
		echo '<ul>';
		foreach($responseData as $record)
		{
			echo '<li><a class="dropdown-item" href="javascript:" onclick="dialysis_set_record('.$record->uid.',\''.$record->item_name.'\','.$record->amount.')">'.$record->item_name."  [".$record->amount."]".' </a></li>';
		}
		echo '</ul>';		
	}
	function get_items_and_charge_list()
	{
		$search_text=$this->input->post('search_text');
		$service_uid=$this->input->post('service_uid');
		$this->load->model('dialysisModel/Dialysis_fetch_model');
		$responseData=$this->Common_fetch_model->fetch_charge_list_by_name($search_text,$service_uid);
		echo '<ul>';
		foreach($responseData as $record)
		{
			echo '<li><a class="dropdown-item" href="javascript:" onclick="set_record('.$record->uid.',\''.$record->item_name.'\','.$record->amount.')">'.$record->item_name."  [".$record->amount."]".' </a></li>';
		}
		echo '</ul>';		
	}	
//-------------------------------------------------------------------//	
	function Save_allotment()
	{
		$clinic=$this->input->post('dialysis_clinic');
		$treating_doctor=$this->input->post('dialysis_doctorsID');
		$hd_date_new = str_replace('/', '-', $this->input->post('hd_date') );
		$hd_date=date('Y-m-d',strtotime($hd_date_new));		
		$hd_slot=$this->input->post('hd_slot');
		$old_tbl_data_flag=$this->input->post('old_tbl_data_flag');
		$isset_patient_flag=$this->input->post('isset_patient_flag');
		$patient_uid=$this->input->post('pid');
		if($patient_uid=="")//when new patient
		$patient_uid=0;
		$patient_name=$this->input->post('pname');
		$gender=$this->input->post('gender');		
		$age=$this->input->post('age');
		$dob=$this->input->post('dob');
		$ageflag=$this->input->post('ageflag');		
		$blood_group=$this->input->post('blood_group');		
		$mobile=$this->input->post('mobile');		
		$alternative_no=$this->input->post('alter_mobile');		
		$address1=$this->input->post('address1');		
		$address2=$this->input->post('address2');		
		$city=$this->input->post('city');		
		$state_code=$this->input->post('state_code');		
		$district=$this->input->post('district');		
		$country_code=$this->input->post('country_code');		
		$pin=$this->input->post('pin');
		$email=$this->input->post('email_id');
		$patient_category=$this->input->post('patient_category');
		
		if($ageflag==1)
		{
			$current_year=date('Y');
			$past_year=$current_year-$age;
			$dob=$past_year."-01-01";
		}
		if($ageflag==2)
		{
			$dob_new = str_replace('/', '-', $this->input->post('dob') );
			$dob=date("Y-m-d",strtotime($dob_new));
				
		}		

		$data=array(
				"clinic_uid"=>$clinic,
				"treating_doctor_uid"=>$treating_doctor,
				"service_type"=>1,//for dialysis
				"date_of_booking"=>$hd_date,
				"hd_slot"=>$hd_slot,
				"patient_uid"=>$patient_uid,
				"patient_name"=>$patient_name,
				"gender"=>$gender,
				"dob"=>$dob,
				"blood_group"=>$blood_group,
				"mobile"=>$mobile,
				"alternative_phone"=>$alternative_no,
				"email"=>$email,
				"address1"=>$address1,
				"address2"=>$address2,
				"city"=>$city,
				"state"=>$state_code,
				"district"=>$district,
				"country"=>$country_code,
				"pin"=>$pin,
				"patient_category"=>$patient_category,
				"old_tbl_data_flag"=>$old_tbl_data_flag,
				"isset_patient_flag"=>$isset_patient_flag,
				"entry_by"=>$_SESSION['loggedUserId']					
			);
		$this->Common_insert_model->save_data($data,'booking_record');
		redirect(base_url()."Dialysis/slotAllotment?stat=105");		
	}
	function get_patient_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');
		//$patient_list=$this->Dialysis_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);
		

		if($param_flag==2)//for search by name or/And mobile
		{
			$patient_list=$this->Common_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);
			foreach($patient_list as $record)
			{
				//$curryear=date('Y-m-d');
				//$curryear=date_create_from_format('Y-m-d');
				if(($record->dob!=""))
				{
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($record->dob));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
				}
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($record->sex);
				 
				?>
				  <tr>
					<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->uid?>,'<?=$record->full_name?>','<?=$sexage?>',<?=$record->mobile?>)"><?=$record->uid?></a></td>
					<td><?=$record->old_puid?></td>
					<td><?=$record->full_name?></td>
					<td><?=$record->mobile?></td>
				  </tr>			
			<?php
			}
		}
		if($param_flag==1)//for search by patient id only
		{
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record($patient_id);
			if(!empty($patient_list))
			{
				$dateOfBirth = date('Y-m-d',strtotime($patient_list->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list->sex);
				
				echo "{";
				echo '"patient_uid":"'.$patient_list->uid.'",';
				echo '"patient_name":"'.$patient_list->full_name.'",';
				echo '"agesex":"'.$sexage.'",';
				echo '"mobile":"'.$patient_list->mobile.'"';
				echo "}";
			}
			else
			{//if data found on new db then search old database
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_id);			
				if(!empty($old_patient_list))
				{
					$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
					echo "{";
					echo '"uid":"'.$old_patient_list->patientUid.'",';
					echo '"full_name":"'.$old_patient_list->patientName.'",';
					echo '"agesex":"'.$sexage.'",';
					echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
					echo "}";
				}			
			}
		}
	}
	function get_supplier_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');
		if($param_flag==2)//for search by name or/And mobile
		{
			$patient_list=$this->Common_fetch_model->fetch_supplier_using_search_filter($patient_id,$patient_name,$mobile);//print_r($patient_list);die();
			foreach($patient_list as $record)
			{

				?>
				  <tr>
					<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list2(<?=$record->uid?>,'<?=$record->supplier_name?>',<?=$record->mobile?>)"><?=$record->uid?></a></td>
					<td><?=$record->supplier_name?></td>
					<td><?=$record->mobile?></td>
				  </tr>			
			<?php
			}
		}
		if($param_flag==1)//for search by patient id only
		{
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record($patient_id);
			if(!empty($patient_list))
			{
				$dateOfBirth = date('Y-m-d',strtotime($patient_list->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list->sex);
				
				echo "{";
				echo '"patient_uid":"'.$patient_list->uid.'",';
				echo '"patient_name":"'.$patient_list->full_name.'",';
				echo '"agesex":"'.$sexage.'",';
				echo '"mobile":"'.$patient_list->mobile.'"';
				echo "}";
			}
			else
			{//if data found on new db then search old database
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_id);			
				if(!empty($old_patient_list))
				{
					$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
					echo "{";
					echo '"uid":"'.$old_patient_list->patientUid.'",';
					echo '"full_name":"'.$old_patient_list->patientName.'",';
					echo '"agesex":"'.$sexage.'",';
					echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
					echo "}";
				}			
			}
		}
	}	
	/*
//------------------temp code-----------------------------------------//	
	function get_patient_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');
		
		///$patient_list=$this->Common_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);	
		$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record_from_prevdb($patient_name,$mobile);		
		if($param_flag==2)//for search by name or/And mobile
		{
			foreach($patient_list as $record)
			{
				//$curryear=date('Y-m-d');
				//$curryear=date_create_from_format('Y-m-d');
				if(($record->patientDOB!=""))
				{
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($record->patientDOB));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
				}
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($record->patientSex);
				$old_tbl_data_flag=1;
				?>
				  <tr>
					<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->patientUid?>,'<?=$record->patientName?>','<?=$sexage?>',<?=$record->PatientMobile?>,<?=$old_tbl_data_flag?>)"><?=$record->patientUid?></a></td>
					<td><?=$record->patientName?></td>
					<td><?=$record->PatientMobile?></td>
				  </tr>			
			<?php
			}
		}
		if($param_flag==1)//for search by patient id only
		{
			//check first our new database for data
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record($patient_id);		
			if(!empty($patient_list))
			{
			
				$dateOfBirth = date('Y-m-d',strtotime($patient_list->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list->sex);
				
				echo "{";
				echo '"uid":"'.$patient_list->uid.'",';
				echo '"full_name":"'.$patient_list->full_name.'",';
				echo '"agesex":"'.$sexage.'",';
				echo '"mobile":"'.$patient_list->mobile.'"';
				echo "}";
			}
			else
			{//if data found on new db then search old database
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_id);			
				if(!empty($old_patient_list))
				{
					$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
					echo "{";
					echo '"uid":"'.$old_patient_list->patientUid.'",';
					echo '"full_name":"'.$old_patient_list->patientName.'",';
					echo '"agesex":"'.$sexage.'",';
					echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
					echo "}";
				}
			}
		}
	}*/
//------------------temp code-----------------------------------------//	
	function get_patient_name()
	{
		$pid=$this->input->post('pid');

		//chech new software database
		$responseData=$this->Common_fetch_model->get_patient_basic_details($pid);								
	
		if(empty($responseData))//if not record found
		{					
			
			//search previous db
			$this->load->model('billingModel/Billing_fetch_model');
			$prevResponseData=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($pid);

			if(!empty($prevResponseData))
			{
					//current age calculate
					/*  $dateOfBirth = date('Y-m-d',strtotime($prevResponseData->patientDOB));
					  $today = date("Y-m-d");
					  $diff = date_diff(date_create($dateOfBirth), date_create($today));
					  $cur_age=$diff->format('%y');*/

					//if age available of old patient then work with age
					if($prevResponseData->patientDOB=="" || $prevResponseData->patientDOB=="1970-01-01")
					{
						$cur_age=$prevResponseData->patientAge;
						//dob calculation from age as 1st jan of year
						$current_year=date('Y');
						$past_year=$current_year-$cur_age;
						$calculated_dob=$past_year."-01-01";				
					}
					else
					{
						$dateOfBirth = date('Y-m-d',strtotime($prevResponseData->patientDOB));
						$today = date("Y-m-d");
						$diff = date_diff(date_create($dateOfBirth), date_create($today));
						$cur_age=$diff->format('%y');
						
						$calculated_dob=$prevResponseData->patientDOB;
					}					  
					
					echo "{";
					echo '"pname":"'.$prevResponseData->patientName.'",';
					echo '"age":"'.$cur_age.'",';
					echo '"dob":"'.$calculated_dob.'",';
					echo '"gender":"'.$prevResponseData->patientSex.'",';
					echo '"mobile":"'.$prevResponseData->PatientMobile.'",';
					echo '"alter_mobile":"'.$prevResponseData->patientPhone.'",';
					echo '"email_id":"'.$prevResponseData->patientEmail.'",';
					echo '"address1":"'.$prevResponseData->patientAdd1.'",';
					echo '"address2":"'.$prevResponseData->patientAdd2.'",';
					echo '"city":"'.$prevResponseData->patientCity.'",';
					echo '"pin":"'.$prevResponseData->PatientPin.'",';
					echo '"state_code":"'.$prevResponseData->PatientState.'",';
					echo '"district":"'.$prevResponseData->patientDist.'",';
					echo '"country_code":"'.$prevResponseData->patientCountry.'",';
					echo '"blood_group":"'.$prevResponseData->patientBlood.'",';
					echo '"salutation":"'.$prevResponseData->patientSalutation.'",';
					//echo '"type":"'.$prevResponseData->patientBlood.'"';
					echo '"police_station":"'.$prevResponseData->patientPs.'",';
					//echo '"occupation":"'.$prevResponseData->occupation.',"';
					echo '"referred_by":"'.$prevResponseData->referred_by.'"';
					//echo '"diet":"'.$prevResponseData->patientBlood.'"';
					//echo '"patient_category":"'.$prevResponseData->patient_category.'",';
					echo "}";
			/*	}
				else
				{
					//if selected patient name found from new table
					$responseData=$this->Dialysis_fetch_model->fetch_booked_patient_details($pid);

					//current age calculate
					  $dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
					  $today = date("Y-m-d");
					  $diff = date_diff(date_create($dateOfBirth), date_create($today));
					  $cur_age=$diff->format('%y');		
					echo "{";
					echo '"pname":"'.$responseData->patient_name.'",';
					echo '"age":"'.$cur_age.'",';
					echo '"gender":"'.$responseData->gender.'",';
					echo '"mobile":"'.$responseData->mobile.'",';
					echo '"alter_mobile":"'.$responseData->alternative_phone.'",';
					echo '"email_id":"'.$responseData->email.'",';
					echo '"address1":"'.$responseData->address1.'",';
					echo '"address2":"'.$responseData->address2.'",';
					echo '"city":"'.$responseData->city.'",';
					echo '"pin":"'.$responseData->pin.'",';
					echo '"state_code":"'.$responseData->state.'",';
					echo '"district":"'.$responseData->district.'",';
					echo '"country_code":"'.$responseData->country.'",';
					echo '"blood_group":"'.$responseData->blood_group.'",';
					echo '"patient_category":"'.$responseData->patient_category.'",';
					echo "}";
				}*/	
			}

		
		}
		else
		{
				//current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');		
					echo "{";
					echo '"pname":"'.$responseData->full_name.'",';
					echo '"age":"'.$cur_age.'",';
					echo '"dob":"'.$responseData->dob.'",';
					echo '"gender":"'.$responseData->sex.'",';
					echo '"mobile":"'.$responseData->mobile.'",';
					echo '"alter_mobile":"'.$responseData->phone.'",';
					echo '"email_id":"'.$responseData->email.'",';
					echo '"address1":"'.$responseData->address1.'",';
					echo '"address2":"'.$responseData->address2.'",';
					echo '"city":"'.$responseData->city.'",';
					echo '"pin":"'.$responseData->pin.'",';
					echo '"state_code":"'.$responseData->state_code.'",';
					echo '"district":"'.$responseData->district.'",';
					echo '"country_code":"'.$responseData->country.'",';
					echo '"blood_group":"'.$responseData->blood_group.'",';
					echo '"patient_category":"'.$responseData->category.'",';
					echo '"salutation":"'.$responseData->salutation.'",';
					echo '"police_station":"'.$responseData->police_station.'",';
					echo '"referred_by":"'.$responseData->referred_by.'"';					
					echo "}";			
		}	
	}

	function get_patient_data_from_new_patient_table()
	{
			$pid=$this->input->post('pid');
			//if selected patient name found from new table
			$responseData=$this->Common_fetch_model->get_patient_basic_details($pid);

			//current age calculate
			  $dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
			  $today = date("Y-m-d");
			  $diff = date_diff(date_create($dateOfBirth), date_create($today));
			  $cur_age=$diff->format('%y');		
			echo "{";
			echo '"salutation":"'.$responseData->salutation.'",';
			echo '"pname":"'.$responseData->full_name.'",';
			echo '"age":"'.$cur_age.'",';
			echo '"gender":"'.$responseData->sex.'",';
			echo '"mobile":"'.$responseData->mobile.'",';
			echo '"alter_mobile":"'.$responseData->phone.'",';
			echo '"email_id":"'.$responseData->email.'",';
			echo '"address1":"'.$responseData->address1.'",';
			echo '"address2":"'.$responseData->address2.'",';
			echo '"city":"'.$responseData->city.'",';
			echo '"pin":"'.$responseData->pin.'",';
			echo '"state_code":"'.$responseData->state_code.'",';
			echo '"district":"'.$responseData->district.'",';
			echo '"country_code":"'.$responseData->country.'",';
			echo '"blood_group":"'.$responseData->blood_group.'",';
			echo '"police_station":"'.$responseData->police_station.'",';
			echo '"patient_type":"'.$responseData->patient_type.'",';
			echo '"anniversary":"'.$responseData->anniversary.'",';
			echo '"occupation":"'.$responseData->occupation.'",';
			echo '"referred_by":"'.$responseData->referred_by.'",';
			echo '"diet":"'.$responseData->diet.'",';
			echo '"patient_category":"'.$responseData->category.'"';
			echo "}";		
	}
	function get_data()
	{
		$clinic_id=$this->input->post('clinic');
		$dialysis_patient_flag=$this->input->post('dialysis_patient');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Dialysis_fetch_model->fetch_booked_patient_list($clinic_id,$from_date,$to_date);
		foreach($response as $record)
		{
		?>
		  <tr>
			<td><?=date('d-m-Y',strtotime($record->date_of_booking))?></td>
			<td><?=$record->full_name?></td>
			<td><?=$record->patient_name?></td>
			<td><?=$record->mobile?></td>
			<td><?=$record->hd_slot?></td>
			
			<?php
			if($record->present_flag==1)
			{?>
				<td>
				<a href="javascript:void()" data-dismiss="modal" onclick="select_appo_patient(<?=$record->patient_uid?>,'<?=date('d/m/Y',strtotime($record->date_of_booking))?>','<?=$record->hd_slot?>');set_appo_id_to_store('<?=$record->uid?>')"><i class="far fa-check-circle" style="color:green;font-weight: bold"></i></a>
				<a href="javascript:void(0)" onclick="change_dialysis_date('<?=$record->uid?>')"><i class="far fa-edit"></i></a>
				</td>
		
			<?php
			}
			else
			{
			?>
				<td>
				<a href="javascript:void()" onclick="set_present('<?=$record->uid?>')"><i class="far fa-check-circle"></i></a>
				<a href="javascript:void(0)" onclick="change_dialysis_date('<?=$record->uid?>')"><i class="far fa-edit"></i></a> <a href="#"><i class="far fa-trash-alt"></i></a>
				</td>
			<?php
			}
			?>
		  </tr>			
		<?php
			
		}
	}
	
	
	function set_present()
	{
		$appointment_no=$this->input->post('booking_id');
		$data=array(
			"present_flag"=>1
		);
		
		//update field value for repoting status updated to 'present'
		$this->Common_insert_model->update_data($data,'booking_record','uid',$appointment_no);
				
		//patient convert to master tbl
		$responseData=$this->Dialysis_fetch_model->fetch_booking_record($appointment_no);						
		if($responseData->present_flag==1 && $responseData->isset_patient_flag==0 && $responseData->patient_uid==0)
		{
			//generate patient id
			//$patient_uid=$this->Common_fetch_model->generate_patient_uid($responseData->name,$responseData->whatsapp_num);
		
				$insertdata=array(
					//"uid"=>$patient_uid,
					//"age"=>$responseData->age,
					"full_name"=>$responseData->patient_name,
					"sex"=>$responseData->gender,
					"dob"=>$responseData->dob,
					"mobile"=>$responseData->mobile,
					"phone"=>$responseData->alternative_phone,
					"email"=>$responseData->email,
					"city"=>$responseData->city,
					"pin"=>$responseData->pin,
					"country"=>$responseData->country,
					"category"=>$responseData->patient_category,
					"patient_type"=>2,
					"Month_of_registration"=>date("m"),
					"Year_of_registration"=>date("Y"),
					"employee_uid"=>$_SESSION['loggedUserId'],
					//"registered_user_uid"=>$responseData->user_uid,
					"entry_date_time"=>date('Y-m-d H:m')
					);

					$patient_uid=$this->Common_insert_model->save_data($insertdata,'patient');
				
				
//----------------------temp  code------------------------------------------

				$insertdata2=array(
					"patientUid"=>$patient_uid,
					//"age"=>$responseData->age,
					"isset_patient"=>1,
					"patientName"=>$responseData->patient_name,
					"patientSex"=>$responseData->gender,
					"patientDOB"=>$responseData->dob,
					"PatientMobile"=>$responseData->mobile,
					"patientPhone"=>$responseData->alternative_phone,
					"patientEmail"=>$responseData->email,
					"patientCity"=>$responseData->city,
					"PatientPin"=>$responseData->pin,
					"patientCountry"=>$responseData->country
					//"category"=>$responseData->patient_category,
					//"patient_type"=>$responseData->patient_type,
					//"employee_uid"=>$_SESSION['loggedUserId'],
					//"registered_user_uid"=>$responseData->user_uid,
					//"entry_date_time"=>date('Y-m-d H:m')
					);
						//print_r($insertdata2);die();
					$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
								
					$insertdata3=array(
					"patient_uid"=>$patient_uid,
					"isset_patient_flag"=>1
					);				
					$this->Common_insert_model->update_data($insertdata3,'booking_record','uid',$appointment_no);
					
//----------------------temp code-------------------------------------------
				
				
				//echo $patient_uid;
				//die(0);
				//update present flag
				echo $patient_uid;
		}
		if($responseData->present_flag==1 && $responseData->patient_uid!=0 && $responseData->isset_patient_flag==0)
		{
				//fetch patient id from old patient table
				$this->load->model('billingModel/Billing_fetch_model');
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($responseData->patient_uid);
				
				if(!empty($old_patient_list))
				{
					//if age available of old patient then work with age
					if($old_patient_list->patientDOB=="" || $old_patient_list->patientDOB=="1970-01-01")
					{
						$cur_age=$old_patient_list->patientAge;
						//dob calculation from age as 1st jan of year
						$current_year=date('Y');
						$past_year=$current_year-$cur_age;
						$calculated_dob=$past_year."-01-01";				
					}
					else
					{
						$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
						$today = date("Y-m-d");
						$diff = date_diff(date_create($dateOfBirth), date_create($today));
						$cur_age=$diff->format('%y');
						
						$calculated_dob=$old_patient_list->patientDOB;
					}
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
						
					$salutation=$old_patient_list->patientSalutation;
					$patient_name=$old_patient_list->patientName;
					$gender=$old_patient_list->patientSex;		
					$dob=$calculated_dob;		
					$blood_group=$old_patient_list->patientBlood;		
					$mobile=$old_patient_list->PatientMobile;		
					$alternative_no=$old_patient_list->patientPhone;		
					$address1=$old_patient_list->patientAdd1;
					$address2=$old_patient_list->patientAdd2;
					$city=$old_patient_list->patientCity;		
					$state_code=10037;//$old_patient_list->PatientState;		
					$district=1003710;//$old_patient_list->patientDist;		
					$country_code=76;//$old_patient_list->patientCountry;		
					$pin=$old_patient_list->PatientPin;	
					$patient_type=$old_patient_list->patientName;	
					$email_id=$old_patient_list->patientEmail;
					$ps=$old_patient_list->patientPs;
					
					$guardian_name=$old_patient_list->patientGurdian;
					$relation_guardian=$old_patient_list->patientRelation;
					$aadhaar=$old_patient_list->patientAadhaar;
					$passport=$old_patient_list->patientPassport;
					$visa=$old_patient_list->patientVisa;
					$race=$old_patient_list->patientRace;
					$occupation=$old_patient_list->occupation;
					$photo_url=$old_patient_list->photo_url;
					$fcm_reg=$old_patient_list->fcm_reg;
					$religion=$old_patient_list->patientReligion;
					
					$data=array(
						"old_puid"=>$responseData->patient_uid,
						
						"salutation"=>$salutation,
						"full_name"=>$patient_name,
						"sex"=>$gender,
						"dob"=>$dob,
						"blood_group"=>$blood_group,
						"mobile"=>$mobile,
						"phone"=>$alternative_no,
						"address1"=>$address1,
						"address2"=>$address2,
						"city"=>$city,
						"state_code"=>$state_code,
						"district"=>$district,
						"country"=>$country_code,
						"pin"=>$pin,
						"email"=>$email_id,
						"police_station"=>$ps,
						"Month_of_registration"=>date("m"),
						"Year_of_registration"=>date("Y"),
						"employee_uid"=>$_SESSION['loggedUserId'],
						"entry_date_time"=>date('Y-m-d H:i:s'),

						"referred_by"=>$old_patient_list->referred_by,	
						
						"guardian_name"=>$guardian_name,				
						"relation_guardian"=>$relation_guardian,				
						"aadhaar"=>$aadhaar,				
						"passport"=>$passport,				
						"visa"=>$visa,				
						"race"=>$race,				
						"occupation"=>$occupation,				
						"photo_url"=>$photo_url,				
						"religion"=>$religion,				
						"fcm_reg"=>$fcm_reg
					
					);
					$patient_uid_new=$this->Common_insert_model->save_data($data,'patient');
				}
				else				
				{				
					
			/* 		$insertdata=array(
						"old_puid"=>$responseData->patient_uid,
						//"age"=>$responseData->age,
						"full_name"=>$responseData->patient_name,
						"sex"=>$responseData->gender,
						"dob"=>$responseData->dob,
						"mobile"=>$responseData->mobile,
						"phone"=>$responseData->alternative_phone,
						"email"=>$responseData->email,
						"city"=>$responseData->city,
						"pin"=>$responseData->pin,
						"country"=>$responseData->country,
						"category"=>$responseData->patient_category,
						"patient_type"=>2,
						"employee_uid"=>$_SESSION['loggedUserId'],
						//"registered_user_uid"=>$responseData->user_uid,
						"Month_of_registration"=>date("m"),
						"Year_of_registration"=>substr($responseData->patient_uid,0,4),
						"entry_date_time"=>date('Y-m-d H:m')
						);
						$patient_uid_new=$this->Common_insert_model->save_data($insertdata,'patient');
						 */
					$insertdata=array(
						"old_puid"=>$responseData->patient_uid,
						//"age"=>$responseData->age,
						"full_name"=>$responseData->name,
						"sex"=>$responseData->gender,
						"dob"=>$responseData->dob,
						"mobile"=>$responseData->whatsapp_num,
						"phone"=>$responseData->alternate_mobile,
						"email"=>$responseData->email,
						"city"=>$responseData->city,
						"pin"=>$responseData->pin,
						"occupation"=>$responseData->occupation,
						"referred_by"=>$responseData->referred_by,
						"country"=>$responseData->country,
						"category"=>$responseData->patient_category,
						"patient_type"=>$responseData->patient_type,
						"employee_uid"=>$_SESSION['loggedUserId'],
						"registered_user_uid"=>$responseData->user_uid,
						"Month_of_registration"=>date("m"),
						"Year_of_registration"=>substr($responseData->patient_uid,0,4),
						"entry_date_time"=>date('Y-m-d H:m')
						);	
						$patient_uid_new=$this->Common_insert_model->save_data($insertdata,'patient');
				}
					
					$insertdata_old=array(
					"patient_uid_new"=>$patient_uid_new,
					"isset_patient"=>1
					//"occupation"=>$responseData->occupation,
					//"referred_by"=>$responseData->referred_by
					);				
					$this->Common_insert_model->update_data_prevDb($insertdata_old,'patient_mast','patientUid',$responseData->patient_uid);
					
					$insertdata2=array(
						"patient_uid"=>$patient_uid_new,
						"isset_patient_flag"=>1
						);				
						$this->Common_insert_model->update_data($insertdata2,'booking_record','uid',$appointment_no);
					echo $patient_uid_new;
		}
		
		
		//$patient_uid=$this->convert_to_patient($appointment_no);
		
		//patient visit info saved into visit_register
		   //$data=$this->Appointment_fetch_model->insert_visit_no_in_visit_register($patient_uid);
		//	echo $patient_uid;
		//return $patient_uid;
		
		
	}//end of function
/*	function convert_to_patient($appointment_no)
	{
		
		$responseData=$this->Dialysis_fetch_model->fetch_booking_record($appointment_no);						
		if($responseData->patient_uid==0 && $responseData->old_tbl_data_flag==0 && $responseData->present_flag==1)
		{
			
			//generate patient id
			//$patient_uid=$this->Common_fetch_model->generate_patient_uid($responseData->name,$responseData->whatsapp_num);
		
				//new patient insert with autoPID
				$insertdata=array(
					//"uid"=>$patient_uid,
					//"age"=>$responseData->age,
					"full_name"=>$responseData->patient_name,
					"sex"=>$responseData->gender,
					"dob"=>$responseData->dob,
					"mobile"=>$responseData->mobile,
					"phone"=>$responseData->alternative_phone,
					"email"=>$responseData->email,
					"address1"=>$responseData->address1,
					"address2"=>$responseData->address2,
					"city"=>$responseData->city,
					"district"=>$responseData->district,
					"state_code"=>$responseData->state,
					"pin"=>$responseData->pin,
					"country"=>$responseData->country,
					"category"=>$responseData->patient_category,
					"patient_type"=>2,//dialysis patient
					"blood_group"=>$responseData->blood_group,
					"employee_uid"=>$_SESSION['loggedUserId'],
					//"registered_user_uid"=>$responseData->user_uid,
					"entry_date_time"=>date('Y-m-d H:m')
					);

				$patient_uid=$this->Common_insert_model->save_data($insertdata,'patient');
				//update patient id in booking record table
				$insertdata=array(
					"patient_uid"=>$patient_uid
					);				
				$this->Common_insert_model->update_data($insertdata,'booking_record','uid',$appointment_no);
				//new generated patient id				
				
//----------------------temp  code------------------------------------------

				$insertdata2=array(
					"patientUid"=>$patient_uid,
					//"age"=>$responseData->age,
					"patientName"=>$responseData->patient_name,
					"patientSex"=>$responseData->gender,
					"patientDOB"=>$responseData->dob,
					"PatientMobile"=>$responseData->mobile,
					"patientPhone"=>$responseData->alternative_phone,
					"patientEmail"=>$responseData->email,
					"patientCity"=>$responseData->city,
					"PatientPin"=>$responseData->pin,
					"patientCountry"=>$responseData->country
					//"category"=>$responseData->patient_category,
					//"patient_type"=>$responseData->patient_type,
					//"employee_uid"=>$_SESSION['loggedUserId'],
					//"registered_user_uid"=>$responseData->user_uid,
					//"entry_date_time"=>date('Y-m-d H:m')
					);
//print_r($insertdata2);die();
				$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
				$insertdata3=array(
					"patient_uid"=>$patient_uid
					);				
					$this->Common_insert_model->update_data($insertdata3,'booking_record','uid',$appointment_no);						
	

//----------------------temp code-------------------------------------------
				
			
		}
		
		
		if($responseData->patient_uid!=0 && $responseData->old_tbl_data_flag==1 && $responseData->present_flag==1)
		{
			
			//then insert the patient into our new patient table
				$insertdata=array(
					"old_puid"=>$responseData->patient_uid,
					//"uid"=>$responseData->patient_uid,
					//"age"=>$responseData->age,
					"full_name"=>$responseData->patient_name,
					"sex"=>$responseData->gender,
					"dob"=>$responseData->dob,
					"mobile"=>$responseData->mobile,
					"phone"=>$responseData->alternative_phone,
					"email"=>$responseData->email,
					"city"=>$responseData->city,
					"pin"=>$responseData->pin,
					"district"=>$responseData->district,
					"state_code"=>$responseData->state,					
					"country"=>$responseData->country,
					"category"=>$responseData->patient_category,
					"patient_type"=>2,
					"employee_uid"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:m')
					);

				$patient_uid=$this->Common_insert_model->save_data($insertdata,'patient');
				$insertdata2=array(
						"patient_uid"=>$patient_uid
						);				
						$this->Common_insert_model->update_data($insertdata2,'booking_record','uid',$appointment_no);
							
			
			
		}	
		return $patient_uid;//new generated patient id	
	}

*/
	function get_dialysis_bill_list()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));		
		
		$services=$this->input->post('services');		
		$payment_mode=$this->input->post('payment_mode');		
		$employee=$this->input->post('employee');
		$bill_section=3;//for dialysis bill only
		$response=$this->Dialysis_fetch_model->fetch_dialysis_bill_list($from_date,$to_date,$services,$payment_mode,$employee,$bill_section);				
		$sl=0;
		if($response)
		{
			foreach($response as $record)
			{		
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->bill_no?></td>
				<td><?=date('d-m-Y',strtotime($record->bill_date))?></td>
				<td><?=$record->patient_uid?></td>			
				<td><?=$record->patient_name?></td>
				<td><?=$record->gross_amount?></td>
				<td><?=($record->gross_amount)-($record->net_amount)?></td>
				<td><?=$record->net_amount?></td>
				<td>
				<a href="<?=base_url()?>Dialysis/printBill/<?=$record->uid?>" target="blank" title="Reprint">
					<i class="fa fa-print" aria-hidden="true"></i>
				</a>
				
				</td>
			  </tr>			
			<?php			
			}
		}
		else
		{?>
			  <tr>
				<td colspan="8"><?="Data not available"?></td>

			  </tr>	
		<?PHP
		}			
	}
	function get_hd_date_time()
	{
		$appointment_id=$this->input->post('appoint_id');
		$responseData=$this->Dialysis_fetch_model->fetch_booking_record($appointment_id);	
		echo "{";
		echo '"hd_date":"'.date('d/m/Y',strtotime($responseData->date_of_booking)).'",';
		echo '"hd_time":"'.date('H:m',strtotime($responseData->hd_slot)).'"';
		echo "}";		
	}
    function registration()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('dialysis/patient_registration.php',$data);
	}
    function supplierRegistration()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('dialysis/supplier_master.php',$data);
	}	
	function save_date_time_changes()	
	{
		$new_time=date('H:i:s',strtotime($this->input->post('new_time')));
		$new_date_new = str_replace('/', '-', $this->input->post('new_date') );
		$new_date=date('Y-m-d',strtotime($new_date_new));		
		
		$request_appointment_id=$this->input->post('request_appointment_id');
		$data=array(
		"hd_slot"=>$new_time,
		"date_of_booking"=>$new_date
		);				
		$this->Common_insert_model->update_data($data,'booking_record','uid',$request_appointment_id);
				
	}
	function addItem($update_item_id='')
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');	
	//	$data['all_item']=$this->Common_fetch_model->fetch_all_item_list();	
		if($update_item_id!='')
		{
			$edit_item_id=base64_decode($update_item_id);
			$data['item_record']=$this->Dialysis_fetch_model->fetch_item_record($edit_item_id);						
		}	
			$this->load->view('dialysis/add_item',$data);
	}
		public function add_item_record()
	{	
	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('product_name', 'Product Name', 'required');
		$this->form_validation->set_rules('reorder_level', 'Reorder Level', 'required');
		
	    if($this->form_validation->run()!= FALSE)
        {	
		$uid=base64_decode($this->input->post('uid'));//used to edit
		$product_name=$this->input->post('product_name');
		$product_category=$this->input->post('product_category');
		$reorder_level=$this->input->post('reorder_level');
		$minimum_level=$this->input->post('minimum_level');
		$maxium_level=$this->input->post('maxium_level');
		$issue_method=$this->input->post('issue_method');
		$clinic_uid=$this->input->post('clinic_uid');
		if(!empty($this->input->post('show_app')))
			$show_app=$this->input->post('show_app');
		else
			$show_app=0;
		if(!empty($this->input->post('active_flag')))		
			$active_flag=$this->input->post('active_flag');
		else
			$active_flag=0;

		//$generic_id_arr=$this->input->post('generic_id_arr');
		//$generic_id_arr=explode(",",$generic_id_arr);		

			$insertdata=array(
						"product_name"=>$product_name,
						"product_category"=>$product_category,
						"reorder_level"=>$reorder_level,
						"minimum_level"=>$minimum_level,
						"maxium_level"=>$maxium_level,
						"issue_method"=>$issue_method,
						"clinic_uid"=>$clinic_uid,
						"show_app"=>$show_app,
						"active_flag"=>$active_flag,
						"entry_by"=>$_SESSION['loggedUserId']
						
						);
						$last_inserted_item_id=0;
						if($uid=="")
							$this->Common_insert_model->save_data($insertdata,'product');
						else
							$this->Common_insert_model->update_data($insertdata,'product','uid',$uid);

					
					$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Dialysis/additem");
		}
		else
		{
			$this->add_item_record();
		}		
	}
	function save_opening_stock()
	{
		$item_uid=$this->input->post('product_uid');
		$opening_quantity=$this->input->post('opening_quantity');
		$unit=$this->input->post('unit');

		$data=array(
		"product_uid"=>$item_uid,
		"purchase_uid"=>11,
		"quantity"=>$opening_quantity,
		"unit"=>$unit,
		"clinic_uid"=>$_SESSION['clinicId'],
		"employee_uid"=>$_SESSION['loggedUserId'],
		"entry_date_time"=>date('Y-m-d H:i:s')		
		);			
		$this->Common_insert_model->save_data($data,'purchase_details');
		redirect(base_url()."Dialysis/item");
	}	
	function issueEntry()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_non_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),2);//non patient
		$data['todays_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),1);// patient wise
		$data['group_list']=$this->Dialysis_fetch_model->fetch_group_list('ASC');//descending order		
/*		if($update_item_id!='')
		{
			$edit_item_id=base64_decode($update_item_id);
			$data['item_record']=$this->Dialysis_fetch_model->fetch_item_record($edit_item_id);						
		}*/	
			$this->load->view('dialysis/issue',$data);		
	}
	function issueToSupplier()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_supplier_wise_issue_list']=$this->Dialysis_fetch_model->fetch_supplier_issues_date_wise(date('Y-m-d'),date('Y-m-d'));
		$data['group_list']=$this->Dialysis_fetch_model->fetch_group_list('ASC');//descending order		
		$this->load->view('dialysis/issueToSupplier',$data);		
	}	
	function issueSave()
	{
		$new_date_new = str_replace('/', '-', $this->input->post('issue_date') );
		$issue_date=date('Y-m-d',strtotime($new_date_new));		
		$product_id=$this->input->post('product_name');
		$quantity=$this->input->post('quantity');
		$unit=$this->input->post('unit');
		$issue_to_department=$this->input->post('issue_to_department');
		$patient_id=$this->input->post('patient_id');

		$data=array(
		"issue_date"=>$issue_date,
		"product_uid"=>$product_id,
		"quantity"=>$quantity,
		"unit"=>$unit,
		"issue_to_department"=>$issue_to_department,
		"patient_uid"=>$patient_id,
		"clinic_uid"=>$_SESSION['clinicId'],
		"challan_no"=>$this->input->post('challan_no'),
		"vehicle_no"=>$this->input->post('vehicle_no'),
		"employee_uid"=>$_SESSION['loggedUserId'],
		"entry_date_time"=>date('Y-m-d H:i:s')
		);			
		$this->Common_insert_model->save_data($data,'issue');
		if($patient_id!="")
			$this->session->set_flashdata('temp_patient_id', $patient_id);
		redirect(base_url()."Dialysis/issueEntry");		
	}
	function supplierIssueSave()
	{
		$new_date_new = str_replace('/', '-', $this->input->post('issue_date') );
		$issue_date=date('Y-m-d',strtotime($new_date_new));		
		$product_id=$this->input->post('product_name');
		$quantity=$this->input->post('quantity');
		$unit=$this->input->post('unit');
		$issue_to_department=$this->input->post('issue_to_department');
		$patient_id=$this->input->post('supplier_id');

		$data=array(
		"issue_date"=>$issue_date,
		"product_uid"=>$product_id,
		"quantity"=>$quantity,
		"unit"=>$unit,
		"issue_to_department"=>$issue_to_department,
		"issue_to"=>2,//for supplier
		"patient_uid"=>$patient_id,
		"clinic_uid"=>$_SESSION['clinicId'],
		"challan_no"=>$this->input->post('challan_no'),
		"vehicle_no"=>$this->input->post('vehicle_no'),
		"employee_uid"=>$_SESSION['loggedUserId'],
		"entry_date_time"=>date('Y-m-d H:i:s')
		);			
		$this->Common_insert_model->save_data($data,'issue');
		if($patient_id!="")
			$this->session->set_flashdata('temp_patient_id', $patient_id);
		redirect(base_url()."Dialysis/issueToSupplier");		
	}	
	function issueByGroupSave()
	{
		$new_date_new = str_replace('/', '-', $this->input->post('issue_date') );
		$issue_date=date('Y-m-d',strtotime($new_date_new));		
		$group_name=$this->input->post('group_name');
		$quantity=$this->input->post('quantity');
		$issue_to_department=$this->input->post('issue_to_department');
		$patient_id=$this->input->post('patient_id_for_group');

		//get items of group
		$response=$this->Dialysis_fetch_model->fetch_group_items($group_name);		
		foreach($response as $record)
		{
			$data=array(
			"issue_date"=>$issue_date,
			"product_uid"=>$record->item_id,
			"quantity"=>$quantity,
			"unit"=>"Pcs",
			"issue_to_department"=>$issue_to_department,
			"patient_uid"=>$patient_id,
			"clinic_uid"=>$_SESSION['clinicId'],
			"employee_uid"=>$_SESSION['loggedUserId'],
			"entry_date_time"=>date('Y-m-d H:i:s')
		);			
		$this->Common_insert_model->save_data($data,'issue');
		}

		redirect(base_url()."Dialysis/issueEntry");		
	}
	function checkIssueMethod()
	{
		$product_id=$this->input->post('prod_id');
		$response=$this->Dialysis_fetch_model->check_issue_method($product_id);								
		if(!empty($response))
		{
			if($response->issue_method==1)
				echo 1;//patient wise issue accepted
			else
				echo 0;//patient wise issue accepted
		}
	}
	function itemReceived()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_purchase_list']=$this->Dialysis_fetch_model->fetch_purchase_list(date('Y-m-d'));//non patient
		$this->load->view('dialysis/purchase_details',$data);		
	}
	function purchaseSave()	
	{
		$new_date_new = str_replace('/', '-', $this->input->post('purchase_date') );
		$purchase_date=date('Y-m-d',strtotime($new_date_new));		
		$product_id=$this->input->post('product_name');
		$quantity=$this->input->post('quantity');
		$unit=$this->input->post('unit');
		$invoice_no=$this->input->post('invoice_no');
		$received_from_type=$this->input->post('received_from');
		if($received_from_type=="1")
		{
			$received_from=$this->input->post('supplier_id');
		}
		else if($received_from_type=="2")
		{
			$received_from=$this->input->post('patient_id');
		}
		$data=array(
		"purchase_date"=>$purchase_date,
		"purchase_uid"=>0,
		"product_uid"=>$product_id,
		"quantity"=>$quantity,
		"unit"=>$unit,
		"invoice_no"=>$invoice_no,
		"clinic_uid"=>$_SESSION['clinicId'],
		"received_from_type"=>$received_from_type,
		"received_from"=>$received_from,
		"employee_uid"=>$_SESSION['loggedUserId'],
		"entry_date_time"=>date('Y-m-d H:i:s')
		);			
		$this->Common_insert_model->save_data($data,'purchase_details');
		redirect(base_url()."Dialysis/itemReceived");			
	}
	function closingStock()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);								
		$this->load->view('dialysis/closing_stock',$data);		
	}
	function get_closing_stock()
	{
		$no_of_record=100;
		$all_item_list=$this->Dialysis_fetch_model->fetch_item_list($no_of_record);//descending order		
		foreach($all_item_list as $record)
		{
		?>
		<tr>
			<td><input type="checkbox" id="search_filtered_items_id" name="search_filtered_items_id[]" value="<?=base64_encode($record->uid)?>"></td>
			<td><?=$record->product_name?></td>
			<td><?=($record->product_category==1)?'Medicine':(($record->product_category==2)?'Consumable':'')?></td>
			<?php
			//get opening stock
			$opening_stock=$this->Dialysis_fetch_model->fetch_opening_stock($record->uid);		
			//get item_entry
			$item_entry=$this->Dialysis_fetch_model->fetch_item_total_entry($record->uid);		
			//get issue
			$issue=$this->Dialysis_fetch_model->fetch_item_total_issue($record->uid);		
			
			?>
			<td><?=((!empty($opening_stock)?$opening_stock->quantity:0)+($item_entry->tot_qty))-($issue->tot_issue_qty)?></td>
			<td>&nbsp;</td>
		</tr>
		<?php
		}
	}
	function get_product_closing_stock()
	{
		$product_id=$this->input->post('product_id');
		//get opening stock
		$opening_stock=$this->Dialysis_fetch_model->fetch_opening_stock($product_id);		
		//get item_entry
		$item_entry=$this->Dialysis_fetch_model->fetch_item_total_entry($product_id);		
		//get issue
		$issue=$this->Dialysis_fetch_model->fetch_item_total_issue($product_id);		
		echo ((!empty($opening_stock)?$opening_stock->quantity:0)+($item_entry->tot_qty))-($issue->tot_issue_qty);
	}
	function issueRegister()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_non_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),2);//non patient
		$data['todays_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),1);// patient wise		
		$this->load->view('dialysis/rpt_issue_register',$data);		
	}
	function get_issue_register_data()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$product_id=$this->input->post('product_id');		
		$todays_non_patient_wise_issue_list=$this->Dialysis_fetch_model->fetch_issues_date_wise($date_from,2,$date_to,$product_id);
		$todays_patient_wise_issue_list=$this->Dialysis_fetch_model->fetch_issues_date_wise($date_from,1,$date_to,$product_id);

		$sl=0;
		foreach($todays_non_patient_wise_issue_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td>&nbsp;</td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		  <td><?=$record->challan_no?></td>
		  <td><?=$record->vehicle_no?></td>
		  <td><a href="javascript:void(0)" onclick="delete_record('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td>
		</tr>
		<?php
		}

		foreach($todays_patient_wise_issue_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td><?=$record->full_name?> [<?=$record->patient_uid?>]</td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		  <td><?=$record->challan_no?></td>
		  <td><?=$record->vehicle_no?></td>		  
		  <td><a href="javascript:void(0)" onclick="delete_record('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td>
		</tr>
		<?php
		}
		
		
	}
	function receivedRegister()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['todays_purchase_list']=$this->Dialysis_fetch_model->fetch_purchase_list(date('Y-m-d'));//non patient		
		$this->load->view('dialysis/rpt_received_register',$data);		
	}
	function get_received_register_data()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
	
		$todays_purchase_list=$this->Dialysis_fetch_model->fetch_purchase_list($date_from,$date_to);//non patient
		$sl=0;
		foreach($todays_purchase_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=date('d-m-Y',strtotime($record->purchase_date))?></td>													  
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td><?=$record->invoice_no?></td>
		  <td><a href="javascript:void(0)" onclick="delete_record('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td>
		</tr>
		<?php
		}	
		
	}
	function patientIssuelist()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_non_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),2);//non patient
		$data['todays_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),1);// patient wise		
		$this->load->view('dialysis/rpt_patient_wise_issue_list',$data);		
	}
	function get_patient_issue_register_data()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$patient_id=$this->input->post('patient_id');		
		$patient_wise_issue_list=$this->Dialysis_fetch_model->fetch_patient_issues_date_wise($date_from,$date_to,$patient_id);// patient wise
		$sl=0;
		foreach($patient_wise_issue_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		</tr>
		<?php
		}
		
		
	}
	function groupAdd($updateGroupId="")
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');	
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list(0,'ASC',1);//descending order				
		$data['group_list']=$this->Dialysis_fetch_model->fetch_group_list('ASC');//descending order				
		if($updateGroupId!='')
		{
			$edit_item_id=base64_decode($update_item_id);
			$data['item_record']=$this->Dialysis_fetch_model->fetch_item_record($edit_item_id);						
		}	
			$this->load->view('dialysis/group_add',$data);
	}
	function add_group_record()
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('group_name', 'Group Name', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
		$uid=base64_decode($this->input->post('uid'));//used to edit
		$group_name=$this->input->post('group_name');
		$item_list=$this->input->post('item_list');
		if(!empty($this->input->post('show_app')))
			$show_app=$this->input->post('show_app');
		else
			$show_app=0;
		if(!empty($this->input->post('active_flag')))		
			$active_flag=$this->input->post('active_flag');
		else
			$active_flag=0;

		for($i=0;$i<count($item_list);$i++)
		{
			$insertdata=array(
				"group_name"=>$group_name,
				"item_id"=>$item_list[$i],
				"unit"=>"Pcs",
				"active_flag"=>$active_flag,
				"show_app_flag"=>$show_app
				);
				$last_inserted_item_id=0;
				if($uid=="")
					$this->Common_insert_model->save_data($insertdata,'item_group');
				else
					$this->Common_insert_model->update_data($insertdata,'item_group','uid',$uid);

		}		
					$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Dialysis/groupAdd");
		}
		else
		{
			$this->add_item_record();
		}		
	}
	function get_group_items()
	{
		$group_name=$this->input->post('group_name');
		$response=$this->Dialysis_fetch_model->fetch_group_items($group_name);
		foreach($response as $record)
		{
			?>
			<tr>
				<td><?=$record->item_id?></th>
				<td><?=$record->product_name?></th>
			</tr>
			<?php
		}
	}
	function delete_group($group_name)
	{
		$response=$this->Common_insert_model->delete_record('item_group','group_name',$group_name);		
		redirect(base_url().'Dialysis/groupAdd');
	}
	function hdRecord($update_id=0)
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['departmental_doctor_list']=$this->Common_fetch_model->fetch_departmental_doctors_name(801);//descending order
		if(base64_decode($update_id)!=0)//fetch value against given id
		{
			$data['hd_record']=$this->Dialysis_fetch_model->fetch_dialysis_hd_record_by_id(base64_decode($update_id));
			
		}
		$this->load->view('dialysis/hd_record',$data);			
	}
	function hdRecordList()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['departmental_doctor_list']=$this->Common_fetch_model->fetch_departmental_doctors_name(801);//descending order
		$this->load->view('dialysis/hd_record_search',$data);			
	}	
           // -----------  Dialysis Record Save/Edit Start      ------------------	
		public function save_hdrecord()
		{	
		    $uid=$this->input->post('uid');
			$patient_uid=$this->input->post('patient_id');
			$doctor_uid=$this->input->post('doctor_uid');
			$patient_type=$this->input->post('patient_type');

			$hd_date_new = str_replace('/', '-', ($this->input->post('hd_date')));
			$hd_date = date('Y-m-d',strtotime($hd_date_new));			
			
			$hd_start_time=$this->input->post('hd_start_time');
			$hd_close_time=$this->input->post('hd_close_time');
			$machine_no=$this->input->post('machine_no');
			$access_for_hd=$this->input->post('access_for_hd');
			$tubing_reuse=$this->input->post('tubing_reuse');
			$dialyzer_reuse=$this->input->post('dialyzer_reuse');
			$dialyzer_discard=$this->input->post('dialyzer_discard');
			$pre_weight=$this->input->post('pre_weight');
			$post_weight=$this->input->post('post_weight');
			$weight_gain=$this->input->post('weight_gain');
			$uf=$this->input->post('uf');
			$weight_loss=$this->input->post('weight_loss');
			$pre_hd_bp_systolic=$this->input->post('pre_hd_bp_systolic');
			$pre_hd_bp_diastolic=$this->input->post('pre_hd_bp_diastolic');
			$post_hd_bp_systolic=$this->input->post('post_hd_bp_systolic');
			$post_hd_bp_diastolic=$this->input->post('post_hd_bp_diastolic');
			$dia_procedure=$this->input->post('dia_procedure');
			$flow=$this->input->post('flow');
			$blood_transfussion=$this->input->post('blood_transfussion');
			$remarks=$this->input->post('remarks');
			
				$insertdata=array(
					   // "uid"=>$diagnosis_uid,
						"patient_uid"=>$patient_uid,
						//"patient_name"=>$patient_name,
						//"patient_gender_age"=>$patient_gender_age,
						"doctor_uid"=>$doctor_uid,
						"patient_type"=>$patient_type,
						"hd_date"=>$hd_date,
						"hd_start_time"=>$hd_start_time,
						"hd_close_time"=>$hd_close_time,
						"machine_no"=>$machine_no,
						"access_for_hd"=>$access_for_hd,
						"tubing_reuse"=>$tubing_reuse,
						"dialyzer_reuse"=>$dialyzer_reuse,
						"dialyzer_discard"=>$dialyzer_discard,
						"pre_weight"=>$pre_weight,
						"post_weight"=>$post_weight,
						"weight_gain"=>$weight_gain,
						"uf"=>$uf,
						"weight_loss"=>$weight_loss,
						"pre_hd_bp_systolic"=>$pre_hd_bp_systolic,
						"pre_hd_bp_diastolic"=>$pre_hd_bp_diastolic,
						"post_hd_bp_systolic"=>$post_hd_bp_systolic,
						"post_hd_bp_diastolic"=>$post_hd_bp_diastolic,
						"dia_procedure"=>$dia_procedure,
						"flow"=>$flow,
						"blood_transfussion"=>$blood_transfussion,
						"remarks"=>$remarks
						
						);

				if($uid=="0")
					$this->Common_insert_model->save_data($insertdata,'dialysis_record');
				else
					$this->Common_insert_model->update_data($insertdata,'dialysis_record','uid',$uid);

			redirect(base_url()."Dialysis/hdRecord");	
		}
		// -----------  Dialysis Record Save/Edit End      ------------------
	function complication()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('dialysis/complication',$data);			
	}
	function save_dialysisComplication()
	{
		$patient_uid=$this->input->post('patient_id');
		$hd_date_new = str_replace('/', '-', $this->input->post('hd_date') );
		$hd_date=date('Y-m-d',strtotime($hd_date_new));		
		
		$hd_time_slot=$this->input->post('hd_time_slot');
		$complication_time=$this->input->post('complication_time');
		$complication=$this->input->post('complication');
		
			$insertdata=array(
			"patient_uid"=>$patient_uid,
			"dialysis_date"=>$hd_date,
			"dialysis_time"=>$hd_time_slot,
			"complication_time"=>$complication_time,
			"complication"=>$complication,
			"employee_uid"=>$_SESSION['loggedUserId'],
			"entry_date_time"=>date('Y-m-d H:i:s')
			
			);
			$this->Common_insert_model->save_data($insertdata,'dialysis_complication');
			redirect(base_url()."Dialysis/complication");
	}
	function get_patients_complication()
	{
		$patient_uid=$this->input->post('patient_id');
		$response=$this->Dialysis_fetch_model->fetch_patients_complication($patient_uid);
		if(!empty($response))
		{
			foreach($response as $record)
			{
				?>
				<tr>
					<td><?=date('d-m-Y',strtotime($record->dialysis_date))?></td>
					<td><?=$record->patient_uid?></td>
					<td><?=$record->complication?></td>
					<td><?=($record->complication_time==1)?'During HD':(($record->complication_time==2)?'Others Time':'')?></td>
				</tr>
				<?php
			}
		}
		
	}
	function investigation()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('dialysis/investigation',$data);			
	}
	function save_dialysisInvestigation()
	{
		$patient_uid=$this->input->post('patient_id');
		$investigation_date_new = str_replace('/', '-', $this->input->post('investigation_date') );
		$investigation_date=date('Y-m-d',strtotime($investigation_date_new));		
		
		$investigation_id=base64_decode($this->input->post('enc_investigation_id'));
		$value=$this->input->post('value');
		$unit=$this->input->post('investigation_unit');
		
			$insertdata=array(
			"patient_id"=>$patient_uid,
			"investigation_date"=>$investigation_date,
			"parameter_id"=>$investigation_id,
			"value"=>$value,
			"unit"=>$unit,
			"employee_id"=>$_SESSION['loggedUserId'],
			"entry_date"=>date('Y-m-d')
			
			);
			$this->Common_insert_model->save_data($insertdata,'dialysis_investigation');
			redirect(base_url()."Dialysis/investigation");
	}
	function get_patients_investigation()
	{
		$patient_uid=$this->input->post('patient_id');
		$response=$this->Dialysis_fetch_model->get_patients_investigation($patient_uid);
		if(!empty($response))
		{
			foreach($response as $record)
			{
				?>
				<tr>
					<td><?=date('d-m-Y',strtotime($record->investigation_date))?></td>
					<td><?=$record->patient_id?></td>
					<td><?=$record->parameter?></td>
					<td><?=$record->value?></td>
					<td><?=$record->unit?></td>
				</tr>
				<?php
			}
		}		
	}
	function get_dialysis_hd_records()
	{
		$patient_uid=$this->input->post('patient_id');

		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));

		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$response=$this->Dialysis_fetch_model->fetch_dialysis_hd_records($patient_uid,$date_from,$date_to);
		if(!empty($response))
		{
			foreach($response as $record)
			{
				?>
				<tr>
					<td><?=date('d-m-Y',strtotime($record->hd_date))?></td>
					<td><?=$record->patient_uid?></td>
					<td><?=$record->hd_start_time?></td>
					<td><?=$record->remarks?></td>
					<td><a href="<?=base_url()."Dialysis/hdRecord/"?><?=base64_encode($record->uid)?>" title="Show/Update"><i class="fa fa-pencil" aria-hidden="true"></i></a></td>
				</tr>
				<?php
			}
		}		
	}
	function medication()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('dialysis/hd_medication',$data);			
	}
	function save_dialysisMedication()
	{
		$patient_uid=$this->input->post('patient_id');
		$hd_date_new = str_replace('/', '-', $this->input->post('hd_date') );
		$hd_date=date('Y-m-d',strtotime($hd_date_new));		
		
		$medicine_id=base64_decode($this->input->post('enc_advise_medicine_id'));
		$medicine_strength=$this->input->post('medicine_strength');
		$medicine_dose=$this->input->post('medicine_dose');
		$medicine_days=$this->input->post('medicine_days');
		
			$insertdata=array(
			"patient_id"=>$patient_uid,
			"hd_date"=>$hd_date,
			"medicine_id"=>$medicine_id,
			"strength"=>$medicine_strength,
			"dose"=>$medicine_dose,
			"days"=>$medicine_days,
			"employee_id"=>$_SESSION['loggedUserId'],
			"entry_date"=>date('Y-m-d')
			
			);
			$this->Common_insert_model->save_data($insertdata,'dialysis_medication');
			redirect(base_url()."Dialysis/medication");
	}
	function get_patients_dialysis_medication()
	{
		$patient_uid=$this->input->post('patient_id');
		$response=$this->Dialysis_fetch_model->fetch_patients_dialysis_medication($patient_uid);
		if(!empty($response))
		{
			foreach($response as $record)
			{
				?>
				<tr>
					<td><?=date('d-m-Y',strtotime($record->hd_date))?></td>
					<td><?=$record->patient_id?></td>
					<td><?=$record->medicine_name?></td>
					<td><?=$record->strength?></td>
					<td><?=$record->dose?></td>
					<td><?=$record->days?></td>
				</tr>
				<?php
			}
		}		
	}
	function nonReceivedItemsRegister()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_non_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),2);//non patient
		$data['todays_patient_wise_issue_list']=$this->Dialysis_fetch_model->fetch_issues_date_wise(date('Y-m-d'),1);// patient wise		
		$this->load->view('dialysis/rept_non_received_items_register',$data);		
	}
	function get_nonReceivedItems_register_data()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$product_id=$this->input->post('product_id');		
		$product_issued_customer_list=$this->Dialysis_fetch_model->fetch_distinct_issues_product_wise();// patient wise

		$sl=0;
		foreach($product_issued_customer_list as $record)
		{
			//get total issue of a partcular product
			$patient_total_issue=$this->Dialysis_fetch_model->fetch_patient_total_issues_forSelectedProduct($record->patient_uid,$product_id);
			
		?>
	<!--	<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td>&nbsp;</td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		</tr>-->
		<?php
		}

		foreach($patient_wise_issue_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td><?=$record->full_name?> [<?=$record->patient_uid?>]</td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		</tr>
		<?php
		}
			
	}	
	function customerData()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_customer_list']=$this->Common_fetch_model->fetch_all_customer();//descending order				
		$this->load->view('dialysis/customer_list',$data);
	}
	function supplierData()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_supplier_list']=$this->Common_fetch_model->fetch_all_supplier();//descending order				
		$this->load->view('dialysis/supplier_list',$data);
	}
	function supplierIssueRegister()
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');
		$data['all_item_list']=$this->Dialysis_fetch_model->fetch_item_list_forDropDown('ASC');//descending order
		$data['todays_supplier_wise_issue_list']=$this->Dialysis_fetch_model->fetch_supplier_issues_date_wise(date('Y-m-d'),date('Y-m-d'));//date from,date to
		$this->load->view('dialysis/rpt_supplier_issue_register',$data);		
	}
	function get_supplier_issue_register_data()
	{
		$date_from_new = str_replace('/', '-', $this->input->post('date_from') );
		$date_from=date('Y-m-d',strtotime($date_from_new));		
		$date_to_new = str_replace('/', '-', $this->input->post('date_to') );
		$date_to=date('Y-m-d',strtotime($date_to_new));
		
		$product_id=$this->input->post('product_id');		
		$supplier_wise_issue_list=$this->Dialysis_fetch_model->fetch_supplier_issues_date_wise($date_from,$date_to);

		$sl=0;
		foreach($supplier_wise_issue_list as $record)
		{
		?>
		<tr>
		  <th scope="row"><?=++$sl?></th>
		  <td><?=$record->product_name?></td>
		  <td><?=$record->quantity?></td>
		  <td><?=$record->unit?></td>
		  <td><?=$record->supplier_name?> [<?=$record->uid?>]</td>
		  <td><?=date('d-m-Y',strtotime($record->issue_date))?></td>
		  <td><?=$record->challan_no?></td>
		  <td><?=$record->vehicle_no?></td>		  
		  <td><a href="javascript:void(0)" onclick="delete_record('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td>
		</tr>
		<?php
		}
		
		
	}	
}

?>