<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Doctor extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		$this->load->model('doctorModel/Doctor_fetch_model');
		$this->load->model('systemsModel/Systems_fetch_model');
		$this->load->model('diagnosticsModel/Diagnostics_fetch_model');
		//$this->load->model('adminModel/Admin_fetch_model');
		//$this->load->model('pharmacyModel/Pharmacy_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');	
		$this->load->model('appointmentModel/Appointment_fetch_model');
	}
	//************************doctor dash board start**********
	function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('doctor/doctor_dashboard',$userModuleData);
	}
		//************************doctor dash board End **********
		
	function complain()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_complain_list']=$this->Doctor_fetch_model->fetch_complain_list($no_of_record);//descending order				
		$this->load->view('doctor/complain_data',$data);
	}
	function advice()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_advice_list']=$this->Doctor_fetch_model->fetch_advise_activity_data($no_of_record);//descending order				
		$this->load->view('doctor/advice_data',$data);
	}
	function diagnosis()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_diagnosis_list']=$this->Doctor_fetch_model->fetch_diagnosis($no_of_record);//descending order				
		$this->load->view('doctor/diagnosis_data',$data);
	}
	function diagnosisAdd()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);							
		$this->load->view('doctor/diagnosis_add',$data);
	}
		
	function appointmentList()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch	
	
		$userModuleData['appointment_list']=$this->Appointment_fetch_model->fetch_appointment_list_for_billing_completed(date('Y-m-d'));				
		$this->load->view('doctor/doctor_appointment_list',$userModuleData);		
	}
	function get_appointment_list()
	{
		$clinic=$this->input->post('clinic');
		
		if($this->input->post('date_from')!="")
			$date_from=date('Y-m-d',strtotime($this->input->post('date_from')));
		else
			$date_from="";
		
		if($this->input->post('date_to')!="")
			$date_to=date('Y-m-d',strtotime($this->input->post('date_to')));
		else
			$date_to="";
		
		$visitor_name=$this->input->post('visitor_name');
		$mobile=$this->input->post('mobile');
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$visit_consultation=$this->Appointment_fetch_model->fetch_appointment_list($clinic,$date_from,$date_to,$visitor_name,$mobile);
		foreach($visit_consultation as $record)
		{
		?>
		  <tr>
			<td><input type="hidden" name="selection[]" value="<?=$record->appo_uid?>"></td>
			<td><?=date('d-m-Y',strtotime($record->approve_date))?></td>
			<td><?=$record->name?></td>
			<td><?=$record->age?></td>
			<td><?=$record->whatsapp_num?></td>
			<td><span id="product-status-1" class="label label-success">Active</span></td>
			<td><a class="update-product" href="#" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="#" title="Delete"><i class="fa fa-trash-o"></i></a></td>
		  </tr>
		<?php
		}		
	}
	function consultancy($pid=0,$visit_no=0)
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch			
		//get the appointed patient
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$data['appointed_patient_list']=$this->Appointment_fetch_model->fetch_appointed_patient_list(date('Y-m-d'));
//----------------------------old code---------------------------------
		if(base64_decode($pid)!=0 || isset($_SESSION['session_patient_id']))
		{			
			if(isset($_SESSION['session_patient_id']))
				$patient_uid=$_SESSION['session_patient_id'];
			else
				$patient_uid=base64_decode($pid);
			
			if(base64_decode($visit_no)!=0)
				$current_visit_no=base64_decode($visit_no);
			else
				$current_visit_no=$_SESSION['session_current_visit_no'];			
			//get patient available investigation details
			$data['patient_investigation_details']=$this->Doctor_fetch_model->get_recent_saved_invst_record_history($patient_uid,$current_visit_no);		

			//get patient complain available details
			$data['patient_complain_details']=$this->Doctor_fetch_model->get_recent_saved_complain_history($patient_uid,$current_visit_no);		

			//get patient used medicine available details
			//$data['patient_used_medicine_details']=$this->Doctor_fetch_model->get_recent_saved_medicine_used_history($patient_uid,$current_visit_no);			
			
			//fetch patient general survey
			$data['history_general_survey']=$this->Doctor_fetch_model->get_patient_saved_general_history($patient_uid,$current_visit_no);

			//fetch patients available diagnosis
			$data['history_diagnosis']=$this->Doctor_fetch_model->get_recent_saved_diagnosis($patient_uid,$current_visit_no);
			
			//fetch patients advised investigation
			$data['history_advised_investigation']=$this->Doctor_fetch_model->fetch_advise_investigation($patient_uid,$current_visit_no);
			
			//fetch saved advised activity
			$data['history_advised_activity']=$this->Doctor_fetch_model->fetch_advise_activity_name($patient_uid,$current_visit_no);					

			//fetch previous visit medicine
			//$data['history_previous_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no-1);								
			
			//fetch saved advised activity
			$data['history_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no);					
			
			//fetch saved history questions
			//$data['history_questions']=$this->Doctor_fetch_model->get_saved_hisory_questions($patient_uid,$current_visit_no);					

			//fetch saved history questions
			//$data['history_default_exam']=$this->Doctor_fetch_model->get_default_hisory_examination_name($patient_uid,$current_visit_no);					


			//fetch patient vaccination
			//$data['patient_vaccination_data']=$this->Doctor_fetch_model->fetch_vaccine_detail_list($patient_uid);						

			//fetch dialysis_pt
			$data['dialysis_pt_data']=$this->Doctor_fetch_model->fetch_dialysis_pt_data($patient_uid,$current_visit_no);						
			//fetch tx waiting pt
			//$data['tx_waiting_pt_data']=$this->Doctor_fetch_model->fetch_tx_waiting_pt_data($patient_uid,$current_visit_no);	
			//fetch patient vaccination
			$data['post_tx_data']=$this->Doctor_fetch_model->fetch_post_tx_data($patient_uid,$current_visit_no);	

			//fetch patient radiology data
			//$data['radio_data']=$this->Doctor_fetch_model->fetch_radiology_data($patient_uid,$current_visit_no);	
		}
//----------------------------old code---------------------------------				
		
		//fetch KB category and organ list
		$data['KB_cat']=$this->Doctor_fetch_model->kb_category();
		$data['KB_organ']=$this->Doctor_fetch_model->kb_organ();
		$this->load->view('doctor/consultancy.php',$data);
	}
	function counselling($pid=0,$visit_no=0)
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch			
		//get the appointed patient
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$data['appointed_patient_list']=$this->Appointment_fetch_model->fetch_appointed_patient_list(date('Y-m-d'));
//----------------------------old code---------------------------------
		if(base64_decode($pid)!=0 || isset($_SESSION['session_patient_id']))
		{			
			if(isset($_SESSION['session_patient_id']))
				$patient_uid=$_SESSION['session_patient_id'];
			else
				$patient_uid=base64_decode($pid);
			
			if(base64_decode($visit_no)!=0)
				$current_visit_no=base64_decode($visit_no);
			else
				$current_visit_no=$_SESSION['session_current_visit_no'];			
			//get patient available investigation details
			$data['patient_investigation_details']=$this->Doctor_fetch_model->get_recent_saved_invst_record_history($patient_uid,$current_visit_no);		

			//get patient complain available details
			$data['patient_complain_details']=$this->Doctor_fetch_model->get_recent_saved_complain_history($patient_uid,$current_visit_no);		

			//get patient used medicine available details
			//$data['patient_used_medicine_details']=$this->Doctor_fetch_model->get_recent_saved_medicine_used_history($patient_uid,$current_visit_no);			
			
			//fetch patient general survey
			$data['history_general_survey']=$this->Doctor_fetch_model->get_patient_saved_general_history($patient_uid,$current_visit_no);

			//fetch patients available diagnosis
			$data['history_diagnosis']=$this->Doctor_fetch_model->get_recent_saved_diagnosis($patient_uid,$current_visit_no);
			
			//fetch patients advised investigation
			$data['history_advised_investigation']=$this->Doctor_fetch_model->fetch_advise_investigation($patient_uid,$current_visit_no);
			
			//fetch saved advised activity
			$data['history_advised_activity']=$this->Doctor_fetch_model->fetch_advise_activity_name($patient_uid,$current_visit_no);					

			//fetch previous visit medicine
			//$data['history_previous_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no-1);								
			
			//fetch saved advised activity
			$data['history_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no);					
			
			//fetch saved history questions
			//$data['history_questions']=$this->Doctor_fetch_model->get_saved_hisory_questions($patient_uid,$current_visit_no);					

			//fetch saved history questions
			//$data['history_default_exam']=$this->Doctor_fetch_model->get_default_hisory_examination_name($patient_uid,$current_visit_no);					


			//fetch patient vaccination
			//$data['patient_vaccination_data']=$this->Doctor_fetch_model->fetch_vaccine_detail_list($patient_uid);						

			//fetch dialysis_pt
			$data['dialysis_pt_data']=$this->Doctor_fetch_model->fetch_dialysis_pt_data($patient_uid,$current_visit_no);						
			//fetch tx waiting pt
			//$data['tx_waiting_pt_data']=$this->Doctor_fetch_model->fetch_tx_waiting_pt_data($patient_uid,$current_visit_no);	
			//fetch patient vaccination
			$data['post_tx_data']=$this->Doctor_fetch_model->fetch_post_tx_data($patient_uid,$current_visit_no);	

			//fetch patient radiology data
			//$data['radio_data']=$this->Doctor_fetch_model->fetch_radiology_data($patient_uid,$current_visit_no);	
		}
//----------------------------old code---------------------------------				
		$this->load->view('doctor/counselling.php',$data);
	}
	function temp()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('doctor/page.html',$userModuleData);
	}
	function get_list()
	{
		$text=$this->input->post('search_text');		
		$field_id=$this->input->post('field_id');		
		$list_name=$this->input->post('list_name');		
		$search_for=$this->input->post('pattern');
		if($search_for=="complain_search")
			$data=$this->Doctor_fetch_model->fetch_complain_list_by_name($text);
		if($search_for=="diagnosis_search")
			$data=$this->Doctor_fetch_model->fetch_diagnosis_by_name($text);
		if($search_for=="investigation_search")
			$data=$this->Diagnostics_fetch_model->fetch_test_parameter_list($text);		
		if($search_for=="advise_medicine_search")
			$data=$this->Common_fetch_model->fetch_medicine_list_by_name($text);
		if($search_for=="investigation_advise_search")
			$data=$this->Diagnostics_fetch_model->fetch_investigation_by_name($text);
		if($search_for=="diat_activity_search")
			$data=$this->Doctor_fetch_model->fetch_advise_activity_data_by_name($text);
		
		?>
		<!--<ul ><!--class="dropdown-menu total_search"-->
		<?php
		foreach($data as $record)
		{
			if($search_for=="complain_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->complain?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->complain?></a></li>
		<?php
			}

			if($search_for=="diagnosis_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->diagnosis_name?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->diagnosis_name?></a></li>
		<?php
			}
			if($search_for=="investigation_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->parameter?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->parameter?></a></li>
		<?php
			}
			if($search_for=="advise_medicine_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->medicine_name?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->medicine_name?></a></li>
		<?php
			}
			if($search_for=="investigation_advise_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->test_name?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->test_name?></a></li>
		<?php
			}
			if($search_for=="diat_activity_search")
			{
		?>
			<li><a class="dropdown-item" href="javascript:" onclick="get_search_record('<?=base64_encode($record->uid)?>','<?=$record->topic?>','<?=$field_id?>','<?=$list_name?>')"><?=$record->topic?></a></li>
		<?php
			}			
		}//end of foreach
		?>		
		<!--</ul>-->
		<?php		
	}
	function save_complain()
	{
		$patientId=$this->input->post('patient_id');
		//$patientId=base64_decode($this->input->post('patient_id'));
		$currentVisitNo=$this->input->post('current_visit_no');
		$complainName=base64_decode($this->input->post('complain_name'));
		$complainDuration=$this->input->post('complain_duration');
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"complain_uid"=>$complainName,
			"complain_duration"=>$complainDuration
		);

		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_complain');
		echo $last_insert_id;
		
	}
	function save_diagnosis()
	{
		$patientId=$this->input->post('patient_id');
		//$patientId=base64_decode($this->input->post('patient_id'));
		$currentVisitNo=$this->input->post('current_visit_no');
		$diagnosis_name=base64_decode($this->input->post('diagnosis_name'));
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"diagnosis_uid"=>$diagnosis_name
		);

		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_diagnosis');
		echo $last_insert_id;
		
	}
	function search_advice()
	{
		$search_data=$this->input->post('search_data');
		$all_advice_list=$this->Doctor_fetch_model->fetch_advise_activity_data_by_name($search_data);	
		foreach($all_advice_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_items_id[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->topic?></td>
				<td>&nbsp;</td>
                <td><a class="update-product" data-toggle="modal" data-target="#myModal" onclick="edit_data('<?=base64_encode($record->uid)?>')" href="javascript:void(0)" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}
	function delete_table_items()//bulk delete
	{
		$search_filtered_items_id=$this->input->post('search_filtered_items_id');
		$redirect_url=$this->input->post('redirect_url');
		$table_name=$this->input->post('table_name');
 		$condition_field=$this->input->post('delete_field');

		for($i=0;$i<count($search_filtered_items_id);$i++)
		{
			$data=$this->Common_insert_model->delete_record($table_name,$condition_field,base64_decode($search_filtered_items_id[$i]));				
		}
		$url=base64_decode($redirect_url);
		redirect(base_url().$url);		
	}
	public function patient_general_survey_insert($patientId=0)
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$visistDate=date('Y-m-d');
		$pulse=$this->input->post('pulse');
		$bp_systolic=$this->input->post('systolic');
		$bp_diastolic=$this->input->post('diastolic');
		$temparature=$this->input->post('temparature');
		$rr=$this->input->post('rr');
		$height_ft=$this->input->post('height_ft');
		$height_cm=$this->input->post('height_cm');
		$general_survey_edit_flag=$this->input->post('general_survey_edit_flag');

		$data=array(
			"patient_uid"=>$patientId,
			"pulse"=>$this->input->post('pulse'),
			"bp_systolic"=>$this->input->post('systolic'),
			"bp_diastolic"=>$this->input->post('diastolic'),
			"temperature"=>$this->input->post('temperature'),
			"respiratory"=>$this->input->post('rr'),
			"spo2"=>$this->input->post('spo2'),
			"height_ft"=>$this->input->post('height_ft'),
			"height_cm"=>$this->input->post('height_cm'),
			"weight"=>$this->input->post('weight_kg'),
			"bmi"=>$this->input->post('bmi'),
			//"bsa"=>$this->input->post('bsa'),
			//"native_urine_output"=>$this->input->post('native_urine_output'),
			//"fluid_intake"=>$this->input->post('fluid_intake'),
			//"allergies"=>$this->input->post('allergies'),
			//"body_habits"=>$this->input->post('body_habits'),
			//"anemia"=>$this->input->post('anemia'),
			//"jaundice"=>$this->input->post('jaundice'),
			//"edema"=>$this->input->post('edema'),
			//"jvp"=>$this->input->post('jvp'),
			"visit_register_sequence"=>$currentVisitNo
		);
		if($general_survey_edit_flag==0)
		{
			//insert data
			$last_insert_id=$this->Common_insert_model->save_data($data,'visit_survey');
			
			//insert default examnames data if first time

/*			$examData=array(
			array(
				"patient_uid"=>$patientId,
				"visit_register_sequence"=>$currentVisitNo,
				"systematic_examination"=>"RS-vesicular Breath sound in all area"
			),
			array(
				"patient_uid"=>$patientId,
				"visit_register_sequence"=>$currentVisitNo,
				"systematic_examination"=>"CVS-S1S2 normaly audible no Murmur,Rub,Adv sound"
			),		
			array(
				"patient_uid"=>$patientId,
				"visit_register_sequence"=>$currentVisitNo,
				"systematic_examination"=>"Abd-Soft. No organomegaly. No free fluid"
			),
			array(
				"patient_uid"=>$patientId,
				"visit_register_sequence"=>$currentVisitNo,
				"systematic_examination"=>"CNS-NAD"
			)
			
			);//end of array	
*/
			//insert data
			//$this->Opd_model->insert_history_exam_name($examData,"multi"); 		
			
			
		}
		if($general_survey_edit_flag==1)
		{
			$update_record_id=base64_decode($this->input->post('general_survey_edit_recid'));
			//update data
			$this->Common_insert_model->update_data($data,'visit_survey','uid',$update_record_id);
		}

		//$this->session->set_flashdata('status', '1');
		//redirect(base_url()."Opd/history/".base64_encode($patientId)."/".base64_encode($currentVisitNo));		

	}	
	public function general_survey_dialysis_pt_insert($patientId=0)
	{
		$patientId=$this->input->post('patient_id');//base64_decode($patientId);
		$currentVisitNo=$this->input->post('current_visit_no');
		//$dialysis_pt_edit_flag=$this->input->post('dialysis_pt_edit_flag');
		
		$data=array(
			"patient_uid"=>$patientId,
			"dialysis_frequency"=>$this->input->post('dialysis_frequency'),
			"vascular_access"=>$this->input->post('vascular_access'),
			"intradialytic_weight_gain"=>$this->input->post('intradialytic_weight_gain'),
			"visit_register_sequence"=>$currentVisitNo
		);
/*		if($dialysis_pt_edit_flag==0)
		{*/
			//insert data
			$last_insert_id=$this->Common_insert_model->save_data($data,'visit_dialysis_pt');	
			
/*		}
		if($dialysis_pt_edit_flag==1)
		{
			//update data
			$this->Opd_model->update_table_data_for_all_dialysis_tx_pt('visit_dialysis_pt',$data);
		}

		$this->session->set_flashdata('status', '1');
		redirect(base_url()."Opd/history/".base64_encode($patientId)."/".base64_encode($currentVisitNo));		
*/
	}
	public function post_tx_pt_general_survey_insert($patientId=0)
	{
		$patientId=$this->input->post('patient_id');//base64_decode($patientId);
		$currentVisitNo=$this->input->post('current_visit_no');
		//$post_tx_pt_edit_flag=$this->input->post('post_tx_pt_edit_flag');
		
		$date_of_tx_new = str_replace('/', '-', $this->input->post('date_of_tx') );
		$date_of_tx=date('Y-m-d',strtotime($date_of_tx_new));
		
		$data=array(
			"patient_uid"=>$patientId,
			"date_of_tx"=>$date_of_tx,
			"graft_urine_output"=>$this->input->post('graft_urine_output'),
		//	"dsa_report"=>$this->input->post('dsa_report'),
		//	"dsa_date"=>date('Y-m-d',strtotime($this->input->post('dsa_report_date'))),
		//	"pra_report"=>$this->input->post('pra_report'),
		//	"pra_date"=>date('Y-m-d',strtotime($this->input->post('pra_report_date'))),
		//	"cross_match"=>$this->input->post('cross_match'),
		//	"cross_match_date"=>date('Y-m-d',strtotime($this->input->post('cross_match_date'))),
			"visit_register_sequence"=>$currentVisitNo
		);
/*		if($post_tx_pt_edit_flag==0)
		{*/
			//insert data
			$last_insert_id=$this->Common_insert_model->save_data($data,'visit_post_tx_pt');		
			
/*		}
		if($post_tx_pt_edit_flag==1)
		{
			//update data
			$this->Opd_model->update_table_data_for_all_dialysis_tx_pt('visit_post_tx_pt',$data);
		}

		$this->session->set_flashdata('status', '1');
		redirect(base_url()."Opd/history/".base64_encode($patientId)."/".base64_encode($currentVisitNo));		
*/
	}
	function patient_investigation_save()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$invstName=base64_decode($this->input->post('investigation_id'));

		$investigation_date_new = str_replace('/', '-', $this->input->post('investigation_date'));
		$investigation_date=date('Y-m-d',strtotime($investigation_date_new));		
		
		$invstValue=$this->input->post('investigation_value');
		$invstUnit=$this->input->post('investigation_unit');
		$data_source=$this->input->post('data_source');
		
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"parameter_uid"=>$invstName,
			"test_date"=>$investigation_date,
			"test_value"=>$invstValue,
			"data_source"=>$data_source,
			"unit_uid"=>$invstUnit
		);

		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_investigation');
		echo $last_insert_id;
	}
	function patient_history_save()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$hist_kb_category=$this->input->post('hist_kb_category');
		$hist_kb_organ=$this->input->post('hist_kb_organ');
		$kb_data_text=$this->input->post('kb_data_text');
		$hist_kb_month=$this->input->post('hist_kb_month');
		$hist_kb_year=$this->input->post('hist_kb_year');
		//$data_source=$this->input->post('data_source');
		
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"history_code"=>$kb_data_text,
			"history_organ"=>$hist_kb_organ,
			"history_category"=>$hist_kb_category,
			"month_occured"=>$hist_kb_month,
			"year_occured"=>$hist_kb_year
		);

		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_history');
		echo $last_insert_id;
	}	
	function save_advise_medicine()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$medicine_uid=base64_decode($this->input->post('medicine_uid'));
		$medicine_name=$this->input->post('medicine_name');
		$medicine_strength=$this->input->post('medicine_strength');
		$medicine_dose=$this->input->post('medicine_dose');
		$medicine_days=$this->input->post('medicine_days');
		$continue_flag=$this->input->post('continue_flag');
		
		//generic duplicate enrt check
		//get generic of selected medicine to check duplicate
		$count=0;
		//$response=$this->Opd_model->get_generic_ids_by_medicine_ids($medicine_uid);
		$response=$this->Common_fetch_model->fetch_medicine_generic_record($medicine_uid);
		if($response==true)
		{
			foreach($response as $record)
			{
				$count_response=$this->Common_fetch_model->check_generic_ids_duplicate_maching($record->generic_uid,$patientId,$currentVisitNo);			
				if($count_response->no_of_record>0)
					$count++;//used to stop same generic save
			}
		}		
		
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"medicine_name"=>$medicine_name,
			"medicine_uid"=>$medicine_uid,
			"medicine_strength"=>$medicine_strength,
			"medicine_dosage"=>$medicine_dose,
			"medicine_days"=>$medicine_days,
			"medicine_continue_flag "=>$continue_flag
			
		);

		//insert data
		//$this->Opd_model->save_advised_medicine($data);
		//echo "Patient advised medcine saved";
		//echo $count;
		if($count>0)
		{
			echo 0;
		}
		else
		{
			//insert data
			$last_insert_id=$this->Common_insert_model->save_data($data,'visit_medicine_advice');			
			echo $last_insert_id;
		}		
	}
	function save_advise_investigation()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$priority=$this->input->post('priority');
		$advise_investigation_uid=base64_decode($this->input->post('advise_investigation_uid'));
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"priority"=>$priority,
			"investigation_uid"=>$advise_investigation_uid
		);

		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_investigation_advice');			
		echo $last_insert_id;		
	}
	function save_advise_activity()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$advise_activity_uid=base64_decode($this->input->post('advise_activity_uid'));
		$data=array(
			"patient_uid"=>$patientId,
			"visit_register_sequence"=>$currentVisitNo,
			"advice_uid"=>$advise_activity_uid
		);

		//insert data
		//insert data
		$last_insert_id=$this->Common_insert_model->save_data($data,'visit_activity_advice');			
		echo $last_insert_id;	
	}
//--------------------------master data save /search---------------------	
	public function add_advice_record()
	{	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('advice_topic', 'Advice', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
		$advice_uid=base64_decode($this->input->post('enc_advice_id'));//used to edit
		
		$advice_topic=$this->input->post('advice_topic');
		$advice_type=$this->input->post('advice_type');
		$insertdata=array(
					"topic"=>$advice_topic,
					"trap"=>'61'
					);

		if($advice_uid=="")
			$last_inserted_advice_id=$this->Common_insert_model->save_data($insertdata,'masterdb');
		else
			$this->Common_insert_model->update_data($insertdata,'masterdb','uid',$advice_uid);
	
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Doctor/advice");
		}
		else
		{
			$this->advice();
		}		
	}
	function search_diagnosis()
	{
		$search_data=$this->input->post('search_data');
		$all_diagnosis_list=$this->Doctor_fetch_model->fetch_diagnosis_by_name($search_data);	
		foreach($all_diagnosis_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_items_id[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->diagnosis_name?></td>
				<td>&nbsp;</td>
                <td><a class="update-product" href="<?=base_url()?>Doctor/diagnosisAdd/<?=base64_encode($record->uid)?>" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}
	public function add_diagnosis_record()//master data save
	{	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('diagnosis', 'Diagnosis', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
		$diagnosis_uid=base64_decode($this->input->post('diagnosis_enc_id'));//used to edit
		
		$diagnosis=$this->input->post('diagnosis');
		$icd=$this->input->post('ICD');
		$description=$this->input->post('description');
		$symptom=$this->input->post('symptom');
		$insertdata=array(
					"diagnosis_name"=>$diagnosis,
					"icd"=>$icd,
					"description"=>$description,
					"symptom"=>$symptom
					);

		if($diagnosis_uid=="")
			$last_inserted_diagnosis_id=$this->Common_insert_model->save_data($insertdata,'diagnosis');
		else
			$this->Common_insert_model->update_data($insertdata,'diagnosis','uid',$diagnosis_uid);
	
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Doctor/diagnosisAdd");
		}
		else
		{
			$this->diagnosisAdd();
		}		
	}
	function search_complain()
	{
		$search_data=$this->input->post('search_data');
		$all_complain_list=$this->Doctor_fetch_model->fetch_complain_list_by_name($search_data);	
		foreach($all_complain_list as $record)
		{?>
              <tr>
                <td><input type="checkbox" name="search_filtered_items_id[]" value="<?=base64_encode($record->uid)?>"></td>
                <td><?=$record->complain?></td>
				<td>&nbsp;</td>
                <td><a class="update-product" data-toggle="modal" data-target="#myModal" onclick="edit_data('<?=base64_encode($record->uid)?>')" href="javascript:void(0)" title="Update" ><i class="fa fa-pencil"></i></a> <a  href="javascript:delete_list_items('<?=base64_encode($record->uid)?>')" title="Delete"><i class="fa fa-trash-o"></i></a> </td>
              </tr>			
		<?php
		}
	}	
	public function add_complain_record()//master data save
	{	   	
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('complain', 'Complain', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
		$complain_uid=base64_decode($this->input->post('complain_enc_id'));//used to edit
		
		$complain=$this->input->post('complain');
		$complain_details=$this->input->post('complain_details');
		$insertdata=array(
					"complain"=>$complain,
					"details"=>$complain_details
					);

		if($complain_uid=="")
			$last_inserted_advice_id=$this->Common_insert_model->save_data($insertdata,'complain');
		else
			$this->Common_insert_model->update_data($insertdata,'complain','uid',$complain_uid);
	
		$this->session->set_flashdata('success', 'Data Saved...');				
		redirect(base_url()."Doctor/complain");
		}
		else
		{
			$this->complain();
		}		
	}
	function edit_advice()
	{
		$advice_id=base64_decode($this->input->post('id'));
		$edit_advice_record=$this->Doctor_fetch_model->fetch_advise_activity_by_id($advice_id);	
		echo '{';
			echo '"uid":"'.base64_encode($edit_advice_record->uid).'",';
			echo '"topic":"'.$edit_advice_record->topic.'"';
		echo '}';
	}
	function edit_complain()
	{
		$complain_id=base64_decode($this->input->post('id'));
		$edit_complain_record=$this->Doctor_fetch_model->fetch_complain_by_id($complain_id);	
		echo '{';
			echo '"uid":"'.base64_encode($edit_complain_record->uid).'",';
			echo '"complain":"'.$edit_complain_record->complain.'",';
			echo '"details":"'.$edit_complain_record->details.'"';
		echo '}';
	}
	function historyRecord($pid=0,$visit_no=0)
	{
		
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		

//----------------------------old code---------------------------------
		if(base64_decode($pid)!=0 || isset($_SESSION['session_patient_id']))
		{			
			if(isset($_SESSION['session_patient_id']))
				$patient_uid=$_SESSION['session_patient_id'];
			else
				$patient_uid=base64_decode($pid);
			
			if(base64_decode($visit_no)!=0)
				$current_visit_no=base64_decode($visit_no);
			else
				$current_visit_no=$_SESSION['session_current_visit_no'];

			//get patient available investigation details
			$data['patient_investigation_details']=$this->Doctor_fetch_model->get_recent_saved_invst_record_history($patient_uid,$current_visit_no);		

			//get patient complain available details
			$data['patient_complain_details']=$this->Doctor_fetch_model->get_recent_saved_complain_history($patient_uid,$current_visit_no);		

			//get patient used medicine available details
			$data['patient_used_medicine_details']=$this->Doctor_fetch_model->get_recent_saved_medicine_used_history($patient_uid,$current_visit_no);			
			
			//fetch patient general survey
			$data['history_general_survey']=$this->Doctor_fetch_model->get_patient_saved_general_history($patient_uid,$current_visit_no);

			//fetch patients available diagnosis
			$data['history_diagnosis']=$this->Doctor_fetch_model->get_recent_saved_diagnosis($patient_uid,$current_visit_no);
			
			//fetch patients advised investigation
			$data['history_advised_investigation']=$this->Doctor_fetch_model->fetch_advise_investigation($patient_uid,$current_visit_no);
			
			//fetch saved advised activity
			$data['history_advised_activity']=$this->Doctor_fetch_model->fetch_advise_activity_name($patient_uid,$current_visit_no);					

			//fetch previous visit medicine
			$data['history_previous_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no-1);								
			
			//fetch saved advised activity
			$data['history_advised_medicine']=$this->Doctor_fetch_model->get_recent_saved_medicine_advise($patient_uid,$current_visit_no);					
			
			//fetch saved history
			$data['visit_kb_history_details']=$this->Doctor_fetch_model->fetch_saved_kb_hisory_details($patient_uid,$current_visit_no);					

			//fetch saved history questions
			//$data['history_default_exam']=$this->Doctor_fetch_model->get_default_hisory_examination_name($patient_uid,$current_visit_no);					


			//fetch patient vaccination
			//$data['patient_vaccination_data']=$this->Doctor_fetch_model->fetch_vaccine_detail_list($patient_uid);						

			//fetch dialysis_pt
			$data['dialysis_pt_data']=$this->Doctor_fetch_model->fetch_dialysis_pt_data($patient_uid,$current_visit_no);						
			//fetch tx waiting pt
			$data['tx_waiting_pt_data']=$this->Doctor_fetch_model->fetch_tx_waiting_pt_data($patient_uid,$current_visit_no);	
			//fetch patient vaccination
			$data['post_tx_data']=$this->Doctor_fetch_model->fetch_post_tx_data($patient_uid,$current_visit_no);	


			//fetch patient radiology data
			//$data['radio_data']=$this->Doctor_fetch_model->fetch_radiology_data($patient_uid,$current_visit_no);	
		}
			//fetch KB category and organ list
			$data['KB_cat']=$this->Doctor_fetch_model->kb_category();
			$data['KB_organ']=$this->Doctor_fetch_model->kb_organ();
			$this->load->model("researchModel/Research_fetch_model");
			$data['all_medicine_group']=$this->Research_fetch_model->fetch_all_medicine_group();	
		
//----------------------------old code---------------------------------		

		$this->load->view('doctor/history_taking.php',$data);
	}
	public function set_patient_session()
	{
		$patient_uid=$this->input->post('pid');
		$pname=$this->input->post('pname');
		$page=$this->input->post('page');
		$psex=$this->input->post('psex');
		if($psex==1)
			$psex_txt="Female";
		else
			$psex_txt="Male";
		
		//destroy previous session
		unset(
			$_SESSION['session_patient_id'],
			$_SESSION['session_patient_name'],
			$_SESSION['session_patient_age'],
			$_SESSION['session_patient_sex']
		);
		
		//insert visit no in visit register
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$num_rows=$this->Appointment_fetch_model->visit_check($patient_uid);
				
		if($num_rows==0)//visit register entry not done for today
		{
			//insert visit no in visit register
			$this->Appointment_fetch_model->insert_visit_no_in_visit_register($patient_uid);
		}		
		
		
		//get patient current visit no
		$visit_record=$this->Appointment_fetch_model->current_visit_no($patient_uid);
		if($visit_record)
			$current_visit_no=$visit_record->sequence;
		else
			$current_visit_no=0;
		
		$patient_session = array(
				'session_patient_id'  => $patient_uid,
				'session_patient_name'  => $pname,
				'session_patient_age'     => $page,
				'session_patient_sex'     => $psex_txt,
				'session_current_visit_no'     => $current_visit_no
		);

		$this->session->set_userdata($patient_session);

	}
	function clear_patient_session()
	{
		//destroy previous session
		unset(
			$_SESSION['session_patient_id'],
			$_SESSION['session_patient_name'],
			$_SESSION['session_patient_age'],
			$_SESSION['session_patient_age'],
			$_SESSION['session_current_visit_no']
		);
	}
	function get_appointment_data_for_doctor()
	{
		$clinic_id=$this->input->post('clinic');
		$doctor_id=$this->input->post('doctor_id');
		$appointment_mode=$this->input->post('appointment_mode');
		
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$response=$this->Appointment_fetch_model->fetch_appointment_list($clinic_id,$from_date,$to_date,$visitor_name="",$mobile="",$doctor_id,0,$appointment_mode);
		$sl=0;
		if(!empty($response))
		{
			foreach($response as $record)
			{
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->name?></td>
				<td><?=$record->patient_uid?></td>
				<td><?=date('d-m-Y',strtotime($record->approve_date))?><br/>
					<?=date('h:i:s A',strtotime($record->approve_time))?>
				</td>
				<td><?=(($record->app_mode==1)?"Clinic":(($record->app_mode==2)?"Online":""))?></td>
				<td><?=($record->app_type==1)?"New":(($record->app_type==2)?"Follow up":"")?></td>
				<!--<td><?=($record->patient_category==1)?"General":(($record->patient_category==2)?"VIP":"referral")?></td>-->
				<td>&nbsp;</td>
				<td><?=$record->clinic_name?></td>
				<td>
				<a href="javascript:void(0)"><i class="far fa-edit"></i></a>
				</td>
			  </tr>			
			<?php
				
			}
		}
	}
	function get_visit_history()
	{
		$patient_uid=$this->input->post('patient_id');
		$page_source=$this->input->post('page_source');
		if($page_source=="history_taking")
			$method="historyRecord";
		else if($page_source=="consultancy")
			$method="consultancy";
		else
		{}
		$response=$this->Doctor_fetch_model->fetch_visit_history($patient_uid);
		if(!empty($response))
		{
			$sl=0;
			foreach($response as $record)
			{
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->visit_date))?></td>
				<td><a href="<?=base_url()?>Doctor/<?=$method?>/<?=base64_encode($patient_uid)?>/<?=base64_encode($record->sequence)?>" ><?=$record->sequence?></a></td>
			  </tr>			
			<?php
				
			}
		}		
	}
	function get_billed_patient()
	{
		$clinic_id=$this->input->post('clinic_id');
		$doctor_id=$this->input->post('doctor_id');
		$date_new = str_replace('/', '-', $this->input->post('date') );
		$date=date('Y-m-d',strtotime($date_new));		
		//get the billed patient
		$this->load->model('billingModel/Billing_fetch_model');
		$billed_patient_list=$this->Billing_fetch_model->fetch_billing_completed_patient_list_date_wise($clinic_id,$doctor_id,$date);

		  $sl=0;
		  foreach($billed_patient_list as $record)
		  {
				if(($record->dob!=""))
				{
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($record->dob));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
				}			  
		  ?>
			<tr>
			  <th scope="row"><?=++$sl?></th>
			  <td><a href="javascript:void(0)" onclick="set_patient_session(<?=$record->patient_uid?>,'<?=$record->full_name?>',<?=$cur_age?>,<?=$record->sex?>)" ><?=$record->full_name?></a></td>
			  <td><?=$cur_age?></td>
			</tr>
		<?php
		  }
	
	}
	function set_history_done()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$insertdata=array(
		"patient_uid"=>$patientId,
		"sequence"=>$currentVisitNo,		
		"state_flag"=>1,
		"state_updated_by"=>$_SESSION['loggedUserId']
		);
		$this->load->model('doctorModel/Doctor_insert_model');
		$response=$this->Doctor_insert_model->set_history_done($insertdata,'visit_register');		
	}
	function add_knowledge_base_data()
	{
		$kb_category=$this->input->post('kb_category');
		$kb_organ=$this->input->post('kb_organ');
		$data_text=$this->input->post('data_text');
		$return_url=$this->input->post('return_url');
		$insertdata=array(
		"kb_category"=>$kb_category,
		"kb_organ"=>$kb_organ,
		"data_text"=>$data_text
		);
		$response=$this->Common_insert_model->save_data($insertdata,'history_KB');		
		redirect(base_url('Doctor/'.$return_url));		
	}
	function get_kb_data_text()
	{
		$category_value=$this->input->post('category_value');
		$organ_value=$this->input->post('organ_value');
		$response=$this->Doctor_fetch_model->fetch_kb_data_text($category_value,$organ_value);		
		foreach($response as $record)
		{
			echo '<option value="'.$record->uid.'">'.$record->data_text.'</option>';
		}
	}
	function get_KB_visit_history()
	{
		$patient_uid=$this->input->post('patient_id');
		$current_visit_no=$this->input->post('current_visit_no');
		$history_organ=$this->input->post('taken_history_organ');
		$history_category=$this->input->post('taken_history_category');
		$page_source=$this->input->post('page_source');
		if($page_source=="history_taking")
			$method="historyRecord";
		else if($page_source=="consultancy")
			$method="consultancy";
		else
		{}
		$response=$this->Doctor_fetch_model->fetch_visist_kb_hisory_details($patient_uid,$current_visit_no,$history_category,$history_organ);
		if(!empty($response))
		{
			$sl=0;
			foreach($response as $record)
			{
			?>
			  <tr>
				<td><?=++$sl?></td>
				<td><?=$record->month_occured."/".$record->year_occured?></td>
				<td><?=$record->data_text?></td>
			  </tr>			
			<?php
				
			}
		}		
	}
	function save_advise_medicine_group()
	{
		$patientId=$this->input->post('patient_id');
		$currentVisitNo=$this->input->post('current_visit_no');
		$group_id=$this->input->post('group_id');
		$continue_flag=$this->input->post('continue_flag');
		
		$c=0;
		//get medicine details from group
		$this->load->model('researchModel/Research_fetch_model');
		$medicineResponse=$this->Research_fetch_model->fetch_medicine_details_from_group($group_id);
		foreach($medicineResponse as $record)
		{
			//generic duplicate enrt check
			//get generic of selected medicine to check duplicate
			$count=0;
			//$response=$this->Opd_model->get_generic_ids_by_medicine_ids($medicine_uid);
			$response=$this->Common_fetch_model->fetch_medicine_generic_record($record->medicine_id);
			if($response==true)
			{
				foreach($response as $record)
				{
					$count_response=$this->Common_fetch_model->check_generic_ids_duplicate_maching($record->generic_uid,$patientId,$currentVisitNo);			
					if($count_response->no_of_record>0)
						$count++;//used to stop same generic save
				}
			}		
			//get medicine name
			$mednameResponse=$this->Common_fetch_model->fetch_prevdb_medicine_record($record->medicine_id);
			if(!empty($mednameResponse))
			{
				$data=array(
					"patient_uid"=>$patientId,
					"visit_register_sequence"=>$currentVisitNo,
					"medicine_name"=>$mednameResponse->med_name,
					"medicine_uid"=>$record->medicine_id,
					"medicine_strength"=>$record->strength,
					"medicine_dosage"=>$record->dose,
					"medicine_days"=>$record->days,
					"medicine_continue_flag "=>0
					
				);

				//insert data
				//$this->Opd_model->save_advised_medicine($data);
				//echo "Patient advised medcine saved";
				//echo $count;
					//insert data
					$last_insert_id=$this->Common_insert_model->save_data($data,'visit_medicine_advice');			
					//echo $last_insert_id;
					$c++;
			}
		
		}//end foreach
		if($c>0)
			echo 1;//successful
		else
			echo 0;//unsuccessful
	}//end function	
		

}

?>