<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Gateway extends CI_Controller 
{
	public function __construct() 
	{
		parent::__construct();
		$this->load->model('gatewayModel/Gateway_model');
		$this->load->model('commonModel/Common_fetch_model');
	}
	public function index()
	{
		//get clicnic location 
		$responseData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		
		$this->load->view('portallogin.php',$responseData);
		
	}
	
	public function portallogin()
	{
		//$response_data['miscSettings']=$this->Gateway_model->miscSettings_fetch();//receiving all data
		//get clicnic location 
		$responseData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		
		$this->load->view('portallogin.php',$responseData);
		
	}
	public function logout()
	{
		//destroy current session
		session_destroy();
		//load home
		redirect(base_url());		
	}

	public function login_validation()//module login authorization check
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('user_mobile', 'User Mobile', 'required|numeric');
		$this->form_validation->set_rules('user_password', 'User Password', 'required');
	    if($this->form_validation->run()!= FALSE)
        {		
			//input login form data from the login page
			$username=$this->input->post("user_mobile");
			$password=$this->input->post("user_password");
			$clinic_id=$this->input->post("clinic");

			$authenticationResult=$this->Gateway_model->loginAuthentication($username,$password,$clinic_id);//receiving login authentication data

			if($authenticationResult==true)//user available
			{		
				
				//fetch module name
				$module_name_data=$this->Common_fetch_model->fetch_module_name($authenticationResult[0]['default_module_id']);
				$clinic_data=$this->Common_fetch_model->fetch_clinic_details($clinic_id);
				
				//set session value when successfully logged in_array
				$loginfo = array(
					   'userLoggedin'  => TRUE,
					   'loggedUserId'  =>  $authenticationResult[0]['uid'],
					   'fullname'	=> $authenticationResult[0]['full_name'],
					   'default_module'	=> $module_name_data->module_name,
					   'desig'	=> $authenticationResult[0]['designation'],
					   'allowed_group'	=> $authenticationResult[0]['allowed_group'],
					   'clinicId'	=> $clinic_id,
					   'print_with_header_flag'	=> $clinic_data->print_with_header_flag,
					   'clinic_name'	=> $clinic_data->clinic_name
				   );
				$this->session->set_userdata($loginfo);
				/*$authenticationResult[0]['full_name']*/

				//load OPD/index
				redirect(base_url().$_SESSION['default_module'].'/dashboard');

			}
			else
			{echo "alert";
				$this->session->set_flashdata('error','Record Not Found');
				$this->index();//reload login page if invalid password found//
			}
		
		}
		else
		{
			//get clicnic location
			$responseData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		
			$this->load->view('index2',$responseData);
		}		
	}	
	
	
}
