<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class HR extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		
		//fetch logged user's modules ***this method is require for all pages***
		$this->load->model('gatewayModel/Gateway_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('hrModel/Hr_fetch_model');
		$this->load->model('hrModel/Hr_insert_model');
	}
	public function dashboard()//hr dash board
	{
		$this->load->model('Gateway_model');
		$responseData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);		
		
		//$this->load->view('hr/header');
		$this->load->view('hr/hr_dashboard',$responseData);
	}
	public function logout()
	{
		//destroy current session
		session_destroy();
		//load System/index
		redirect(base_url());//load->view('System/index');		
	}
	function doctorData()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_doctor_list']=$this->Hr_fetch_model->fetch_doctor_list($no_of_record);//descending order				
		$this->load->view('hr/doctor_data',$data);
	}
	function doctorAdd($update_id="")
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['departments']=$this->Common_fetch_model->fetch_department();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		if($update_id!="")
		{
			$edit_id=$update_id;
			$data['doctor_record']=$this->Common_fetch_model->fetch_selected_doctor_detail($edit_id);						
			
		}
		$this->load->view('hr/doctor_add',$data);
	}
	
	function employeeData()
	{
		$no_of_record=0;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_employee_list']=$this->Hr_fetch_model->fetch_employee_list($no_of_record);//descending order				
		
		$this->load->view('hr/employee_data',$data);
	}
	function employeeAdd($update_id="")
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['module_name']=$this->Common_fetch_model->fetch_all_module_name();
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_group']=$this->Common_fetch_model->fetch_all_group_name();
		if($update_id!="")
		{
			$edit_id=$update_id;
			$data['employee_record']=$this->Common_fetch_model->fetch_selected_doctor_detail($edit_id);//will work for emp also						
			
		}		
		$this->load->view('hr/employee_add',$data);
	}
	
	
	//==================
	public function fetch_district_list()
	{	
		$statecode=$this->input->post('stateUid');	
		$this->load->model('commonModel/Common_fetch_model');
		$responseData['districtName']=$this->Common_fetch_model->fetch_district($statecode);
		$js = 'class="form-control" id="district"';
		echo form_dropdown('district',$responseData['districtName'],'',$js);
	}
		// ----------- HR Menu Show Method Start   -------------------------------------------


	function module()
	{
		$responseData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);		
		$this->load->view('hr/header');
		$this->load->view('hr/allot_module_menu',$responseData);		
	}

	
	
	// -----------  HR Menu Show Method End      ------------------
  // *****************  Employee search list/all record show/save Start *****************
	//-------------- Search List Start -------------------
	function fetch_employee_list()
	{
		$text=$this->input->post('text');		
		$data=$this->Hr_fetch_model->fetch_employee_list($text);

			?>
			<!--<ul ><!--class="dropdown-menu total_search"-->
			<?php
		foreach($data as $record)
		{
		
			?>
			
			<li><a class="dropdown-item" href="javascript:" onclick="get_employee('<?=base64_encode($record->uid)?>','<?=$record->full_name?>')"><?=$record->full_name?></a></li>
			<?php				

		}//end of foreach
			?>		
			<!--</ul>-->
			<?php		
	}
	//-------------- Search List End 	--------------------
	
	//-------------- Fectch All Record End --------------------	
		public function fetch_employee_details()
		{
		$uid=base64_decode($this->input->post('uid'));
		$response=$this->Hr_fetch_model->fetch_employee_record($uid);

		echo "{";
			echo '"uid":"'.$response->uid.'",';
			echo '"salutation":"'.$response->salutation.'",';
			echo '"full_name":"'.$response->full_name.'",';
			echo '"gender":"'.$response->gender.'",';
			echo '"type":"'.$response->type.'",';
			echo '"reg_no":"'.$response->reg_no.'",';
			echo '"mobile":"'.$response->mobile.'",';
			echo '"email":"'.$response->email.'",';
			echo '"category":"'.$response->category.'",';
			echo '"designation":"'.$response->designation.'",';
			echo '"qualification":"'.$response->qualification.'",';
			echo '"department":"'.$response->department.'",';
			echo '"address1":"'.$response->address1.'",';
			echo '"police_station":"'.$response->police_station.'",';
			echo '"state":"'.$response->state.'",';
			echo '"district":"'.$response->district.'",';
			echo '"pin":"'.$response->pin.'",';
			echo '"pan_no":"'.$response->pan_no.'",';
			echo '"aadhar_no":"'.$response->aadhar_no.'",';
			echo '"bank_account":"'.$response->bank_account.'",';
			echo '"ifsc_code":"'.$response->ifsc_code.'",';
			echo '"bank_name":"'.$response->bank_name.'",';
			echo '"clinic_uid":"'.$response->clinic_uid.'"';
		echo "}";	
		
	}
	//-------------- Fectch All Record End --------------------	
	// -----------  Employee Save/Edit Start   ------------------
	public function add_employee()
	{	
	    $uid=$this->input->post('uid');
	    $salutation=$this->input->post('salutation');
		$name=$this->input->post('full_name');
		$gender=$this->input->post('gender');
		$type=$this->input->post('type');
		$reg_no=$this->input->post('reg_no');//doc only
		$mobile=$this->input->post('mobile');
		$email=$this->input->post('email');
		$category=$this->input->post('category');//doc only
		$designation=$this->input->post('designation');
		$qualification=$this->input->post('qualification');
		$department=$this->input->post('department');
		$address1=$this->input->post('address1');
		$police_station=$this->input->post('police_station');
		$city=$this->input->post('city');//emp only
		$state=$this->input->post('state');
		$district=$this->input->post('district');
		$pin=$this->input->post('pin');
		$pan_no=$this->input->post('pan_no');
		$aadhar_no=$this->input->post('aadhar_no');
		$bank_account=$this->input->post('bank_account');
		$branch=$this->input->post('branch');//emp only
		$ifsc_code=$this->input->post('ifsc_code');
		$bank_name=$this->input->post('bank_name');
	    $clinic_uid=$this->input->post('clinic_uid');
	    $default_module=$this->input->post('default_module');//emp only
	    $allowed_group=$this->input->post('allowed_group');//emp only
		if($uid=="0")//save
		
		{        $insertdata=array(
		            "salutation"=>$salutation,
					"full_name"=>$name,
					"gender"=>$gender,
					"type"=>$type,
					"reg_no"=>$reg_no,
					"mobile"=>$mobile,
					"email"=>$email,
					"category"=>$category,
					"designation"=>$designation,
					"qualification"=>$qualification,
					"department"=>$department,
					"address1"=>$address1,
					"police_station"=>$police_station,
					"state"=>$state,
					"district"=>$district,
					"pin"=>$pin,
					"pan_no"=>$pan_no,
					"aadhar_no"=>$aadhar_no,
					"bank_account"=>$bank_account,
					"ifsc_code"=>$ifsc_code,
					"bank_name"=>$bank_name,
					"clinic_uid"=>$clinic_uid,
					
					"city"=>$city,
					"branch_name"=>$branch,
					"default_module_id"=>$default_module,
					"allowed_group"=>$allowed_group
					
					);
		        $this->Hr_insert_model->add_new_employee($insertdata);	
	        } 	
	        else
		    {
			        $insertdata=array(
					"uid"=>$uid,
				    "salutation"=>$salutation,
					"full_name"=>$name,
					"gender"=>$gender,
					"type"=>$type,
					"reg_no"=>$reg_no,
					"mobile"=>$mobile,
					"email"=>$email,
					"category"=>$category,
					"designation"=>$designation,
					"qualification"=>$qualification,
					"department"=>$department,
					"address1"=>$address1,
					"police_station"=>$police_station,
					"state"=>$state,
					"district"=>$district,
					"pin"=>$pin,
					"pan_no"=>$pan_no,
					"aadhar_no"=>$aadhar_no,
					"bank_account"=>$bank_account,
					"ifsc_code"=>$ifsc_code,
					"bank_name"=>$bank_name,
                    "clinic_uid"=>$clinic_uid,

					"city"=>$city,
					"branch_name"=>$branch,
					"default_module_id"=>$default_module,
					"allowed_group"=>$allowed_group					

					);

			        $this->Hr_insert_model->update_employee_record($insertdata);
		    }
	    redirect(base_url()."HR/dashboard");
	
	
	
	
	}
	// -----------  New Employee Save End      ------------------
   //-------------------Module allotment------------------------
   function user_module_allotment()
   {
	$user_id=base64_decode($this->input->post('uid'));
	$modules=$this->input->post('modules');
	$menu=$this->input->post('menu');

	$insertdata = array();

	foreach ($menu as $i => $name) {

		$module_id=substr($menu[$i],0,2);//extract first two digit as module id
		$insertdata[] = array(
		"employee_uid"=>$user_id,
		"module_uid"=>(int) $module_id,
		"menu_id"=>$menu[$i]
		);

	};		

		$this->Hr_insert_model->user_module_allotment($insertdata);	
	    redirect(base_url()."Hr/module");	   
   }
   
   function fetch_employee_alloted_menus()
   {
		$user_id=base64_decode($this->input->post('uid'));
		$response=$this->Hr_fetch_model->fetch_employee_alloted_menus($user_id);

		$data=array();
		$i=0;
		foreach($response as $record)
		{
			$data[$i]=$record->menu_id;
			$i++;
		}
		print_r($data);
   }
   
   
   //-------------------Module allotment------------------------
   
 //---------------------- Doctor ADD Start ---------------------------//
	function add_doctor_record()
	{	
	    $uid=$this->input->post('uid');
		$name=$this->input->post('full_name');
		$gender=$this->input->post('gender');
		$department=$this->input->post('department');
		$qualification=$this->input->post('qualification');
		$reg_no=$this->input->post('reg_no');
		$designation=$this->input->post('designation');
		$mobile=$this->input->post('mobile');
		$mobile2=$this->input->post('mobile2');
		$email=$this->input->post('email');
		$address1=$this->input->post('address1');
		$city=$this->input->post('city');
		$pin=$this->input->post('pin');
		$state=$this->input->post('state');
		$district=$this->input->post('district');
		$aadhar_no=$this->input->post('aadhar_no');
		$pan_no=$this->input->post('pan_no');
		$bank_account=$this->input->post('bank_account');
	    $ifsc_code=$this->input->post('ifsc_code');
	    $bank_name=$this->input->post('bank_name');
	    $branch_name=$this->input->post('branch_name');
	    $active_flag=$this->input->post('active_flag');
			if($uid=="0")//save
			{        $insertdata=array(
					"salutation"=>'Dr.',
					"full_name"=>$name,
					"gender"=>$gender,
					"department"=>$department,
					"qualification"=>$qualification,
					"reg_no"=>$reg_no,
					"address1"=>$address1,
					"designation"=>$designation,
					"mobile"=>$mobile,
					"mobile2"=>$mobile2,
					"email"=>$email,
					"city"=>$city,
					"pin"=>$pin,
					"state"=>$state,
					"district"=>$district,
					"aadhar_no"=>$aadhar_no,
					"pan_no"=>$pan_no,
					"bank_account"=>$bank_account,
					"bank_name"=>$bank_name,
					"ifsc_code"=>$ifsc_code,
					"branch_name"=>$branch_name,
					"type"=>1,
					"active_flag"=>$active_flag
					);
		        $this->Common_insert_model->save_data($insertdata,'employee');	
	        } 	
	        else
		    {
			    $insertdata=array(
					"full_name"=>$name,
					"gender"=>$gender,
					"department"=>$department,
					"qualification"=>$qualification,
					"reg_no"=>$reg_no,
					"address1"=>$address1,
					"designation"=>$designation,
					"mobile"=>$mobile,
					"mobile2"=>$mobile2,
					"email"=>$email,
					"city"=>$city,
					"pin"=>$pin,
					"state"=>$state,
					"district"=>$district,
					"aadhar_no"=>$aadhar_no,
					"pan_no"=>$pan_no,
					"bank_account"=>$bank_account,
					"bank_name"=>$bank_name,
					"ifsc_code"=>$ifsc_code,
					"branch_name"=>$branch_name,
					"active_flag"=>$active_flag
					);

			        $this->Common_insert_model->update_data($insertdata,'employee','uid',$uid);
		    }
	    redirect(base_url()."HR/doctorAdd");
	
	
	
	
	}

 
 
 
 
 
 
 //--------------------- Doctor ADD End ---------------------------------//

 	function pageGroupListing($group_name="")
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_pages']=$this->Common_fetch_model->fetch_all_page_name();		
		$data['all_group_name']=$this->Common_fetch_model->fetch_all_group_name();
		//get group name to fetch group information
		if(base64_decode($group_name)!="")
		{
			$data['group_details']=$this->Common_fetch_model->fetch_group_details(base64_decode($group_name));
		}
		$this->load->view('hr/group_listing',$data);
	}
	function save_group()
	{
		$group_name=$this->input->post('group_name');
		$update_group_name=base64_decode($this->input->post('update_group_name'));
		$page_codes_arr=$this->input->post('page_codes');
		$create_arr=$this->input->post('create');
		$view_arr=$this->input->post('view');
		$edit_arr=$this->input->post('edit');
		$delete_arr=$this->input->post('delete');
		
		if($update_group_name!="")//if update request then delete previous data of the group
		{
			$response=$this->Common_insert_model->delete_record('group_page','group_name',$update_group_name);
		}

		if(!empty($page_codes_arr) && count($page_codes_arr)>0)
		{			
			$data = array();

			foreach ($page_codes_arr as $i => $name) {
				
				$create=$edit=$view=$delete=0;
				if (!empty($create_arr) && in_array($page_codes_arr[$i], $create_arr))
				{
					$create=1;
				}
				if (!empty($view_arr) && in_array($page_codes_arr[$i], $view_arr))
				{
					$view=1;
				}
				if ( !empty($edit_arr) &&in_array($page_codes_arr[$i], $edit_arr))
				{
					$edit=1;
				}
				if (!empty($delete_arr) && in_array($page_codes_arr[$i], $delete_arr))
				{
					$delete=1;
				}				

				$data[] = array(
				"page_uid"=>$page_codes_arr[$i],
				'group_name' => $group_name,
				'create_flag' => $create,
				'view_flag' => $view,
				'edit_flag' => $edit,
				'delete_flag' => $delete
				
				);

			};
			$this->Common_insert_model->save_batch_data($data,'group_page');			
		}

		redirect(base_url()."HR/pageGroupListing");		
	}
	function agentList()
	{
		$no_of_record=0;//all record
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_doctor_list']=$this->Hr_fetch_model->fetch_agent_list($no_of_record,'DESC');//descending order				
		$this->load->view('hr/agent_data',$data);
	}
	function agentAdd($update_id="")
	{
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		if($update_id!="")
		{
			$edit_id=$update_id;
			$data['agent_record']=$this->Hr_fetch_model->fetch_selected_agent_detail($edit_id);						
			
		}
		$this->load->view('hr/agent_add',$data);
	}	
	function add_agent_record()
	{	
	    $uid=$this->input->post('uid');
		$name=$this->input->post('full_name');
		$gender=$this->input->post('gender');
		$mobile=$this->input->post('mobile');
		$commission=$this->input->post('commission');
		$aadhar_no=$this->input->post('aadhar_no');
	    $show_app=$this->input->post('show_app');
	    $active_flag=$this->input->post('active_flag');
		if(!($this->input->post('show_app')))
		{
			$show_app=0;
		}
		if(!($this->input->post('active_flag')))
		{
			$active_flag=0;
		}		
			if($uid=="0")//save
			{        $insertdata=array(
					"full_name"=>$name,
					"gender"=>$gender,
					"mobile"=>$mobile,
					"commission"=>$commission,
					"aadhar_no"=>$aadhar_no,
					"show_app"=>$show_app,
					"active_flag"=>$active_flag
					);
		        $this->Common_insert_model->save_data($insertdata,'agent_master');	
	        } 	
	        else
		    {
			    $insertdata=array(
					"full_name"=>$name,
					"gender"=>$gender,
					"mobile"=>$mobile,
					"commission"=>$commission,
					"aadhar_no"=>$aadhar_no,
					"show_app"=>$show_app,
					"active_flag"=>$active_flag
					);

			        $this->Common_insert_model->update_data($insertdata,'agent_master','uid',$uid);
		    }
	    redirect(base_url()."HR/agentAdd?sc=105");
	}
}
?>