<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class IPD extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		$this->load->model('appointmentModel/Appointment_fetch_model');
		$this->load->model('ipdModel/Ipd_fetch_model');
		$this->load->model('billingModel/Billing_fetch_model');
		//$this->load->model('adminModel/Admin_fetch_model');
		//$this->load->model('pharmacyModel/Pharmacy_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	//************************appointment dash board start**********
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$userModuleData['country']=$this->Common_fetch_model->fetch_country();
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department();
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('ipd/ipd_dashboard',$userModuleData);
	}
		//************************appointment dash board End **********

	function patientAdmission($admission_no="")
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');		

		if($admission_no!="")
		{
			$adm_no=base64_decode($admission_no);
			$data['admission_record']=$this->Ipd_fetch_model->fetch_admitted_patient_info($adm_no);		
			$data['kin_record']=$this->Ipd_fetch_model->fetch_patient_kin_info($adm_no);		
		}
		$this->load->view('ipd/patient_admission',$data);
	}
	 function ipdBilling()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');					
		$data['all_services']=$this->Common_fetch_model->fetch_all_service_list();		
		
		$this->load->view('ipd/billing_ipd',$data);
	}
	function patientDischarge()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('ipd/patient_discharge',$data);
	}
	function new_patient_short_registration()
	{
		$patient_uid=$this->input->post('patient_id');
		$update_flag=$this->input->post('update_flag');
		$admission_record_id=$this->input->post('admission_record_id');
		
		$patient_name=$this->input->post('patient_name');
		$gender=$this->input->post('gender');		
		$mobile=$this->input->post('mobile');		
		$phone=$this->input->post('alternative_no');		
		$address1=$this->input->post('address1');	
		$address2=$this->input->post('address2');
		$police_station=$this->input->post('police_station');
		$blood_group=$this->input->post('blood_group');	
		$diet=$this->input->post('diet');
		$city=$this->input->post('city');		
		$state_code=$this->input->post('state_code');		
		$district=$this->input->post('district');		
		$country_code=$this->input->post('country_code');		
		$pin=$this->input->post('pin');
		$old_tbl_data_flag=$this->input->post('old_tbl_data_flag');

		
		$dob_new = str_replace('/', '-', $this->input->post('dob') );
		$dob=date('Y-m-d',strtotime($dob_new));
				
		$age=$this->input->post('age');
		$ageflag=$this->input->post('ageflag');

		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('patient_id', 'Patient ID', 'trim|numeric');
		$this->form_validation->set_rules('patient_name', 'Patient Name', 'trim|required');
		$this->form_validation->set_rules('mobile', 'Mobile', 'trim|required|exact_length[10]|numeric');
		$this->form_validation->set_rules('address1', 'Address 1', 'trim|required');
		$this->form_validation->set_rules('city', 'City', 'trim|required');
		$this->form_validation->set_rules('police_station', 'Police Station', 'trim|required');
		$this->form_validation->set_rules('state_code', 'Patient State', 'required|numeric');
		$this->form_validation->set_rules('district', 'Patient District', 'required|numeric');
		$this->form_validation->set_rules('country_code', 'Patient Country', 'required|numeric');
		$this->form_validation->set_rules('pin', 'Patient PIN', 'trim|required|numeric|exact_length[6]');
		$this->form_validation->set_rules('kin_name', 'Kin Name', 'trim|required');
	//	$this->form_validation->set_rules('kin_mobile ', 'Kin Mobile', 'trim|required|exact_length[10]|numeric');
	//	$this->form_validation->set_rules('kin_address1 ', 'Kin Address', 'trim|required');
		$this->form_validation->set_rules('kin_city', 'Kin City', 'trim|required');
		$this->form_validation->set_rules('kin_ps', 'Kin Police Station', 'trim|required');
		$this->form_validation->set_rules('kin_pin', 'Kin\'s PIN', 'trim|required|numeric|exact_length[6]');
		$this->form_validation->set_rules('adm_date', 'Admission Date', 'required');
		$this->form_validation->set_rules('adm_time', 'Admission Time', 'required');
		$this->form_validation->set_rules('treating_doctor', 'Treating Doctor', 'required|is_natural_no_zero');
		$this->form_validation->set_rules('bed', 'Bed', 'required|is_natural_no_zero');
	    if($this->form_validation->run()!= FALSE)
        {

			if($ageflag==1)
			{
				$current_year=date('Y');
				$past_year=$current_year-$age;
				$dob=$past_year."-01-01";
			}
			if($ageflag==2)
			{
				$dob_new = str_replace('/', '-', $this->input->post('dob') );
				$dob=date("Y-m-d",strtotime($dob_new));
					
			}		


			$data=array(
					"full_name"=>$patient_name,
					"sex"=>$gender,
					"dob"=>$dob,
					"blood_group"=>$blood_group,
					"mobile"=>$mobile,
					"phone"=>$phone,
					"address1"=>$address1,
					"address2"=>$address2,
					"city"=>$city,
					"police_station"=>$police_station,
					"state_code"=>$state_code,
					"district"=>$district,
					"country"=>$country_code,
					"pin"=>$pin,
					"diet"=>$diet,
					"employee_uid"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:i:s')					
				);
				//$data['dob']=$dob;		
				//$data['address2']=$address2;
				//$data['police_station']=$police_station;
			//	$data['diet']=$diet;

			//if patient id already exist then dont insert same patient
			if($patient_uid=="")//for fresh new patient
			{
				$patient_uid=$this->Common_insert_model->save_data($data,'patient');
	//------------------temp code------------------------------------------
					//old patient table save
					$insertdata2=array(
						"patientUid"=>$patient_uid,
						//"age"=>$responseData->age,
						"patientName"=>$patient_name,
						"patientSex"=>$gender,
						"patientDOB"=>$dob,
						"PatientMobile"=>$mobile,
						"patientPhone"=>$phone,
						//"patientEmail"=>$responseData->email,
						"patientCity"=>$city,
						"PatientPin"=>$pin,
						"patientCountry"=>$country_code//country code will not match with old patient table format
					);
					$this->Common_insert_model->save_data_for_prevDb($insertdata2,'patient_mast');
					


	//------------------temp code------------------------------------------
			
			
			}
			
			if($update_flag!=1 && $patient_uid>0)
			{
				//insert for old patient table followup patient.if old followup patient not available
				//in new patient table then insert it into new patient table.
				
				//check if follow up patient available in new table or not
				$response=$this->Billing_fetch_model->fetch_patient_reg_record($patient_uid);
				if(!empty($response))//if any data found
				{
					$updateData=array(
							"blood_group"=>$blood_group,
							"mobile"=>$mobile,
							"phone"=>$phone,
							"address1"=>$address1,
							"address2"=>$address2,
							"city"=>$city,
							"police_station"=>$police_station,
							"state_code"=>$state_code,
							"district"=>$district,
							"country"=>$country_code,
							"pin"=>$pin,
							"diet"=>$diet,
							"employee_uid"=>$_SESSION['loggedUserId'],
							"entry_date_time"=>date('Y-m-d H:i:s')						
						);
					if($patient_uid!="" || $patient_uid>0)
					{
						$this->Common_insert_model->update_data($updateData,'patient','uid',$patient_uid);
						//$patient_uid_new=$patient_uid;
						$old_tbl_data_flag=0;
					}
				
				}
				else
				{
					//if age available of old patient then work with age
					$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_uid);			
					if(!empty($old_patient_list))
					{
							if($old_patient_list->patientDOB=="" || $old_patient_list->patientDOB=="1970-01-01")
							{
								$cur_age=$old_patient_list->patientAge;
								//dob calculation from age as 1st jan of year
								$current_year=date('Y');
								$past_year=$current_year-$cur_age;
								$calculated_dob=$past_year."-01-01";				
							}
							else
							{
								$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
								$today = date("Y-m-d");
								$diff = date_diff(date_create($dateOfBirth), date_create($today));
								$cur_age=$diff->format('%y');
								
								$calculated_dob=$old_patient_list->patientDOB;
							}
							$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
							
								
							$salutation=$old_patient_list->patientSalutation;
							$patient_name=$old_patient_list->patientName;
							$gender=$old_patient_list->patientSex;		
							$dob=$calculated_dob;		
							$blood_group=$old_patient_list->patientBlood;		
							$mobile=$old_patient_list->PatientMobile;		
							$alternative_no=$old_patient_list->patientPhone;		
							$address1=$old_patient_list->patientAdd1;
							$address2=$old_patient_list->patientAdd2;
							$city=$old_patient_list->patientCity;		
							$state_code=10037;//$old_patient_list->PatientState;		
							$district=1003710;//$old_patient_list->patientDist;		
							$country_code=76;//$old_patient_list->patientCountry;		
							$pin=$old_patient_list->PatientPin;	
							$patient_type=$old_patient_list->patientName;	
							$email_id=$old_patient_list->patientEmail;
							$ps=$old_patient_list->patientPs;
							
							$guardian_name=$old_patient_list->patientGurdian;
							$relation_guardian=$old_patient_list->patientRelation;
							$aadhaar=$old_patient_list->patientAadhaar;
							$passport=$old_patient_list->patientPassport;
							$visa=$old_patient_list->patientVisa;
							$race=$old_patient_list->patientRace;
							$occupation=$old_patient_list->occupation;
							$photo_url=$old_patient_list->photo_url;
							$fcm_reg=$old_patient_list->fcm_reg;
							
							$data=array(
								"old_puid"=>$patient_uid,
								"salutation"=>$salutation,
								"full_name"=>$patient_name,
								"sex"=>$gender,
								"dob"=>$dob,
								"blood_group"=>$blood_group,
								"mobile"=>$mobile,
								"phone"=>$alternative_no,
								"address1"=>$address1,
								"address2"=>$address2,
								"city"=>$city,
								"state_code"=>$state_code,
								"district"=>$district,
								"country"=>$country_code,
								"pin"=>$pin,
								"email"=>$email_id,
								"police_station"=>$ps,
								"Month_of_registration"=>date("m"),
								"Year_of_registration"=>date("Y"),
								"employee_uid"=>$_SESSION['loggedUserId'],
								"entry_date_time"=>date('Y-m-d H:i:s'),

								"guardian_name"=>$guardian_name,				
								"relation_guardian"=>$relation_guardian,				
								"aadhaar"=>$aadhaar,				
								"passport"=>$passport,				
								"visa"=>$visa,				
								"race"=>$race,				
								"occupation"=>$occupation,				
								"photo_url"=>$photo_url,				
								"fcm_reg"=>$fcm_reg
							
							);

						$patient_uid_new=$this->Common_insert_model->save_data($data,'patient');
					}		
						$insertdata_old=array(
						"patient_uid_new"=>$patient_uid_new,
						"isset_patient"=>1,
						);				
						$this->Common_insert_model->update_data_prevDb($insertdata_old,'patient_mast','patientUid',$patient_uid);
						
						$data3['patient_uid']=$patient_uid_new;
						$data3['old_patient_uid']=$patient_uid;						
							
				}
			}
			if($update_flag==1)//edit patient table
			{
				$this->Common_insert_model->update_data($data,'patient','uid',$patient_uid);
					
			}


			//save admission records

			$adm_date_new = str_replace('/', '-', $this->input->post('adm_date') );
			$adm_date=date('Y-m-d',strtotime($adm_date_new));
			
			$adm_time=$this->input->post('adm_time');		
		
			$sponsor=$this->input->post('sponsor');		
			$source=$this->input->post('source');		
			$billing_category=$this->input->post('billing_category');		
			$treating_doctor=$this->input->post('treating_doctor');		
		
			$refer_doctor=$this->input->post('refer_doctor');		
			//$building=$this->input->post('building');
		
			//$ward=$this->input->post('ward');
			$bed=$this->input->post('bed');

		
			$data3=array(
					"adm_date"=>$adm_date,
					"adm_time"=>$adm_time,
					"sponsor"=>$sponsor,
					"source"=>$source,
					"billing_category"=>$billing_category,
					"treating_doctor"=>$treating_doctor,
					"reffer_doctor"=>$refer_doctor,
					"bed_uid"=>$bed,
					"entry_by"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:m:s')
				
				);
				if($old_tbl_data_flag==1 && $patient_uid>0 && $update_flag!=1)
				{
					$data3['patient_uid']=$patient_uid_new;
					$data3['old_patient_uid']=$patient_uid;
				}
				else
				{
					$data3['patient_uid']=$patient_uid;
				}
			if($update_flag!=1)
			{
				$adm_no=$this->Common_insert_model->save_data($data3,'admission_record');
			}
			
			
			if($update_flag==1)//edit patient table
			{
				$updatedata3=array(
					"adm_date"=>$adm_date,
					"adm_time"=>$adm_time,
					"sponsor"=>$sponsor,
					"source"=>$source,
					"billing_category"=>$billing_category,
					"treating_doctor"=>$treating_doctor,
					"reffer_doctor"=>$refer_doctor,
					"entry_by"=>$_SESSION['loggedUserId'],
					"entry_date_time"=>date('Y-m-d H:m:s')
				
				);			
				$this->Common_insert_model->update_data($updatedata3,'admission_record','uid',$admission_record_id);
					
			}


			//save kin records
			$kin_name=$this->input->post('kin_name');
			$kin_relationship=$this->input->post('kin_relationship');		
		
			$mobile=$this->input->post('kin_mobile');		
			$alternative_no=$this->input->post('kin_alt_no');		
			$address=$this->input->post('kin_address1');
			$address2=$this->input->post('kin_address2');
			$city=$this->input->post('kin_city');		
			$ps=$this->input->post('kin_ps');
			$country_code=$this->input->post('kin_country_code');		
			$pin=$this->input->post('kin_pin');
			

			if($update_flag!=1)
			{
			$data2=array(
					"ipd_admission_uid"=>$adm_no,
					"kin_name"=>$kin_name,
					"kin_relationship"=>$gender,
					"mobile"=>$mobile,
					"mobile2"=>$alternative_no,
					"address1"=>$address,
					"address2"=>$address2,
					"city"=>$city,
					"ps"=>$ps,
					"country"=>$country_code,
					"pin"=>$pin,
				
				);
				if($old_tbl_data_flag==1 && $patient_uid>0 && $update_flag!=1)
				{
					$data2['patient_uid']=$patient_uid_new;
				}
				else
				{
					$data2['patient_uid']=$patient_uid;
				}

				$this->Common_insert_model->save_data($data2,'patient_kin');
			}
			if($update_flag==1)//edit
			{
				$updatedata2=array(
					"kin_name"=>$kin_name,
					"kin_relationship"=>$gender,
					"mobile"=>$mobile,
					"mobile2"=>$alternative_no,
					"address1"=>$address,
					"address2"=>$address2,
					"city"=>$city,
					"ps"=>$ps,
					"country"=>$country_code,
					"pin"=>$pin,
				
				);			
				$this->Common_insert_model->update_data($updatedata2,'patient_kin','ipd_admission_uid',$admission_record_id);
					
			}		

			
			//update bed vaccant flag
			$data4=array(
					"vaccant_flag"=>1,
					"uid"=>$bed			
				);		
			if($update_flag!=1)
			{
				$this->Common_insert_model->update_data($data4,'bed_master','uid',$bed);
						

				redirect(base_url()."IPD/patientAdmission?adm=".$adm_no);
			}
			if($update_flag==1)
			{
				redirect(base_url()."IPD/patientAdmission?sc=105");
			}
		}
		else
		{
			$this->patientAdmission();
		}
	}
	function load_bed()
	{
		$building=$this->input->post('building');		
		$ward=$this->input->post('ward');
		if($this->input->post('bed_status'))
			$bed_status=$this->input->post('bed_status');
		else
			$bed_status=0;//vaccant
		
		$response=$this->Ipd_fetch_model->fetch_vaccant_bed($building,$ward,$bed_status);
		foreach($response as $record)
		{
			?>
			<option value="<?=$record->uid?>"><?=$record->bed_no?></option>
			<?php				
		}
	}
	function get_admitted_patient_list()
	{
		$clinic=$this->input->post('clinic');		
		$building=$this->input->post('building');		
		$ward=$this->input->post('ward');		
		$bed=$this->input->post('bed');		
		$response=$this->Ipd_fetch_model->fetch_admitted_patient_list($bed);
		//print_r($response);die();

		$sl=0;
		foreach($response as $record)
		{
			?>
			<tr onclick="select_patient(<?=$record->uid?>)" data-dismiss="modal" style="cursor:pointer">
			<td><?=++$sl?></td>
			<td><?=$record->bed_no?></td>
			<td><?=$record->full_name?></td>
			<td><?=$record->patient_uid?></td>
			</td>
			<?php				
		}
	}
	function get_admitted_patient_info()
	{
		$adm_id=$this->input->post('rec_id');				
		$response=$this->Ipd_fetch_model->fetch_admitted_patient_info($adm_id);
		//print_r($response);die();
		if($response->sponsor==1)
			$sponsor_text="Cash";
		else if($response->sponsor==2)
			$sponsor_text="Insurance";
		else if($response->sponsor==3)
			$sponsor_text="CGHS";
		else if($response->sponsor==4)
			$sponsor_text="WBHS";
		else		
			$sponsor_text="";

		  //current age calculate
		  $dateOfBirth = date('Y-m-d',strtotime($response->dob));
		  $today = date("Y-m-d");
		  $diff = date_diff(date_create($dateOfBirth), date_create($today));
		  $cur_age=$diff->format('%y');
			
		echo "{";
		echo '"admission_no":"'.$response->uid.'",';		
		echo '"patient_uid":"'.$response->patient_uid.'",';		
		echo '"patient_name":"'.$response->full_name.'",';		
		echo '"patient_age":"'.$cur_age.'",';		
		echo '"admission_date":"'.date('d-m-Y',strtotime($response->adm_date)).'",';		
		echo '"bed":"'.$response->bed_no.'",';		
		echo '"patient_name":"'.$response->full_name.'",';		
		echo '"treating_doctor_name":"'.$response->treating_doctor_name.'",';				
		echo '"sponsor":"'.$sponsor_text.'"';				
		echo "}";		
	}
	function get_add_services_items()
	{
		$services=$this->input->post('services');				
		$search_item=$this->input->post('search_item');
		if($services==101)
		{
			$response=$this->Common_fetch_model->fetch_doctor_by_name($search_item);
			foreach($response as $record)
			{
				//get doctor fees
				$feesresponse=$this->Common_fetch_model->get_doctor_fees($record->uid);
				echo '<li onclick="set_item('.$record->uid.",'".$record->full_name.'\','.$feesresponse->consultation_ip_fees.')" style="cursor:pointer">'.$record->full_name.'</li>';
			}
		}
		else if($services==103 || $services==104)
		{
			$response=$this->Common_fetch_model->fetch_investigation_by_name($search_item,$services);
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->test_name.'\','.$record->fees.')" style="cursor:pointer">'.$record->test_name.'</li>';			
		}
		else if($services==111)//pharma
		{
			$response=$this->Common_fetch_model->fetch_medicine_list_by_name($search_item);
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->medicine_name.'\',0)" style="cursor:pointer">'.$record->medicine_name.'</li>';			
		}
		else if($services==105 || $services==106 || $services==114 || $services==107 || $services==108 || $services==109 || $services==110 || $services==112 || $services==113 || $services==115)//procedure
		{
			$response=$this->Common_fetch_model->fetch_charge_list_by_name($search_item,$services);			
			foreach($response as $record)
				echo '<li onclick="set_item('.$record->uid.",'".$record->item_name.'\','.$record->amount.')" style="cursor:pointer">'.$record->item_name.'</li>';			
		}
		//print_r($response);die();		
	}
	function add_service_for_ipdbilling()
	{
		$service_patient_id=$this->input->post('service_patient_id');				
		$sub_services=$this->input->post('sub_services');				
		$patient_admission_no=$this->input->post('patient_admission_no');				
		$services=$this->input->post('services');				
		$item_id=$this->input->post('item_id');		
		$quantity=$this->input->post('quantity');		
		$amount=$this->input->post('service_amount');		
		$discount=$this->input->post('discount');		
		$net=$this->input->post('net');		
	
		$service_date_new = str_replace('/', '-', $this->input->post('service_date') );
		$service_date=date('Y-m-d',strtotime($service_date_new));
		
		$data=array(
				//"bill_no"=>$adm_date,
				"patient_uid"=>$service_patient_id,
				"admission_no"=>$patient_admission_no,
				"service_uid"=>$services,
				"date_of_service"=>$service_date,
				"service_amount"=>$amount,
				"discount_amount"=>$discount,
				"gross_amount"=>$net,
				"quantity"=>$quantity,
				"clinic_uid"=>$_SESSION['clinicId'],
				"employee_uid"=>$_SESSION['loggedUserId'],
				"bill_date"=>date('Y-m-d H:m:s')
			
			);
			if($services==101)
			{
				$data['item_id']=$sub_services;
				$data['doctor_id']=$item_id;
			}
			else			
			{
				$data['item_id']=$item_id;
				$data['doctor_id']=0;				
			}

		$rec_id=$this->Common_insert_model->save_data($data,'billing_ipd');
		
	}
	function search_services()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->search_services($from_date,$to_date,$patient_admission_no);					
		$sl=0;
		foreach($response as $record)
		{
			if($record->service_uid==101)
				$service_txt="Doctor Fees";
			else if($record->service_uid==102)
				$service_txt="Administrative";
			else if($record->service_uid==103)
				$service_txt="Diagnostics(Lab)";
			else if($record->service_uid==104)
				$service_txt="Diagnostics(Non Lab)";
			else if($record->service_uid==105)
				$service_txt="Dialysis";			
			else if($record->service_uid==106)
				$service_txt="Procedure";
			else if($record->service_uid==107)
				$service_txt="OT";
			else if($record->service_uid==108)
				$service_txt="Hospital Services";
			else if($record->service_uid==109)
				$service_txt="Bed Charges";
			else if($record->service_uid==110)
				$service_txt="Service Charges";
			else if($record->service_uid==111)
				$service_txt="Pharmacy";
			else if($record->service_uid==112)
				$service_txt="Consumable";
			else if($record->service_uid==113)
				$service_txt="Miscellaneous";
			else if($record->service_uid==114)
				$service_txt="Package";
			else if($record->service_uid==115)
				$service_txt="Instrument Charges";			
			else
				$service_txt="";
			
			
			
			?>
			<tr>
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->date_of_service))?></td>
				<td><?=$service_txt?></td>
				<td><?=$record->gross_amount?></td>
			</tr>
			<?php
		}
	}
	function ipdreceipt()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');				
		$data['all_payment_mode']=$this->Common_fetch_model->fetch_all_payment_mode();						
		$data['employee_level_discount']=$this->Common_fetch_model->fetch_employee_level_discount($_SESSION['loggedUserId']);		
		$data['admin_employee']=$this->Common_fetch_model->fetch_all_employee_name(3);//$type=pass any type if req.		
		$this->load->view('ipd/receipt',$data);
	}
	function admissionRegister()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');			
		$data['all_admitted_patient_list']=$this->Ipd_fetch_model->fetch_all_admitted_patient_list(20);
		$this->load->view('ipd/Ipd_admission_register.php',$data);
	}
	function bedStatus()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch		
		$data['all_admitted_patient_list']=$this->Ipd_fetch_model->fetch_all_admitted_patient_list(20);
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');			
		$this->load->view('ipd/bed_status.php',$data);
	}
	function search_admission_by_pidAdmissionBed()
	{
		$search_by=$this->input->post('search_by');
		$search_data=$this->input->post('search_data');
		$response=$this->Ipd_fetch_model->fetch_admitted_patient_by_pidAdmissionBed($search_by,$search_data);				

		$sl=0;
		foreach($response as $record)
		{
		?>
		  <tr>
			<td><?=++$sl?></td>
			<td><?=date('d-m-Y',strtotime($record->adm_date))?></td>
			<td><?=$record->uid?></td>
			<td><?=$record->patient_uid?></td>
			<td><?=$record->patient_name?></td>
			<td><?=$record->misc_name?></td> 
			<td><?=$record->bed_no?></td>
            <td><a href="<?=base_url()."IPD/patientAdmission/".base64_encode($record->uid)?>" target="_blank" title="Edit Admission"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></td>			
		  </tr>
		<?
		}
				
	}
	function search_admission_by_dateBed()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('date_from') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('date_to') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$bed_id=$this->input->post('bed_id');		
		
		$response=$this->Ipd_fetch_model->fetch_admitted_patient_by_dateBed($from_date,$to_date,$bed_id);				

		$sl=0;
		foreach($response as $record)
		{
		?>
		  <tr>
			<td><?=++$sl?></td>
			<td><?=date('d-m-Y',strtotime($record->adm_date))?></td>
			<td><?=$record->uid?></td>
			<td><?=$record->patient_uid?></td>
			<td><?=$record->patient_name?></td>
			<td><?=$record->misc_name?></td> 
			<td><?=$record->bed_no?></td>
			<td><a href="<?=base_url()."IPD/patientAdmission/".base64_encode($record->uid)?>" target="_blank" title="Edit Admission"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a></td> 			
		  </tr>
		<?
		}		
	}
	function search_patient_services_summery()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->fetch_patient_services_summery($from_date,$to_date,$patient_admission_no);					
		$sl=0;
		$total_services=0;
		foreach($response as $record)
		{
			if($record->service_uid==101)
				$service_txt="Consultation";
			else if($record->service_uid==103)
				$service_txt="Lab";
			else if($record->service_uid==104)
				$service_txt="Non Lab";
			else if($record->service_uid==105)
				$service_txt="Dialysis";			
			else if($record->service_uid==106)
				$service_txt="Procedure";
			else if($record->service_uid==107)
				$service_txt="OT";
			else if($record->service_uid==108)
				$service_txt="Hospital Services";
			else if($record->service_uid==111)
				$service_txt="Pharmacy";
			else if($record->service_uid==112)
				$service_txt="Consumable";
			else if($record->service_uid==109)
				$service_txt="Bed";
			else if($record->service_uid==110)
				$service_txt="Service Charges";
			else if($record->service_uid==113)
				$service_txt="Miscellaneous";
			else if($record->service_uid==114)
				$service_txt="Package";
			else if($record->service_uid==115)
				$service_txt="Instrument";			
			else
				$service_txt="";
			

			?>
			<tr>
				<td><?=$service_txt?></td>
				<td><?=$record->total_quantity?></td>
				<td><?=$record->total_gross_amount?></td>
			</tr>
			<?php
			$total_services+=$record->total_gross_amount;
		}
	}
	function search_patient_transaction_summery()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->fetch_patient_transaction_summery($from_date,$to_date,$patient_admission_no);					
		$sl=0;
		foreach($response as $record)
		{
			if($record->payment_mode==1)
				$payment_mode_txt="Cash";
			else if($record->payment_mode==2)
				$payment_mode_txt="Debit Card";
			else if($record->payment_mode==3)
				$payment_mode_txt="Credit Card";
			else if($record->payment_mode==4)
				$payment_mode_txt="Cheque";
			else if($record->payment_mode==5)
				$payment_mode_txt="UPI/Wallet";			
			else
				$payment_mode_txt="";
			
			?>
			<tr>
				<td><?=++$sl?></td>
				<td><?=date('d-m-Y',strtotime($record->voucher_date))?></td>
				<td><?=$payment_mode_txt?></td>
				<td><?=$record->net_amount?></td>
			</tr>
			<?php
		}
	}
	function calculate_patient_services_total()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->fetch_patient_services_summery($from_date,$to_date,$patient_admission_no);					
		$total_services=0;
		foreach($response as $record)
		{
			$total_services+=$record->total_gross_amount;
		}
		echo $total_services;
	}
	
	function calculate_patient_transaction_total()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));

		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->fetch_patient_transaction_summery($from_date,$to_date,$patient_admission_no);					
		$total_transaction=0;
		foreach($response as $record)
		{
			
			$total_transaction+=$record->net_amount;
			
		}
		echo $total_transaction;
	}	
	function save_receipt()
	{
		$dor_new = str_replace('/', '-', $this->input->post('dor') );
		$dor=date('Y-m-d',strtotime($dor_new));
		
		$tor=date('H:i:s',strtotime($this->input->post('tor')));
		$mode=$this->input->post('mode');
		$cheque_approve_no=$this->input->post('cheque_approve_no');
		$amount=$this->input->post('amount');
		$toward=$this->input->post('toward');
		$remarks=$this->input->post('remarks');
		$admission_no=$this->input->post('admission_no');
		$patient_uid=$this->input->post('patient_uid');
		//if($amount<0)
			//$special_discount=$amount;
		//$special_discount_reason=$this->input->post('special_discount_reason');
		//$special_discount_approved_by=$this->input->post('special_discount_approved_by');
		
		$prefix="NCSLKIPR/";
		$data=array(
				"voucher_date"=>$dor,
				"receipt_prefix"=>$prefix,
				"payment_mode"=>$mode,
				"net_amount"=>$amount,
				"card_instrument_no"=>$cheque_approve_no,
				"toward"=>$toward,
				"voucher_time"=>$tor,
				"remarks"=>$remarks,
				"admission_no"=>$admission_no,
				"patient_uid"=>$patient_uid,
				//"discount_reason"=>$special_discount_reason,
				//"discount_approved_by"=>$special_discount_approved_by,
				"employee_uid"=>$_SESSION['loggedUserId'],
				"entry_date_time"=>date('Y-m-d H:i:s')					
			);
			//if($amount<0)
				//$data['special_discount']=$special_discount;
		
		$receipt_no=$this->Common_insert_model->save_data($data,'bill_receipt');				
		//set temp session to print bill
		$this->session->set_flashdata('temp_print_receipt_no', $receipt_no);
				
		redirect(base_url()."IPD/ipdReceipt?sc=105");		
		
	}
	function printReceipt($receipt_no)
	{
		if($receipt_no!=0)
		{

				//get patient personal details and invoice no and invoice date
				$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);
				//get patient receipt details
				$data['patient_recipt_details']=$this->Ipd_fetch_model->fetch_patient_receipt_details($receipt_no);
				$patient_uid=$data['patient_recipt_details']->patient_uid;
				$admission_no=$data['patient_recipt_details']->admission_no;
				//get patient personal details
				$data['patient_personal_record']=$this->Common_fetch_model->get_patient_basic_details($patient_uid);
				$data['admission_details']=$this->Ipd_fetch_model->fetch_admitted_patient_info($admission_no);
				//get patient payment details
				//$data['patient_payment_details']=$this->Billing_fetch_model->get_patient_payment_details($receipt_uid);
							
		
				$this->load->view('ipd/print_ipd_receipt.php',$data);
	
		}
	}
	function search_sub_services()
	{
		$service_id=$this->input->post('service_id');		
		$category=$this->input->post('category');		
		$response=$this->Ipd_fetch_model->fetch_sub_services($service_id,$category);
		foreach($response as $record)
		{
		?>
			<option value="<?=$record->uid?>" > <?=$record->item_name?> </option> 
		<?
		}		
		
		
	}
	function printIpFinalBill($admission_no=0)
	{	
		if($admission_no!=0)
		{
			//get patient personal details and invoice no and invoice date
			$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);
			//get patient details
			$data['admitted_patient_details']=$this->Ipd_fetch_model->fetch_admitted_patient_info($admission_no);
			$patient_uid=$data['admitted_patient_details']->patient_uid;
			//get patient personal details
			$data['patient_personal_record']=$this->Common_fetch_model->get_patient_basic_details($patient_uid);
			//get bill master details
			$data['bill_master_record']=$this->Ipd_fetch_model->fetch_bill_info_ip($admission_no);
			//get service id by bill no
			$service_id=$this->Ipd_fetch_model->fetch_service_id_by_admission_no($admission_no);
			$data['service_given']=$this->Ipd_fetch_model->fetch_service_id_by_admission_no($admission_no);		
			//$i=0;
			foreach($service_id as $row)
			{	

				switch($row->service_uid)
				{
					case 101: // doctor fees
						$data['consultation_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,101);
						break;
					case 102: // Administrative
						$data['administrative_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,102);
						break;
					case 103: // Diagnostics LAB
						$data['investigation_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,103);
						break;
					case 104: // Diagnostics NON LAB
						$data['investigationNL_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,104);
						break;
					case 105: // Dialysis
						$data['dialysis_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,105);
						break;		
					case 106: // Procedure
						$data['procedure_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,106);
						break;
					case 107: // OT
						$data['ot_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,107);
						break;
					case 108: // Hospital services
						$data['hospital_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,108);
						break;
					case 109: // BED
						$data['BED_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,109);
						break;
					case 110: // Service Charges
						$data['servicecharge_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,110);
						break;
					case 111: // Pharmacy
						$data['pharmacy_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,111);
						break;
					case 112: // Consumable
						$data['consumable_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,112);
						break;
					case 113: // Miscellaneous
						$data['miscellaneous_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,113);
						break;
					case 114: // Packages
						$data['packages_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,114);
						break;
					case 115: // Instrument
						$data['instrument_details']=$this->Ipd_fetch_model->fetch_patient_service_details($admission_no,115);
						break;	
					default:					
						break;
				}
					
			}
		//$data['patient_service_details']=$patient_services;
		//get patient payment details
			$data['patient_payment_details']=$this->Ipd_fetch_model->fetch_patient_payment_details($admission_no);
			$data['bill_info']=$this->Ipd_fetch_model->fetch_bill_info_ip($admission_no);
			$this->load->view('ipd/print_ipd_final_bill',$data);
		}
	}
	function printIpSummeryBill($admission_no=0)
	{	
		if($admission_no!=0)
		{
			//get patient personal details and invoice no and invoice date
			$data['clinic_details']=$this->Common_fetch_model->fetch_clinic_details($_SESSION['clinicId']);
			//get patient details
			$data['admitted_patient_details']=$this->Ipd_fetch_model->fetch_admitted_patient_info($admission_no);
			$patient_uid=$data['admitted_patient_details']->patient_uid;
			//get patient personal details
			$data['patient_personal_record']=$this->Common_fetch_model->get_patient_basic_details($patient_uid);
			//get bill master details
			$data['bill_master_record']=$this->Ipd_fetch_model->fetch_bill_info_ip($admission_no);
			//get service id by bill no
			$service_id=$this->Ipd_fetch_model->fetch_service_id_by_admission_no($admission_no);
			$data['service_given']=$this->Ipd_fetch_model->fetch_service_id_by_admission_no($admission_no);		
			//$i=0;
			foreach($service_id as $row)
			{	

				switch($row->service_uid)
				{
					case 101: // doctor fees
						$data['consultation_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,101);
						break;
					case 102: // Administrative
						$data['administrative_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,102);
						break;
					case 103: // Diagnostics LAB
						$data['investigation_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,103);
						break;
					case 104: // Diagnostics NON LAB
						$data['investigationNL_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,104);
						break;
					case 105: // Dialysis
						$data['dialysis_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,105);
						break;		
					case 106: // Procedure
						$data['procedure_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,106);
						break;
					case 107: // OT
						$data['ot_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,107);
						break;
					case 108: // Hospital services
						$data['hospital_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,108);
						break;
					case 109: // BED
						$data['BED_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,109);
						break;
					case 110: // Service Charges
						$data['servicecharge_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,110);
						break;
					case 111: // Pharmacy
						$data['pharmacy_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,111);
						break;
					case 112: // Consumable
						$data['consumable_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,112);
						break;
					case 113: // Miscellaneous
						$data['miscellaneous_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,113);
						break;
					case 114: // Packages
						$data['packages_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,114);
						break;
					case 115: // Instrument
						$data['instrument_details']=$this->Ipd_fetch_model->fetch_patient_service_total_amount($admission_no,115);
						break;	
					default:					
						break;
				}
					
			}
		//$data['patient_service_details']=$patient_services;
		//get patient payment details
			$data['patient_payment_details']=$this->Ipd_fetch_model->fetch_patient_payment_details($admission_no);
			$data['bill_info']=$this->Ipd_fetch_model->fetch_bill_info_ip($admission_no);
			$this->load->view('ipd/print_ipd_summery_bill',$data);
		}
	}
	function ipdBill()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
		$data['building_location']=$this->Common_fetch_model->fetch_all_building_list('1');				
		$this->load->view('ipd/ipd_bill',$data);
	}
	
	function search_patient_transaction_with_receiptNo()
	{
		$from_date_new = str_replace('/', '-', $this->input->post('from_date') );
		$from_date=date('Y-m-d',strtotime($from_date_new));
		$from_date="";
		$to_date_new = str_replace('/', '-', $this->input->post('to_date') );
		$to_date=date('Y-m-d',strtotime($to_date_new));
		$to_date="";
		$patient_admission_no=$this->input->post('patient_admission_no');
				
		
		$response=$this->Ipd_fetch_model->fetch_patient_transaction_summery($from_date,$to_date,$patient_admission_no);					

		$sl=0;
		foreach($response as $record)
		{
			if($record->payment_mode==1)
				$payment_mode_txt="Cash";
			else if($record->payment_mode==2)
				$payment_mode_txt="Debit Card";
			else if($record->payment_mode==3)
				$payment_mode_txt="Credit Card";
			else if($record->payment_mode==4)
				$payment_mode_txt="Cheque";
			else if($record->payment_mode==5)
				$payment_mode_txt="UPI/Wallet";			
			else
				$payment_mode_txt="";
			
			?>
			<tr>
				<td><?=$record->uid?></td>
				<td><?=date('d-m-Y',strtotime($record->voucher_date))?></td>
				<td><?=$record->net_amount?></td>
				<td><a href="<?=base_url()?>IPD/printReceipt/<?=$record->uid?>" target="_blank" title="Receipt Reprint"><i class="fa fa-print" aria-hidden="true">
				</i></a></td>
			</tr>
			<?php
		}
	}
	function discharge_patient()
	{
		$patient_admission_no=$this->input->post('adm_no');
		$patient_id=$this->input->post('pid');
		$bill_total=$this->input->post('bill_total');
		$total_paid=$this->input->post('total_paid');
		$discount=$this->input->post('discount');
		$discount_reason=$this->input->post('discount_reason');
		$discharge_time=date('H:i:s',strtotime($this->input->post('discharge_time')));
		$discharge_date_new = str_replace('/', '-', $this->input->post('discharge_date') );
		$discharge_date=date('Y-m-d',strtotime($discharge_date_new));		
		$response=$this->Ipd_fetch_model->fetch_admitted_patient_info($patient_admission_no);					
		if($response->discharge_date=="" && $response->discharge_time=="")
		{
			$updateData=array(
				"discharge_date"=>$discharge_date,
				"discharge_time"=>$discharge_time
				
			);
			$this->Common_insert_model->update_data($updateData,'admission_record','uid',$patient_admission_no);
			//update vaccant bed
			$data=array(
				"vaccant_flag"=>0
				
			);
			$this->Common_insert_model->update_data($data,'bed_master','uid',$response->bed_uid);
			//get treating doctor
			$docResponse=$this->Ipd_fetch_model->fetch_admitted_patient_info($patient_admission_no);
			$ipBillPrefix="NCSLKIP/";
			$insertdata=array(
				"bill_prefix"=>$ipBillPrefix,
				"patient_uid"=>$patient_id,
				"gross_amount"=>$bill_total,
				"discount_amount"=>$discount,
				"discount_reason"=>$discount_reason,
				"net_amount"=>$total_paid,
				"bill_section"=>2,
				"bill_date"=>$discharge_date,
				"treating_doctor"=>$docResponse->treating_doctor,
				"clinic_uid"=>$_SESSION['clinicId'],
				"employee_uid"=>$_SESSION['loggedUserId'],
				"entry_date_time"=>date('Y-m-d H:i:s')
				
			);
			$bill_id=$this->Common_insert_model->save_data($insertdata,'billing_master');
			//update bill no in billing ipd
			$updateData=array(
				"bill_no"=>$ipBillPrefix.$bill_id
			);
			$this->Common_insert_model->update_data($updateData,'billing_ipd','admission_no',$patient_admission_no);
			//receipt table update for billmaster uid
			$updateData=array(
				"billmast_uid"=>$bill_id
			);
			$this->Common_insert_model->update_data($updateData,'bill_receipt','admission_no',$patient_admission_no);
			//receipt table update for billmaster uid
			$updateData=array(
				"admission_no"=>$patient_admission_no
			);
			$this->Common_insert_model->update_data($updateData,'billing_master','uid',$bill_id);
																			
		}
	}
}

?>