<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Patient extends CI_Controller 
{
	public function __construct() 
	{
		parent::__construct();
		$this->load->model('gatewayModel/Gateway_model');
		$this->load->model('patientModel/Patient_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
	}
	public function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('pportal/patient_dashboard',$userModuleData);
	}
    function registration()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$data['all_departments']=$this->Common_fetch_model->fetch_department();
		$data['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();		
		$data['country']=$this->Common_fetch_model->fetch_country();
		$data['stateName']=$this->Common_fetch_model->fetch_state();
		$data['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('pportal/patient_registration.php',$data);
	}
	function get_patient_name_list_using_filter()
	{
		$patient_id=$this->input->post('patient_id');
		$patient_name=$this->input->post('patient_name');
		$mobile=$this->input->post('mobile');
		$param_flag=$this->input->post('param_flag');
		//$patient_list=$this->Dialysis_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);
		

		if($param_flag==2)//for search by name or/And mobile
		{
			$patient_list=$this->Common_fetch_model->fetch_patient_using_search_filter($patient_id,$patient_name,$mobile);
			foreach($patient_list as $record)
			{
				//$curryear=date('Y-m-d');
				//$curryear=date_create_from_format('Y-m-d');
				if(($record->dob!=""))
				{
				  //current age calculate
				  $dateOfBirth = date('Y-m-d',strtotime($record->dob));
				  $today = date("Y-m-d");
				  $diff = date_diff(date_create($dateOfBirth), date_create($today));
				  $cur_age=$diff->format('%y');
				}
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($record->sex);
				 
				?>
				  <tr>
					<td><a href="javascript:void(0)" data-dismiss="modal" onclick="select_patient_from_list(<?=$record->uid?>,'<?=$record->full_name?>','<?=$sexage?>',<?=$record->mobile?>)"><?=$record->uid?></a></td>
					<td><?=$record->old_puid?></td>
					<td><?=$record->full_name?></td>
					<td><?=$record->mobile?></td>
				  </tr>			
			<?php
			}
		}
		if($param_flag==1)//for search by patient id only
		{
			$patient_list=$this->Billing_fetch_model->fetch_patient_reg_record($patient_id);
			if(!empty($patient_list))
			{
				$dateOfBirth = date('Y-m-d',strtotime($patient_list->dob));
				$today = date("Y-m-d");
				$diff = date_diff(date_create($dateOfBirth), date_create($today));
				$cur_age=$diff->format('%y');
				
				$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($patient_list->sex);
				
				echo "{";
				echo '"patient_uid":"'.$patient_list->uid.'",';
				echo '"patient_name":"'.$patient_list->full_name.'",';
				echo '"agesex":"'.$sexage.'",';
				echo '"mobile":"'.$patient_list->mobile.'"';
				echo "}";
			}
			else
			{//if data found on new db then search old database
				$old_patient_list=$this->Billing_fetch_model->fetch_patient_record_from_prevdb($patient_id);			
				if(!empty($old_patient_list))
				{
					$dateOfBirth = date('Y-m-d',strtotime($old_patient_list->patientDOB));
					$today = date("Y-m-d");
					$diff = date_diff(date_create($dateOfBirth), date_create($today));
					$cur_age=$diff->format('%y');
					
					$sexage=$cur_age." Years / ".$this->Common_fetch_model->fetch_sex_txt($old_patient_list->patientSex);
					
					echo "{";
					echo '"uid":"'.$old_patient_list->patientUid.'",';
					echo '"full_name":"'.$old_patient_list->patientName.'",';
					echo '"agesex":"'.$sexage.'",';
					echo '"mobile":"'.$old_patient_list->PatientMobile.'"';
					echo "}";
				}			
			}
		}
	}
	function get_patient_data_from_new_patient_table()
	{
			$pid=$this->input->post('pid');
			//if selected patient name found from new table
			$responseData=$this->Common_fetch_model->get_patient_basic_details($pid);

			//current age calculate
			  $dateOfBirth = date('Y-m-d',strtotime($responseData->dob));
			  $today = date("Y-m-d");
			  $diff = date_diff(date_create($dateOfBirth), date_create($today));
			  $cur_age=$diff->format('%y');		
			echo "{";
			echo '"salutation":"'.$responseData->salutation.'",';
			echo '"pname":"'.$responseData->full_name.'",';
			echo '"age":"'.$cur_age.'",';
			echo '"gender":"'.$responseData->sex.'",';
			echo '"mobile":"'.$responseData->mobile.'",';
			echo '"alter_mobile":"'.$responseData->phone.'",';
			echo '"email_id":"'.$responseData->email.'",';
			echo '"address1":"'.$responseData->address1.'",';
			echo '"address2":"'.$responseData->address2.'",';
			echo '"city":"'.$responseData->city.'",';
			echo '"pin":"'.$responseData->pin.'",';
			echo '"state_code":"'.$responseData->state_code.'",';
			echo '"district":"'.$responseData->district.'",';
			echo '"country_code":"'.$responseData->country.'",';
			echo '"blood_group":"'.$responseData->blood_group.'",';
			echo '"police_station":"'.$responseData->police_station.'",';
			echo '"patient_type":"'.$responseData->patient_type.'",';
			echo '"anniversary":"'.$responseData->anniversary.'",';
			echo '"occupation":"'.$responseData->occupation.'",';
			echo '"referred_by":"'.$responseData->referred_by.'",';
			echo '"diet":"'.$responseData->diet.'",';
			echo '"patient_category":"'.$responseData->category.'"';
			echo "}";		
	}
		
		
}
?>