<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Patient extends CI_Controller 
{
	public function __construct() 
	{
		parent::__construct();
		$this->load->model('patientModel/Patient_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
	}
	public function appointment()
	{	
		//get clicnic location
		$responseData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		$responseData['doctor_list']=$this->Common_fetch_model->fetch_doctors_by_department_by_clinic(101,2);//fetch only own branch
		//$this->load->view('pportal/common_head');
		$this->load->view('pportal/appointment_landing_page',$responseData);
	}
	public function logout()
	{
		//destroy current session
		session_destroy();
		//load home
		redirect(base_url()."Patient/appointment");		
	}
	function signin()
	{
		$this->load->view('pportal/common_head');
		$this->load->view('pportal/patient_login');
	}
	function signup()
	{	
		$responseData['country']=$this->Common_fetch_model->fetch_country();
		$responseData['stateName']=$this->Common_fetch_model->fetch_state();
		$responseData['districtName']=$this->Common_fetch_model->fetch_district(10037);		
				
		$this->load->view('pportal/common_head');
		$this->load->view('pportal/registration',$responseData);
	}
	function bookappointment($doctor_enc_id="")
	{
		if($doctor_enc_id!="")
		{
			$doctor_id=base64_decode($doctor_enc_id);
			$data['doctor']=$this->Common_fetch_model->fetch_selected_doctor_detail($doctor_id);//fetch only own branch			
			//get clicnic location
			$data['clinic_location']=$this->Common_model->fetch_clinic('1');//fetch only own branch			
			$this->load->view('pportal/common_head');
			$this->load->view('pportal/book_appointment',$data);
		
		}
		else
		{
			//get clicnic location
			$data['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch			
			$this->load->view('pportal/common_head');
			$this->load->view('pportal/book_appointment',$data);
		}		
	}
	
	
	function get_doctors_widget_view()
	{
		$clinic_id=$this->input->post('clinic_id');
		$department_id=$this->input->post('department_id');
		$doctors=$this->Common_fetch_model->fetch_doctors_by_department_by_clinic($clinic_id,$department_id);//fetch only own branch				

		foreach($doctors as $record)
		{
			?>
		  <div class="col-md-4">
				<div class="single-choose mb-40">
				  <div class="choose-head">
					<div class="choose-icon mb-25 select_dr_img"> <img src="<?=base_url()?>docicon/<?=$record->photo_url?>" width="100" height="100" alt=""></div>
					<h3><a href="#">Dr. <?=$record->full_name?> </a></h3>
					 <h4><?=$record->qualification?> </h4>
					 <h5><?=$record->designation?><br/></h5>
					<a class="btn custom_btn mt-3" href="<?=base_url()?>Patient/docschedule?drc=<?=base64_encode($record->doctor_uid)?>">Schedule</a>
				  </div>
				</div>
		   </div>			
			<?php			
		}
	}
	function get_selected_doctor_detail($page="")
	{
		$doctor_id=$this->input->post('doctor_id');
		$doctors=$this->Common_fetch_model->fetch_selected_doctor_detail($doctor_id);//fetch only own branch				
			if($page!="book_appointment")
				echo '<div class="col-md-4">';
			?>
		  
				<div class="single-choose mb-40 single-choose_select_dr">
				  <div class="choose-head">
					<div class="choose-icon mb-25 select_dr_img"> <img src="<?=base_url()?>docicon/<?=$doctors->photo_url?>" width="100" height="100" alt=""></div>
					<h3><a href="#">Dr. <?=$doctors->full_name?> </a></h3>
					 <h4><?=$doctors->qualification?> </h4>
					 <h5><?=$doctors->designation?><br/></h5>
					<?php
					if($page!="book_appointment")
					{
					?>
						<a class="btn custom_btn mt-3" href="<?=base_url()?>Patient/signin?drc=<?=base64_encode($doctors->uid)?>">Book Appointment</a>
					<?php
					}
					?>
				  </div>
				</div>
		   			
			<?php
			if($page!="book_appointment")
				echo '</div>';			
	
	}
	public function loginValidation()//login authorization check
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('user_mobile', 'User Mobile', 'required|numeric');
		$this->form_validation->set_rules('user_otp', 'User OTP', 'required|numeric');
	    if($this->form_validation->run()!= FALSE)
        {		
			//input login form data from the login page
			$usermobile=$this->input->post("user_mobile");
			$userotp=$this->input->post("user_otp");
			//$selected_doc_id=$this->input->post("selected_doc_id");
			//check user already exist or not in patient table
			$authenticationResult=$this->Patient_fetch_model->loginAuthentication($usermobile,$userotp,'patient');//receiving login authentication data

			if($authenticationResult==true)//user available
			{		
				
				//set session value when successfully logged in_array
				$loginfo = array(
					   'userLoggedin'  => TRUE,
					   'loggedUserId'  =>  $authenticationResult[0]['uid'],
					   'fullname'	=> $authenticationResult[0]['full_name'],
					   'patient_type'	=> 'Followup'
				   );
				$this->session->set_userdata($loginfo);
				/*$authenticationResult[0]['full_name']*/

				//redirect(base_url().'Patient/patient_appointment/'.$selected_doc_id);
				redirect(base_url().'Patient/bookappointment/');

			}
			else
			{
				//if patient not exist in patient table then check in user_registration table
				$authenticationResult=$this->Patient_fetch_model->loginAuthentication($usermobile,$userotp,'user_registration');//receiving login authentication data
				if($authenticationResult==true)//user available
				{		
					
					//set session value when successfully logged in_array
					$loginfo = array(
						   'userLoggedin'  => TRUE,
						   'loggedUserId'  =>  $authenticationResult[0]['uid'],
						   'fullname'	=> $authenticationResult[0]['full_name'],
						   'patient_type'	=> 'New'
					   );
					$this->session->set_userdata($loginfo);
					/*$authenticationResult[0]['full_name']*/

					//redirect(base_url().'Patient/patient_appointment/'.$selected_doc_id);
					redirect(base_url().'Patient/bookappointment/');

				}
				else
				{
				
					$this->session->set_flashdata('error','Record Not Found');
					$this->signin();//reload login page if invalid password found//
				}
			}
		
		}
		else
		{
				$this->session->set_flashdata('error','Record Not Found');
				$this->index();//reload login page if invalid password found//
		}		
	}
	function load_district()
	{
		$state_id=$this->input->post("state_id");
		$district=$this->Common_model->fetch_district($state_id);
		foreach($district as $key => $key_value)
		{
			?>
			<option value="<?=$key?>"><?=$key_value?></option>
			<?php			
		}		
	}
	function registration()
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('patient_name', 'Patient Name', 'required');
		$this->form_validation->set_rules('mobile', 'Mobile', 'required|numeric');
		//$this->form_validation->set_rules('password', 'User Password', 'required');
	    if($this->form_validation->run()!= FALSE)
        {		
			$patient_name=$this->input->post("patient_name");
			if($this->input->post("age")!="")
			{
				$age=$this->input->post("age");
				$y=date('Y')-$age;
				$dob=$y."-"."01-01";
			}
			else
			{
				$dob=date("Y-m-d",strtotime($this->input->post("dob")));
			}

			$mobile=$this->input->post("mobile");		
			$email_id=$this->input->post("email_id");		
			//$password=$this->input->post("password");		
			$gender=$this->input->post("gender");		
			//$address2=$this->input->post("address2");		
			$city=$this->input->post("city");		
			$pin=$this->input->post("pin");		
			$country_code=$this->input->post("country_code");		
			//$state_code=$this->input->post("state_code");		
			//$district=$this->input->post("district");
			$insertdata=array(
				"full_name"=>$patient_name,
				//"dob"=>$dob,
				"mobile"=>$mobile,
				"email"=>$email_id,
				//"password"=>$password,
				"gender"=>$gender,
				//"address2"=>$address2,
				"city"=>$city,
				"pin"=>$pin,
				"country"=>$country_code
				//"state"=>$state_code,
				//"district"=>$district

				);
				$this->Common_insert_model->save_data($insertdata,'user_registration');
				$this->session->set_flashdata('success', 'Data Saved...');				
				redirect(base_url()."Patient/signup");
		}
		else
		{
			$this->signup();

		}
	}
	function appointment_add()
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span style="color:red">', '</span>');
		$this->form_validation->set_rules('patient_name', 'Patient Name', 'required');
		$this->form_validation->set_rules('whatsapp_no', 'whatsapp No', 'required|numeric');
		$this->form_validation->set_rules('preferred_date', 'preferred Date', 'required');
		$this->form_validation->set_rules('preferred_time', 'preferred Time', 'required');
	    if($this->form_validation->run()!= FALSE)
        {		
			$appointment_type=$this->input->post("appointment_type");
			if($appointment_type==1)
				$patient_name=$this->input->post("patient_name");
			else
			{
				$patient_id=$this->input->post("patient_name_list");
				$patient_name=$this->input->post("patient_name");
			}
			
			$consultation_mode=$this->input->post("consultation_mode");
			
			if($this->input->post("age")!="")
			{
				$age=$this->input->post("age");
				$y=date('Y')-$age;
				$dob=$y."-"."01-01";
			}
			else
			{
				$dob=date("Y-m-d",strtotime($this->input->post("dob")));
			}

			$sex=$this->input->post("sex");		
			$whatsapp_no=$this->input->post("whatsapp_no");		
			$clinic=$this->input->post("clinic");		
			$departments=$this->input->post("departments");		
			$doctors=$this->input->post("doctors");	
			
			$preferred_date_new = str_replace('/', '-', $this->input->post('preferred_date') );
			$preferred_date=date('Y-m-d',strtotime($preferred_date_new));
		
			$preferred_time=$this->input->post("preferred_time");
			$whatsapp_no=$this->input->post("whatsapp_no");
			
			$insertdata=array(
				"user_uid"=>$_SESSION['loggedUserId'],
				"gender"=>$sex,
				"dob"=>$dob,
				"whatsapp_num"=>$whatsapp_no,
				"clinic_id"=>$clinic,
				"doctor_id"=>$doctors,
				"request_date"=>$preferred_date,
				"request_time"=>$preferred_time,
				"app_type"=>$appointment_type,
				"app_mode"=>$consultation_mode

				);
				if($appointment_type==1)
				{
					$insertdata['name']=$patient_name;
				}
				else
				{
					$insertdata['name']=$patient_name;
					$insertdata['patient_uid']=$patient_id;
				}

				$this->Common_model->save_data($insertdata,'user_appointment');
				$this->session->set_flashdata('success', 'Data Saved...');				
				redirect(base_url()."Patient/patient_appointment");
		}
		else
		{
			$this->patient_appointment();

		}		
	}
	function get_patient_of_logged_user()
	{
		$log_user_id=$this->input->post("loguid");
		$logged_users_patient=$this->Common_model->fetch_patient_of_logged_user($log_user_id);
		
		echo '<option value="-1" selected>'."--Select--".'</option>';
		foreach($logged_users_patient as $record)
		{
			?>
			<option value="<?=$record->uid?>"><?=$record->full_name?></option>
			<?php			
		}		
	}
	function get_patient_profile_details()
	{
		$patient_id=$this->input->post("patient_id");
		$logged_users_patient=$this->Common_model->fetch_patient_basic_details($patient_id);		
		echo '{';
			echo '"patient_uid":"'.$logged_users_patient->uid.'",';
			echo '"dob":"'.date('d-m-Y',strtotime($logged_users_patient->dob)).'",';
			echo '"sex":"'.$logged_users_patient->sex.'",';
			echo '"mobile":"'.$logged_users_patient->mobile.'"';
		echo '}';
	}

}
