<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Research extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		$this->load->model('researchModel/Research_fetch_model');
		$this->load->model('appointmentModel/Appointment_fetch_model');
		$this->load->model('systemsModel/Systems_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	
	//************************Systems dash board start**********
	function dashboard()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
			
		$this->load->view('research/research_dashboard',$data);
	}
	function showQueryBuilder()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//fetch all diagnosis 
		$data['diagnosis_name']=$this->Research_fetch_model->fetch_diagnosis_name();
		//fetch all diagnosis 
		$data['medicine_name']=$this->Research_fetch_model->fetch_all_medicine_name();
		//fetch all diagnosis 
		$data['investigation_param_name']=$this->Research_fetch_model->fetch_all_investigation_param_name();
						
		$this->load->view('research/query_builder.php',$data);
	}
	function showMedicineGroup()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//$data['medicine_name']=$this->Common_fetch_model->fetch_medicine_list();
		$data['medicine_name']=$this->Common_fetch_model->fetch_all_medicine_name_list();
		//fetch all diagnosis 
		$data['all_medicine_group']=$this->Research_fetch_model->fetch_all_medicine_group();
						
		$this->load->view('research/medicine_group.php',$data);
	}		
		//************************Systems dash board End **********

	function build_query()
	{
		$diagnosis_uid=$this->input->post('diagnosis');
		$medicine_uid=$this->input->post('medicine');
	 	$investigation_param=$this->input->post('investigation_param');
	 	$operator=$this->input->post('operator');
		$investigation_value=$this->input->post('investigation_value');
		
		//delete whole table
		$this->Common_insert_model->empty_a_table('temp_query_tbl1');
		
		if($diagnosis_uid!=-1)
		{
			$response=$this->Research_fetch_model->get_query_data($diagnosis_uid);
			//insert
			foreach($response as $record)
			{
			$data=array(
					"patient_uid"=>$record->patientUid,			
					"patient_name"=>$record->patientName,			
					"patient_sex"=>$record->patientSex,
					"data_set"=>1,
					"set_date"=>date('Y-m-d')
						
				);
				$this->Common_insert_model->save_data_for_prevDb($data,'temp_query_tbl1');
			}
		}
		
		if($medicine_uid!=-1)
		{
			$response2=$this->Research_fetch_model->get_query_data_with_medicine($medicine_uid);
			foreach($response2 as $record)
			{
				$data2=array(
						"patient_uid"=>$record->patient_uid,			
						"patient_name"=>$record->patient_name,			
						"patient_sex"=>$record->patient_sex,
						"data_set"=>2,
						"set_date"=>date('Y-m-d')
							
					);
					$this->Common_insert_model->save_data_for_prevDb($data2,'temp_query_tbl1');				
				if($investigation_param==-1)
				{
			?>
				  <tr>	
					<td>&nbsp;</td>
					<td><?=$record->patient_uid?></td>
					<td><?=$record->patient_name?></td>
					<td><?=($record->patient_sex==1)?'Female':(($record->patient_sex==2)?'Male':'Transgender')?></td>
					<td>&nbsp;</td>
				  </tr>	
			<?php
				}
			}
		}
		
		if($investigation_param!=-1)
		{
			$response2=$this->Research_fetch_model->get_query_data_with_investigation($investigation_param,$investigation_value,$operator);
			foreach($response2 as $record)
			{
				$data2=array(
						"patient_uid"=>$record->patient_uid,			
						"patient_name"=>$record->patient_name,			
						"patient_sex"=>$record->patient_sex,
						"data_set"=>3,
						"set_date"=>date('Y-m-d')
							
					);
					$this->Common_insert_model->save_data_for_prevDb($data2,'temp_query_tbl1');				
			?>
			  <tr>	
				<td>&nbsp;</td>
				<td><?=$record->patient_uid?></td>
				<td><?=$record->patient_name?></td>
				<td><?=($record->patient_sex==1)?'Female':(($record->patient_sex==2)?'Male':'Transgender')?></td>
				<td>&nbsp;</td>
			  </tr>	
			<?php
			}
		}		
		//redirect(base_url()."Research/dashboard");
	}
	function save_medicine_group()
	{
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<span class="error_msg">', '</span>');
		$this->form_validation->set_rules('group_name', 'Group Name', 'required');
	    if($this->form_validation->run()!= FALSE)
        {	
		//$uid=base64_decode($this->input->post('uid'));//used to edit
		$group_id=$this->input->post('group_name');
		$strength=$this->input->post('strength');
		$dose=$this->input->post('dose');
		$days=$this->input->post('days');
		$item_list=$this->input->post('item_list');
		if(!empty($this->input->post('show_app')))
			$show_app=$this->input->post('show_app');
		else
			$show_app=0;
		if(!empty($this->input->post('active_flag')))		
			$active_flag=$this->input->post('active_flag');
		else
			$active_flag=0;

			if(!empty($item_list))
			{
				for($i=0;$i<count($item_list);$i++)
				{
					$insertdata=array(
						"group_id"=>$group_id,
						"medicine_id"=>$item_list[$i],
						"strength"=>$strength,
						"dose"=>$dose,
						"days"=>$days,
						"active_flag"=>$active_flag,
						"show_app_flag"=>$show_app
						);
						//if($uid=="")
							$this->Common_insert_model->save_data($insertdata,'group_medicine');
						//else
							//$this->Common_insert_model->update_data($insertdata,'item_group','uid',$uid);

				}		
					
				$this->session->set_flashdata('success', 'Data Saved...');				
				redirect(base_url()."Research/showMedicineGroup");
	
			}
			else		
			{
				redirect(base_url()."Research/showMedicineGroup?status=ERR");
			}
		}
		else
		{
			$this->showMedicineGroup();
		}


	}
	function delete_medicine_group($group_name)
	{
		$response=$this->Common_insert_model->delete_record('group_medicine','group_id',$group_name);		
		redirect(base_url().'Research/showMedicineGroup');		
	}


}

?>