<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Systems extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		
		//user session existance checking
		if(!isset($_SESSION['loggedUserId']))
			redirect(base_url());		

		$this->load->model('appointmentModel/Appointment_fetch_model');
		$this->load->model('systemsModel/Systems_fetch_model');
		//$this->load->model('adminModel/Admin_fetch_model');
		//$this->load->model('pharmacyModel/Pharmacy_fetch_model');
		$this->load->model('commonModel/Common_fetch_model');
		$this->load->model('commonModel/Common_insert_model');
		$this->load->model('gatewayModel/Gateway_model');		
	}
	
	//************************Systems dash board start**********
	function dashboard()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$this->load->view('systems/systems_dashboard',$userModuleData);
	}
		//************************Systems dash board End **********
		
	function clinicData()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_clinic_list']=$this->Systems_fetch_model->fetch_clinic_list($no_of_record);//descending order				
		$this->load->view('systems/clinic_data',$data);
	}
	function clinicAdd()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//medicine form fetch
	//	$data['medicine_form']=$this->Common_fetch_model->fetch_medicine_form();						
		$this->load->view('systems/clinic_add',$data);
	}	
	
	function departmentData()
	{
		$no_of_record=10;
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//$data['all_doctor_list']=$this->Systems_fetch_model->fetch_doctor_list($no_of_record);//descending order				
		$this->load->view('systems/department_data',$data);
	}
	function departmentAdd()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//medicine form fetch
	//	$data['medicine_form']=$this->Common_fetch_model->fetch_medicine_form();						
		$this->load->view('systems/department_add',$data);
	}	

	public function set_complain()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department();
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('settings/complain_data',$userModuleData);
	}
	public function set_diagnostics()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department();
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('settings/diagnostics_data',$userModuleData);
	}
	public function set_advise()
	{
		//fetch logged user's modules
		$userModuleData['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		//$userModuleData['clinic_location']=$this->Common_fetch_model->fetch_clinic('1');//fetch only own branch
		//$userModuleData['all_departments']=$this->Common_fetch_model->fetch_department();
		//$userModuleData['all_doctors']=$this->Common_fetch_model->get_all_doctors_name_list();
		$this->load->view('settings/advise_data',$userModuleData);
	}
	function page()
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);				
		$data['all_pages']=$this->Common_fetch_model->fetch_all_page_name();
		$data['emp_allowed_pages']=$this->Common_fetch_model->fetch_group_details($_SESSION['allowed_group']);
		$this->load->view('systems/all_page',$data);
	}
	function pageAdd($edit_id=0)
	{
		//fetch logged user's modules
		$data['usersModule']=$this->Gateway_model->module_fetch($_SESSION['loggedUserId']);					
		$data['all_module']=$this->Common_fetch_model->fetch_all_module_name();
		
		if(base64_decode($edit_id)!=0)
		{
			$data['page_record']=$this->Common_fetch_model->fetch_page_record(base64_decode($edit_id));
		}
		$this->load->view('systems/page_add',$data);		
	}
	function add_page_name()
	{
		$uid=$this->input->post('uid');
		$page_name=$this->input->post('page_name');
		$page_code=$this->input->post('page_code');
		$module_id=$this->input->post('module');
		$module_name=$this->input->post('module_name');
		$status=$this->input->post('status');
		//insert
		$sata=array(
				"page_name"=>$page_name,			
				"page_code"=>$page_code,			
				"module_code"=>$module_id,			
				"module_name"=>$module_name,			
				"active_flag"=>$status,			
			);
		if($uid==0)
			$this->Common_insert_model->save_data($sata,'page_code');
		else
			$this->Common_insert_model->update_data($sata,'page_code','uid',$uid);
		redirect(base_url()."Systems/pageAdd");

	}

}

?>