<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Accounts_fetch_model extends CI_Model
{
	public function fetch_bill_list($from_date,$to_date,$services,$payment_mode,$employee)
	{
		$this->db->select("distinct(b.bill_no),bm.uid,bm.discount_amount,bm.gross_amount,bm.net_amount,b.bill_date,date_of_service,b.patient_uid,p.full_name as patient_name");
		//$this->db->select("sum(b.discount_amount),sum(b.gross_amount)");
		$this->db->from('billing b');
		$this->db->join('bill_receipt pm', 'pm.billmast_uid=b.billmast_uid');		
		$this->db->join('billing_master bm', 'bm.uid=b.billmast_uid');				
		$this->db->join('patient p', 'p.uid=b.patient_uid');				
		$this->db->where('b.bill_date>=',$from_date);		
		$this->db->where('b.bill_date<=',$to_date);
		$this->db->where('b.payment_flag',1);
		$this->db->where('bm.bill_section',1);
		if($payment_mode!=-1)
		{
			$this->db->where('pm.payment_mode',$payment_mode);
		}
		if($employee!=-1)
		{
			$this->db->where('bm.employee_uid',$employee);
		}
		if($services!=-1)
		{
			$this->db->where('b.service_uid',$services);
		}		
		$this->db->where('b.clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_payment_list($from_date,$to_date,$payment_mode,$employee)
	{
		$this->db->select("bm.uid,bm.bill_prefix,bm.bill_date,bm.patient_uid,p.full_name,pm.payment_mode,pm.net_amount,pm.employee_uid");
		//$this->db->select("sum(b.discount_amount),sum(b.gross_amount)");
		$this->db->from('bill_receipt pm');
		$this->db->join('billing_master bm', 'bm.uid=pm.billmast_uid');				
		$this->db->join('patient p', 'p.uid=bm.patient_uid');				
		$this->db->where('bm.bill_date>=',$from_date);		
		$this->db->where('bm.bill_date<=',$to_date);
		if($payment_mode!=-1)
		{
			$this->db->where('pm.payment_mode',$payment_mode);
		}
		if($employee!=-1)
		{
			$this->db->where('bm.employee_uid',$employee);
		}
		
		$this->db->where('bm.clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_service_total_bill_net($service_uid,$from_date,$to_date,$table)
	{
		$this->db->select("sum(gross_amount) as total_service_net");
		$this->db->from($table);		
		$this->db->where('service_uid',$service_uid);		
		$this->db->where('bill_date>=',$from_date);		
		$this->db->where('bill_date<=',$to_date);
		$this->db->where('clinic_uid',$_SESSION['clinicId']);
		$this->db->where('cancel_flag',0);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_total_bill_discount($service_uid,$from_date,$to_date)
	{
		$this->db->select("sum(bm.discount_amount) as total_service_discount");
		if($service_uid==114 || $service_uid==107)
		{
			$this->db->from('billing_ipd b');
			$this->db->join('billing_master bm', 'bm.admission_no=b.admission_no');
		}
		else
		{
			$this->db->from('billing b');		
			$this->db->join('billing_master bm', 'bm.uid=b.billmast_uid');
		}
		$this->db->where('b.service_uid',$service_uid);		
		$this->db->where('bm.bill_date>=',$from_date);		
		$this->db->where('bm.bill_date<=',$to_date);
		$this->db->where('b.clinic_uid',$_SESSION['clinicId']);
		$this->db->where('b.cancel_flag',0);
		$query = $this->db->get();
		return $query->row();	
	}
	public function fetch_service_details_breakup($from_date,$to_date,$service_uid)
	{
		$this->db->select("bill_no,billmast_uid,item_id,doctor_id,bill_date,service_amount,discount_amount,gross_amount,patient_uid,full_name,cancel_flag");
		$this->db->from('billing b');
		$this->db->join('patient p', 'p.uid=b.patient_uid');		
		$this->db->where('service_uid',$service_uid);		
		$this->db->where('bill_date>=',$from_date);		
		$this->db->where('bill_date<=',$to_date);
		$this->db->where('clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_item_wise_receipt($from_date,$to_date,$item,$service_id,$table)
	{
		$this->db->select("bill_no,billmast_uid,service_uid,item_id,doctor_id,bill_date,service_amount,discount_amount,gross_amount,patient_uid,full_name,cancel_flag");
		$this->db->from($table.' b');
		$this->db->join('patient p', 'p.uid=b.patient_uid');		
		$this->db->where('bill_date>=',$from_date);		
		$this->db->where('bill_date<=',$to_date);
		$this->db->where('service_uid',$service_id);
		if($service_id==101)
			$this->db->where('doctor_id',$item);
		else
			$this->db->where('item_id',$item);
		$this->db->where('clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	function fetch_all_logged_employee($clinic_id)
	{
		$this->db->select("distinct(employee_uid),e.full_name");
		$this->db->from('bill_receipt p');
		$this->db->join('employee e', 'e.uid=p.employee_uid');
		$this->db->where('p.clinic_uid',$clinic_id);
		$query = $this->db->get();
		return $query->result();		
	}
	function fetch_user_net_by_mode($employee_uid,$payment_mode,$clinic_id,$from_date,$to_date)
	{
		$this->db->select("sum(net_amount) as net_amount");
		$this->db->from('bill_receipt');
		$this->db->where('clinic_uid',$clinic_id);
		$this->db->where('employee_uid',$employee_uid);
		$this->db->where('payment_mode',$payment_mode);
		$this->db->where('voucher_date>=',$from_date);		
		$this->db->where('voucher_date<=',$to_date);		
		$this->db->where('cancel_flag',0);		
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_bill_master_list($from_date,$to_date)
	{
		$this->db->select("bm.uid,bm.bill_prefix,bm.bill_date,gross_amount,discount_amount,net_amount,bm.patient_uid,p.full_name,cancel_flag");
		$this->db->from('billing_master bm');			
		$this->db->join('patient p', 'p.uid=bm.patient_uid');				
		$this->db->where('bm.bill_date>=',$from_date);		
		$this->db->where('bm.bill_date<=',$to_date);	
		$this->db->where('bm.clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_receipt_master_list($from_date,$to_date,$payment_mode)
	{
		$this->db->select("pm.uid,pm.receipt_prefix,pm.voucher_date,patient_uid,p.full_name,pm.payment_mode,pm.net_amount,pm.card_instrument_no,pm.cancel_flag");
		$this->db->from('bill_receipt pm');			
		$this->db->join('patient p', 'p.uid=pm.patient_uid');				
		$this->db->where('pm.voucher_date>=',$from_date);		
		$this->db->where('pm.voucher_date<=',$to_date);
		if($payment_mode!=-1)
		{
			$this->db->where('pm.payment_mode',$payment_mode);
		}
	
		$this->db->where('pm.clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_doctor_wise_report($from_date,$to_date,$item,$service_id,$doctors,$table)
	{
		$this->db->select("bill_no,billmast_uid,service_uid,item_id,doctor_id,bill_date,service_amount,discount_amount,gross_amount,patient_uid,full_name,cancel_flag");
		$this->db->from($table.' b');
		$this->db->join('patient p', 'p.uid=b.patient_uid');		
		$this->db->where('bill_date>=',$from_date);		
		$this->db->where('bill_date<=',$to_date);
		$this->db->where('service_uid',$service_id);

		$this->db->where('doctor_id',$doctors);
		if($item!=-1)
			$this->db->where('item_id',$item);
		$this->db->where('clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}	
	public function fetch_date_wise_total_payment($from_date,$to_date,$clinic_id=0)
	{
		$this->db->select("sum(net_amount) as net_amount,voucher_date");
		$this->db->from('bill_receipt');
		$this->db->where('clinic_uid',$clinic_id);
		$this->db->where('voucher_date>=',$from_date);		
		$this->db->where('voucher_date<=',$to_date);		
		$this->db->where('cancel_flag',0);		
		$this->db->group_by('voucher_date');		
		$query = $this->db->get();
		return $query->result();		
	}	
}