<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Admin_fetch_model extends CI_Model
{
	public function fetch_charge_list($no_of_record=0)	
	{
		if($no_of_record==0)//all medicine
			$this->db->select('t1.uid,item_name,service_uid,misc_name,clinic_name,amount,t1.clinic_uid');
		else
			$this->db->select('t1.uid,item_name,service_uid,misc_name,clinic_name,amount,t1.clinic_uid');
		$this->db->from('charges t1');
		$this->db->join('misc_master t2', 't1.service_uid=t2.uid');
		$this->db->join('clinic t3', 't3.uid=t1.clinic_uid');
		$this->db->limit($no_of_record);
		$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();//passing all result to controller		
	}
	public function fetch_charge_record($charge_id)
	{
		$this->db->select('uid,item_name,charge_category,service_uid,amount,clinic_uid,active_flag,show_app');
		$this->db->from('charges');
		$this->db->where('uid',$charge_id);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_cancel_bill($date_from,$date_to)
	{
		$this->db->select('uid,cancel_date,cancel_purpose,bill_prefix');
		$this->db->from('billing_master');
		$this->db->where('cancel_date>=',$date_from);		
		$this->db->where('cancel_date<=',$date_to);
		$this->db->where('cancel_flag',1);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_patient_appo_stat($date_from,$date_to,$appo_type=0)
	{
		$this->db->select('count(appo_uid) no_of_record');
		//$this->db->select('appo_uid,app_type');
		$this->db->from('user_appointment');
		$this->db->where('approve_date>=',$date_from);		
		$this->db->where('approve_date<=',$date_to);
		if($appo_type!=0)
			$this->db->where('app_type',$appo_type);
		$this->db->where('patient_uid!=',0);
		$this->db->where('present_flag',1);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_monthly_patient_stat($date_from,$date_to,$month)
	{
		if($month==13)
			$month=1;
		else if($month==14)
			$month=2;
		else if($month==15)
			$month=3;		
		$this->db->select('count(appo_uid) no_of_record');
		//$this->db->select('appo_uid,app_type');
		$this->db->from('user_appointment');
		$this->db->where('MONTH(approve_date)',$month);
		$this->db->where('approve_date>=',$date_from);		
		$this->db->where('approve_date<=',$date_to);		
		$this->db->where('present_flag',1);
		$this->db->where('patient_uid!=',0);
		$query = $this->db->get();
		return $query->row();		
	}			
}
?>