<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Appointment_fetch_model extends CI_Model
{
	public function fetch_appointment_list_by_date($date)
	{ 	
		$clinic_uid=$_SESSION['clinicId'];
		$this->db->select('appo_uid,approve_date,approve_time,clinic_id,doctor_id,app_type,patient_uid,name,dob,gender,whatsapp_num,present_flag');
		$this->db->from('user_appointment');
		$this->db->where('approve_date',$date)->where('clinic_id',$clinic_uid);		
		$query=$this->db->get();
		return $query->result();//passing all result to controller

	}
	public function fetch_appointment_list($clinic="",$date_from="",$date_to="",$visitor_name="",$mobile="",$doctor_id="-1",$dialysis_appo=0,$appointment_mode="-1")
	{
		//$qry_stmt="uid,appointment_date,clinic_uid,appointment_type,patient_uid,salutation,patient_name,age,sex,,mobile,email,address1,address2,city,state_code,district,police_station,pincode";
		$this->db->select('appo_uid,approve_date,approve_time,clinic_id,doctor_id,app_type,app_mode,note,patient_uid,name,dob,gender,whatsapp_num,ua.email,ua.city,patient_category,patient_type,present_flag,clinic_name,call_status,referred_by');
		$this->db->from('user_appointment ua');
		$this->db->join('clinic c', 'c.uid=ua.clinic_id');
		if($clinic!="")
			$this->db->where('clinic_id',$clinic);
		if($date_from!="" && $date_to!="")
			$this->db->where('approve_date BETWEEN \''. $date_from.'\' AND \''.$date_to.'\'');
		if($visitor_name!="")
			$this->db->like('name',$visitor_name);
		if($mobile!="")
			$this->db->where('whatsapp_num',$mobile);
		if($doctor_id!=-1)
			$this->db->where('doctor_id',$doctor_id);
		if($appointment_mode!=-1)
			$this->db->where('app_mode',$appointment_mode);
		if($dialysis_appo==1)//if patient is dialysis patient
			$this->db->where('patient_type',2);		
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	function fetch_appointed_patient_list($date)
	{
		$clinic_uid=$_SESSION['clinicId'];
		$this->db->select('p.uid,full_name,p.dob,p.sex,p.mobile,appo_uid,approve_date,approve_time,ua.clinic_id,ua.doctor_id,ua.app_type,present_flag');
		$this->db->from('user_appointment ua');
		$this->db->join('patient p', 'p.uid=ua.patient_uid');
		$this->db->where('ua.approve_date',$date)->where('ua.clinic_id',$clinic_uid);		
		$query=$this->db->get();
		return $query->result();//passing all result to controller
		
	}
	function fetch_get_data_for_patient_approve($clinic_id,$search_date,$doctor_id)
	{
		$this->db->select('appo_uid,approve_date,approve_time,clinic_id,doctor_id,app_type,app_mode,patient_uid,name,age,gender,whatsapp_num,present_flag');
		$this->db->from('user_appointment');
		if($clinic_id!="")
			$this->db->where('clinic_id',$clinic_id);
		if($search_date!="")
			$this->db->where('request_date',$search_date);
		if($doctor_id!="")
			$this->db->where('doctor_id',$doctor_id);		
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	public function fetch_appointment_record($appo_no)
	{
		$this->db->select('appo_uid,`name`,dob,`gender`,`user_uid`,`gender`,`whatsapp_num`,`alternate_mobile`,`email`,`city`,`country`,`pin`,occupation,referred_by,patient_uid,patient_type,patient_category,approve_date,approve_time,present_flag,doctor_id,isset_patient_flag');
		$this->db->from('user_appointment');
		if($appo_no!="")
			$this->db->where('appo_uid',$appo_no);
		$query=$this->db->get();
		return $query->row();//passing all result to controller		
	}
	public function check_for_appointmentId_in_billing($appo_no)
	{
		$this->db->select('uid,bill_date');
		$this->db->from('billing_master');
		if($appo_no!="")
			$this->db->where('appointmentBooking_uid',$appo_no);
		$query=$this->db->get();
		return $query->row();		
	}
	public function fetch_appointment_list_for_billing_completed($date)
	{
		$clinic_uid=$_SESSION['clinicId'];
		$this->db->select('appo_uid,approve_date,approve_time,ua.clinic_id,app_mode,ua.doctor_id,app_type,ua.patient_uid,name,dob,gender,whatsapp_num,present_flag,clinic_name');
		$this->db->from('user_appointment ua');
		$this->db->join('billing_master b', 'b.appointmentBooking_uid=ua.appo_uid');
		$this->db->join('clinic c', 'c.uid=ua.clinic_id');
		$this->db->where('approve_date',$date)->where('ua.clinic_id',$clinic_uid);
		$this->db->order_by('b.uid', 'ASC');		
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	
//------------------old query----------------------	
	public function insert_visit_no_in_visit_register($patient_uid)
	{
		$current_date=date('y-m-d');
		$visit_no=$this->generate_visit_no($patient_uid);
		if(isset($visit_no->sequence))
			$visit_no=$visit_no->sequence;
		else
			$visit_no=$visit_no;//means '1' value stored
		$qry="insert into visit_register (patient_uid,sequence,visit_date) values ($patient_uid,$visit_no,'$current_date')";
		$result=$this->db->query($qry);
	
	}
	public function generate_visit_no($patient_uid)
	{ 	
		$qry="SELECT max(sequence)+1 as 'sequence' FROM `visit_register` WHERE `patient_uid`=$patient_uid";
		$result=$this->db->query($qry);
		//return $result->row();
		$record=$result->row();

		if ($record->sequence!="")
			return $result->row();//passing all result to controller
		else
			return 1;

	}
	public function visit_check($patient_uid)
	{
		$todate=date("Y-m-d");
		$qry="SELECT sequence FROM `visit_register` WHERE `patient_uid`=$patient_uid and visit_date='$todate'";
		$result=$this->db->query($qry);
		return $result->num_rows();
	
	}
	public function current_visit_no($patient_uid)
	{
		$todate=date("Y-m-d");
		$qry="SELECT sequence FROM `visit_register` WHERE `patient_uid`=$patient_uid and visit_date='$todate'";
		$result=$this->db->query($qry);
		return $result->row();
	
	}	
//------------------old query----------------------



//--------------temp code-------------------------------------
	public function fetch_patient_record_from_prevdb($patient_id)
	{
		$db2 = $this->load->database('drpscaredb', TRUE);
		$qry="SELECT patientUid,patientName,PatientMobile,patientSex,patientAge,patientSalutation,patientDOB,patientEmail,patientPhone,patientAdd1,patientAdd2,PatientPin,patientCity,patientCountry,patientPs,patientDist,PatientState,patientBlood,occupation,referred_by FROM patient_mast where patientUid = $patient_id";
		$query=$db2->query($qry);
		return $query->row();//passing all result to controller		
	}
//--------------temp  code-------------------------------------	
}