<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Billing_fetch_model extends CI_Model
{


	public function fetch_bill_list($no_of_record=0,$dtfrom,$dtto,$userid,$clinicid)	
	{
		if($no_of_record==0)//all medicine
			$this->db->select('m.uid,medicine_name,g.generic_name,form,madeby,strength,schedule,price');
		else
			$this->db->select('m.uid,medicine_name,g.generic_name,form,madeby,strength,schedule,price');
		$this->db->from('medicine m');
		$this->db->join('medicine_generic mg', 'm.uid=mg.medicine_uid');
		$this->db->join('generic g', 'g.uid=mg.generic_uid');
		$this->db->limit($no_of_record);
		$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();//passing all result to controller		
	}
	public function fetch_patient_invoice_details($bill_no)
	{/*
		$qry="SELECT b.uid,order_no,bill_no,service_uid,item_id,service_amount,bill_date,unit_uid,patient_uid,p.salutation,p.full_name as 'patient_full_name',sex,age,p.mobile,p.address1,p.address2,p.city,doctor_uid,e.full_name FROM  billing b,patient p,employee e where bill_no=$bill_no and p.uid=b.patient_uid and b.doctor_id=e.uid";
		$query=$this->db->query($qry);
		return $query->row();*/	
		
		$this->db->select("billmast_uid,bill_no,service_uid,item_id,service_amount,bill_date,unit_uid,patient_uid,old_puid,p.salutation,p.full_name as 'patient_full_name',sex,dob,p.mobile,p.address1,p.address2,p.city,p.pin,doctor_uid,e.full_name");
		$this->db->from('billing b');
		$this->db->join('patient p', 'p.uid=b.patient_uid');		
		$this->db->join('employee e', 'b.doctor_id=e.uid');		
		$this->db->where('billmast_uid',$bill_no);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_bill_master_details($bill_no)
	{
		$this->db->select("bm.uid,bill_date,bill_section,patient_uid,appointmentBooking_uid,p.salutation,p.full_name as 'patient_full_name',sex,dob,p.mobile,p.address1,p.address2,p.city,p.pin,e.full_name,hd_date,hd_time,gross_amount,discount_amount,net_amount,cancel_flag");
		$this->db->from('billing_master bm');
		$this->db->join('patient p', 'p.uid=bm.patient_uid');		
		$this->db->join('employee e', 'bm.treating_doctor=e.uid');		
		$this->db->where('bm.uid',$bill_no);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_bill_lab_details($bill_no)
	{
		$this->db->select("bl.lab_uid");
		$this->db->from('bill_lab bl');
		$this->db->where('bl.billmast_uid',$bill_no);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_service_id_by_bill_no($bill_no)
	{/*
		$qry="SELECT service_uid,service_amount FROM  billing  where order_no=$order_no";
		$query=$this->db->query($qry);
		return $query->row();*/

		$this->db->select("distinct(service_uid)");
		$this->db->from('billing');
		$this->db->where('billmast_uid',$bill_no);
		$query = $this->db->get();
		return $query->result();		
	}	
	public function fetch_patient_service_details($bill_no,$service_id)	
	{
		if($service_id==101)//consultation
		{
			//$qry="SELECT service_uid,item_id,doctor_id,service_amount,bill_date FROM  billing  where bill_no=$bill_no";
			$qry="SELECT service_uid,item_id,doctor_id,service_amount,discount_amount,gross_amount,bill_date,full_name,mobile FROM  billing t1,employee t2  where billmast_uid=$bill_no and service_uid=$service_id and t1.doctor_id=t2.uid  order by service_uid";
		}
		if($service_id==102 || $service_id==105 || $service_id==106 || $service_id==107  || $service_id==108 || $service_id==109 || $service_id==110 || $service_id==111 || $service_id==112 || $service_id==113 || $service_id==114 || $service_id==115)
		{
			$qry="SELECT t1.service_uid,item_id,service_amount,discount_amount,gross_amount,bill_date,c.item_name FROM  billing t1,charges c where billmast_uid=$bill_no and c.uid=t1.item_id and t1.service_uid=$service_id";
		}
		if($service_id==103 || $service_id==104)//other than procedure
		{
			//$qry="SELECT service_uid,item_id,doctor_id,service_amount,bill_date FROM  billing  where bill_no=$bill_no";
			$qry="SELECT service_uid,item_id,doctor_id,service_amount,discount_amount,gross_amount,bill_date,requisition_flag,full_name,t3.test_name FROM  billing t1,employee t2,investigation t3  where billmast_uid=$bill_no and service_uid=$service_id and t1.item_id=t3.uid and t1.doctor_id=t2.uid  order by service_uid";
		}		
		
		$query=$this->db->query($qry);
		return $query->result();//passing all result to controller			
	}
	public function fetch_opd_bill_list($from_date,$to_date,$services,$payment_mode,$employee)
	{
		$this->db->select("distinct(b.bill_no),bm.uid,bm.discount_amount,bm.gross_amount,bm.net_amount,b.bill_date,date_of_service,b.patient_uid,p.full_name as patient_name");
		//$this->db->select("sum(b.discount_amount),sum(b.gross_amount)");
		$this->db->from('billing b');
		$this->db->join('bill_receipt pm', 'pm.billmast_uid=b.billmast_uid');		
		$this->db->join('billing_master bm', 'bm.uid=b.billmast_uid');				
		$this->db->join('patient p', 'p.uid=b.patient_uid');				
		$this->db->where('b.bill_date>=',$from_date);		
		$this->db->where('b.bill_date<=',$to_date);
		$this->db->where('b.payment_flag',1);
		$this->db->where('bm.bill_section',1);
		$this->db->where('bm.cancel_flag',0);
		if($payment_mode!=-1)
		{
			$this->db->where('pm.payment_mode',$payment_mode);
		}
		if($employee!=-1)
		{
			$this->db->where('bm.employee_uid',$employee);
		}
		if($services!=-1)
		{
			$this->db->where('b.service_uid',$services);
		}		
		$this->db->where('b.clinic_uid',$_SESSION['clinicId']);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_patient_payment_details($bill_no)
	{
		$this->db->select("receipt_prefix,uid,payment_mode,net_amount,card_instrument_no,instrument_date");
		$this->db->from('bill_receipt');
		$this->db->where('billmast_uid',$bill_no);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_patient_billing_master_details($bill_no)
	{
		$this->db->select("`uid`, `bill_prefix`, `bill_date`, `patient_uid`, `gross_amount`, `discount_amount`, `net_amount`, `discount_reason`, `discount_approved_by`, `bill_section`, `treating_doctor`, `clinic_uid`, `employee_uid`, `entry_date_time`");
		$this->db->from('`billing_master');
		$this->db->where('uid',$bill_no);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_billing_completed_patient_list_date_wise($clinic_id,$doctor_id,$date)
	{
		$this->db->select("`bm.uid`, `bill_prefix`, `bm.bill_date`, `bm.patient_uid`, `bm.gross_amount`, `bm.discount_amount`, `bm.net_amount`, `bm.discount_reason`, `bm.discount_approved_by`, `bm.bill_section`, `bm.treating_doctor`, `bm.clinic_uid`, `bm.employee_uid`, `bm.entry_date_time`,full_name,dob,mobile,sex");
		$this->db->from('`billing_master bm');
		$this->db->join('patient p', 'p.uid=bm.patient_uid');		
		$this->db->join('billing b', 'bm.uid=b.billmast_uid');		
		$this->db->where('bm.bill_date',$date);
		$this->db->where('bm.clinic_uid',$clinic_id);
		$this->db->where('bm.treating_doctor',$doctor_id);
		$this->db->where('b.service_uid','101');		
		$this->db->order_by('bm.uid','ASC');
		$query = $this->db->get();
		return $query->result();		
	}
	
//--------------temp code-------------------------------------
	public function fetch_patient_reg_record_from_prevdb($search_text,$search_mobile=0)
	{
		$db2 = $this->load->database('drpscaredb', TRUE);
		if($search_text!="" && $search_mobile==0)//name search
			$qry="SELECT patientUid,patientName,patientAge,PatientMobile,patientDOB,patientSex,patient_uid_new,isset_patient from patient_mast where patientName like '$search_text%'";
		else if($search_text=="" && $search_mobile!=0)
			$qry="SELECT patientUid,patientName,patientAge,PatientMobile,patientDOB,patientSex,patient_uid_new,isset_patient from patient_mast where PatientMobile =  $search_mobile";
		else
			$qry="SELECT patientUid,patientName,patientAge,PatientMobile,patientDOB,patientSex,patient_uid_new,isset_patient from patient_mast where patientName like '$search_text%' and PatientMobile = $search_mobile";
		$query=$db2->query($qry);
		return $query->result();//passing all result to controller		
	}	
	public function fetch_patient_reg_record($patient_id)
	{
		$qry="SELECT uid,salutation,full_name,sex,dob,blood_group,race,religion,mobile,email,phone,address1,address2,city,country,state_code,district,pin,police_station,aadhaar,passport,visa,doctor_uid,special_note,category  from patient where uid = $patient_id";
		$query=$this->db->query($qry);
		return $query->row();//passing all result to controller		
	}
	public function patient_details_fetch($search_data,$str_length)
	{
		$db2 = $this->load->database('drpscaredb', TRUE); 
		if($str_length==10)//then search by patient mobile no
			$qry="SELECT patientUid,patientName,PatientMobile,patientSex,patientAge,patientSalutation,patientDOB,patientEmail,patientPhone,patientAdd1,patientAdd2,PatientPin,patient_uid_new,isset_patient FROM patient_mast where PatientMobile='$search_data'";
		else
			$qry="SELECT patientUid,patientName,PatientMobile,patientSex,patientAge,patientSalutation,patientDOB,patientEmail,patientPhone,patientAdd1,patientAdd2,PatientPin,patient_uid_new,isset_patient FROM patient_mast where patientUid='$search_data'";
		$query=$db2->query($qry);
		return $query->result();//passing all result to controller			
	}
	public function fetch_patient_record_from_prevdb($patient_id)
	{
		$db2 = $this->load->database('drpscaredb', TRUE);
		//$qry="SELECT patientUid,patientName,PatientMobile,patientSex,patientAge,patientSalutation,patientDOB,patientEmail,patientPhone,patientAdd1,patientAdd2,PatientPin,patientCity,patientCountry,PatientState,patientDist,patientBlood,patient_uid_new,isset_patient,patient_uid_new FROM patient_mast where patientUid = $patient_id";
		//$query=$db2->query($qry);
		//return $query->row();//passing all result to controller	

		$db2->select("patientUid,patientName,PatientMobile,patientSex,patientAge,patientSalutation,patientDOB,patientEmail,patientPhone,patientAdd1,patientAdd2,PatientPin,patientCity,patientCountry,PatientState,patientDist,patientPs,patientBlood,patient_uid_new,isset_patient,patient_uid_new,referred_by,patientGurdian,patientRelation,patientAadhaar,patientPassport,patientVisa,patientRace,occupation,photo_url,fcm_reg,patientReligion");
		$db2->from('`patient_mast');
		$db2->where('patientUid',$patient_id);
		$query = $db2->get();
		return $query->row();		
	}	
//--------------temp code-------------------------------------
	
	
	
}
?>