<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Diagnostics_fetch_model extends CI_Model
{
	public function fetch_all_investigation($no_of_record=0,$order_by_fld="",$order_by="",$type=0)
	{
		$this->db->select('uid,test_name,category');
		$this->db->from('investigation');
		$this->db->where('uid!=',0);
		if($type!=0)//lab or non lab
		{
			$this->db->where('category',$type);
		}
		if($no_of_record!=0)
			$this->db->limit($no_of_record);
		if($order_by!="")
			$this->db->order_by($order_by_fld,$order_by);
		else		
			$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_investigation_by_name($text)
	{	
		$this->db->select('uid,test_name,category');
		$this->db->from('investigation');
		$this->db->like('test_name',$text);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_test_parameter_list($text)	
	{
		$this->db->select('uid,parameter');
		$this->db->from('parameter');
		$this->db->like('parameter',$text);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_investigation_record($investigation_id)
	{
		$this->db->select('uid,test_name,ItemID,abbr,group_name,category,criteria,limitation,specimen,app_flag,in_house,duration,patient_tag,department,show_chk');
		$this->db->from('investigation');
		$this->db->where('uid',$investigation_id);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_investigation_parameter_list($investigation_id)
	{
		$this->db->select('ip.uid,p.uid as parameter_uid,parameter,parameter_uid');
		$this->db->from('investigation_parameter ip');
		$this->db->join('parameter p','p.uid=ip.parameter_uid');
		$this->db->where('ip.investigation_uid',$investigation_id);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_parameter_list($no_of_record)	
	{
		$this->db->select('uid,parameter');
		$this->db->from('parameter');
		$this->db->limit($no_of_record);
		$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_parameter_record($parameter_id)
	{
		$this->db->select('uid,parameter,parameter_position,parameter_unit,parameter_method,parameter_instrument,parameter_value,parameter_formula,app_flag,active_flag,consultancy_priority_flag');
		$this->db->from('parameter');
		$this->db->where('uid',$parameter_id);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_parameter_refrange_details($parameter_uid)
	{
		$this->db->select('uid,parameter_uid,referance_range,ref_type,position');
		$this->db->from('parameter_refrange');
		$this->db->where('parameter_uid',$parameter_uid);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_all_investigation_charges($text="",$diagnostics_service_type=0)
	{
		//if service type is not found list all names
		$this->db->select('i.uid,test_name,category,Department,ir.fees,ItemId');
		$this->db->from('investigation i');
		$this->db->join('investigation_rate ir', 'i.uid=ir.investigation_uid');
		if($diagnostics_service_type!=0)
		{
			if($diagnostics_service_type==103)//lab
				$this->db->where('category', 1);		
			if($diagnostics_service_type==104)//Non lab
				$this->db->where('category', 2);
		}			
		
		$this->db->where('clinic_uid', $_SESSION['clinicId']);
		if($text!="")
			$this->db->like('test_name', $text);
		$this->db->order_by('test_name', 'ASC');
			
		
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_investigation_charge($investigation_id)
	{
		$this->db->select('uid,fees');
		$this->db->from('investigation_rate');
		$this->db->where('investigation_uid',$investigation_id);
		$query = $this->db->get();
		return $query->row();		
	}
	public function fetch_lab_list($date_from,$date_to)
	{
		$this->db->select('distinct(b.bill_no),b.billmast_uid,lab_uid');
		$this->db->from('billing b');
		$this->db->join('bill_lab bl', 'b.billmast_uid=bl.billmast_uid');
		$this->db->where_in('service_uid', array(103,104));
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_patients_lab_items($bill_mast_uid)
	{
		$this->db->select('b.uid,item_id,test_name');
		$this->db->from('billing b');
		$this->db->join('investigation i', 'b.item_id=i.uid');
		$this->db->where('billmast_uid', $bill_mast_uid);
		$this->db->where_in('service_uid', array(103,104));
		$query = $this->db->get();
		return $query->result();		
	}
}
?>