<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Doctor_fetch_model extends CI_Model
{
	
	public function fetch_complain_list($no_of_record=0)	
	{
		if($no_of_record==0)//all medicine
			$this->db->select('uid,complain,details');
		else
			$this->db->select('uid,complain,details');
			$this->db->from('complain');
			$this->db->limit($no_of_record);
			$this->db->order_by('uid','DESC');
			$query = $this->db->get();
			return $query->result();//passing all result to controller		
	}
	
	// -------------------------- Complain list/All Field data Fetch Start -------------------
	public function fetch_complain_list_by_name($text)	
	{
		$this->db->select('uid,complain,details');
		$this->db->from('complain');
		$this->db->like('complain',$text);		
		$query=$this->db->get();
		return $query->result();//passing all result to controller	
	}
	public function fetch_complain_by_id($complain_id)	
	{
		$this->db->select('uid,complain,details');
		$this->db->from('complain');
		$this->db->where('uid',$complain_id);		
		$query=$this->db->get();
		return $query->row();//passing all result to controller	
	}	

   //-------------------------- Complain list/All Field data Fetch End -------------------------//	
	public function fetch_advise_activity_data($no_of_record)
	{	
		$this->db->select('uid,topic');
		$this->db->from('masterdb');
		$this->db->where('trap','61');
		$this->db->limit($no_of_record);
		$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_advise_activity_data_by_name($text)
	{	
		$this->db->select('uid,topic');
		$this->db->from('masterdb');
		$this->db->where('trap','61');
		$this->db->like('topic',$text);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_advise_activity_by_id($advice_id)
	{	
		$this->db->select('uid,topic');
		$this->db->from('masterdb');
		$this->db->where('uid',$advice_id);
		$this->db->where('trap','61');
		$query = $this->db->get();
		return $query->row();		
	}	
	public function fetch_diagnosis($no_of_record)
	{
		$this->db->select('uid,diagnosis_name');
		$this->db->from('diagnosis');
		$this->db->limit($no_of_record);
		$this->db->order_by('uid','DESC');
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_diagnosis_by_name($text)
	{	
		$this->db->select('uid,diagnosis_name');
		$this->db->from('diagnosis');
		$this->db->like('diagnosis_name',$text);
		$query = $this->db->get();
		return $query->result();		
	}
/*--------------------all patient history input fetch-------------------*/	
	public function get_recent_saved_invst_record_history($patientId,$currentVisitNo)
	{
		$qry="SELECT vi.uid,vi.parameter_uid,parameter,test_date,test_value,unit_uid,unit_abbr,pm.consultancy_priority_flag FROM visit_investigation vi,investigation_parameter ip,parameter pm,investigation_unit iu WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo and vi.parameter_uid=ip.parameter_uid and ip.parameter_uid=pm.uid and iu.uid=vi.unit_uid";
		$query=$this->db->query($qry);	
		if($query->num_rows()>0)
			return $query->result();
		else
			return 0;		
	}
	public function fetch_advise_investigation($patientId,$currentVisitNo)
	{
		$qry="SELECT visit_investigation_advice.uid,investigation_uid,test_name,priority FROM `visit_investigation_advice`,investigation WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo and investigation.uid=visit_investigation_advice.investigation_uid";
		$query=$this->db->query($qry);	
		return $query->result();		
	}	
	public function get_recent_saved_complain_history($patientId,$currentVisitNo)
	{
		$qry="SELECT visit_complain.uid,complain_uid,complain_duration,complain FROM `visit_complain`,complain WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo and complain.uid=visit_complain.complain_uid";
		$query=$this->db->query($qry);
		if($query->num_rows()>0)		
			return $query->result();
		else
			return 0;		
	}
	public function get_recent_saved_medicine_used_history($patientId,$currentVisitNo)	
	{
		$qry="SELECT uid,medicine_uid,medicine_name,medicine_dosage,medicine_days,medicine_strength FROM `visit_medicine_used` WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->result();		
	}
	public function get_patient_saved_general_history($patientId,$currentVisitNo)
	{
		$qry="SELECT uid,`pulse`, `bp_systolic`, `bp_diastolic`, `temperature`, `respiratory`,`spo2`, `anemia`, `jaundice`, `edema`, `jvp`, `height_cm`, `height_ft`, `weight`, `bmi`, `bsa`,`native_urine_output`,`fluid_intake`, `allergies`, `body_habits` FROM `visit_survey` WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo";
		$result=$this->db->query($qry);	
		if($result->num_rows()>0)
			return $result->row();	
		else
			return 0;
	}
	public function get_recent_saved_diagnosis($patientId,$currentVisitNo)
	{
		$qry="SELECT visit_diagnosis.uid,diagnosis_uid,diagnosis_name FROM `visit_diagnosis`,diagnosis WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo and diagnosis.uid=visit_diagnosis.diagnosis_uid";
		$query=$this->db->query($qry);	
		return $query->result();		
	}
	public function fetch_advise_activity_name($patientId,$currentVisitNo)
	{
		$qry="SELECT visit_activity_advice.uid,advice_uid,topic FROM `visit_activity_advice`,masterdb WHERE masterdb.uid=visit_activity_advice.advice_uid and `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->result();		
	}
	public function get_recent_saved_medicine_advise($patientId,$currentVisitNo)
	{
		$qry="SELECT uid,medicine_uid,medicine_name,medicine_dosage,medicine_days,medicine_strength,medicine_continue_flag FROM `visit_medicine_advice` WHERE `patient_uid`=$patientId and `visit_register_sequence`=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->result();
	}
	public function fetch_dialysis_pt_data($patient_uid,$currentVisitNo)
	{
		$qry="SELECT uid,visit_register_sequence,patient_uid,dialysis_frequency,vascular_access,intradialytic_weight_gain,serology_status FROM visit_dialysis_pt where patient_uid = $patient_uid and visit_register_sequence=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->row();		
	}
	public function fetch_tx_waiting_pt_data($patient_uid,$currentVisitNo)
	{
		$qry="SELECT uid,visit_register_sequence,patient_uid,serology_status FROM visit_tx_waiting_pt where patient_uid = $patient_uid and visit_register_sequence=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->row();		
	}
	public function fetch_post_tx_data($patient_uid,$currentVisitNo)
	{
		$qry="SELECT uid,visit_register_sequence,patient_uid,date_of_tx,`graft_urine_output`,`dsa_report`,`dsa_date`,`pra_report`,`pra_date`,`cross_match`,`cross_match_date` FROM `visit_post_tx_pt` where patient_uid = $patient_uid and visit_register_sequence=$currentVisitNo";
		$query=$this->db->query($qry);	
		return $query->row();		
	}
	public function kb_category()
	{
		$qry="SELECT uid,misc_name,clinic_uid FROM `misc_master` where tag = 9100 and active_flag=1";
		$query=$this->db->query($qry);
		$options = array();
		foreach($query->result_array() as $row)
		{
		   $options [$row['uid']] = $row['misc_name'];
		}
		return $options;		
	}
	public function kb_organ()
	{
		$qry="SELECT uid,misc_name,clinic_uid FROM `misc_master` where tag = 9200 and active_flag=1";
		$query=$this->db->query($qry);
		$options = array();
		foreach($query->result_array() as $row)
		{
		   $options [$row['uid']] = $row['misc_name'];
		}
		return $options;		
	}
	function fetch_kb_data_text($category_value,$organ_value)
	{
		$this->db->select("uid,kb_category,kb_organ,data_text");
		$this->db->from('history_KB');
		//$this->db->join('misc_master mm', 'p.uid=b.patient_uid');		
		$this->db->where('kb_category',$category_value);
		$this->db->where('kb_organ',$organ_value);
		$query = $this->db->get();
		return $query->result();			
	}
	function fetch_saved_kb_hisory_details($patient_uid,$current_visit_no)
	{
		$this->db->select("vh.uid,hkb.data_text,history_code,month_occured,year_occured");
		$this->db->from('visit_history vh');
		$this->db->join('history_KB hkb', 'vh.history_code=hkb.uid');		
		$this->db->where('patient_uid',$patient_uid);
		$this->db->where('visit_register_sequence',$current_visit_no);
		$query = $this->db->get();
		return $query->result();		
	}
	function fetch_visist_kb_hisory_details($patient_uid,$current_visit_no,$history_category,$history_organ)
	{
		$this->db->select("vh.uid,hkb.data_text,history_code,month_occured,year_occured");
		$this->db->from('visit_history vh');
		$this->db->join('history_KB hkb', 'vh.history_code=hkb.uid');		
		$this->db->where('patient_uid',$patient_uid);
		//$this->db->where('visit_register_sequence',$current_visit_no);
		if($history_category!=-1)
			$this->db->where('history_category',$history_category);
		if($history_organ!=-1)
			$this->db->where('history_organ',$history_organ);
		$this->db->order_by('year_occured','DESC');
		$this->db->order_by('month_occured','DESC');
		$query = $this->db->get();
		return $query->result();		
	}	
/*--------------------all patient history input fetch-------------------*/	
	public function fetch_visit_history($patient_uid)	
	{
		$this->db->select('uid,sequence,visit_date');
		$this->db->from('visit_register');
		$this->db->like('patient_uid',$patient_uid);		
		$this->db->order_by('sequence','ASC');		
		$query=$this->db->get();
		return $query->result();//passing all result to controller	
	}	
}
?>