<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Ipd_fetch_model extends CI_Model
{
	public function fetch_vaccant_bed($building,$ward,$bed_status=0)
	{
		$qry="SELECT `uid`,bed_no,ward_uid FROM `bed_master` WHERE building_uid=$building and ward_uid=$ward and vaccant_flag=$bed_status ORDER BY `uid`";
		$query=$this->db->query($qry);
		return $query->result();
	}
	public function fetch_admitted_patient_list($bed)
	{
		$this->db->select('ar.uid,patient_uid,adm_date,adm_time,treating_doctor,bed_uid,p.salutation,p.full_name,e.full_name as treating_doctor_name,b.bed_no');
		$this->db->from('admission_record ar');
		$this->db->join('patient p', 'p.uid=ar.patient_uid');		
		$this->db->join('employee e', 'e.uid=ar.treating_doctor');
		$this->db->join('bed_master b', 'b.uid=ar.bed_uid');		
		$this->db->where('bed_uid', $bed);
		$query=$this->db->get();
		return $query->result();//passing all result to controller			
	}
	function fetch_admitted_patient_info($adm_id)
	{
		$this->db->select('ar.uid, `patient_uid`, `adm_date`, `adm_time`,`discharge_date`, `discharge_time`, `sponsor`, `source`, `billing_category`, `treating_doctor`, `reffer_doctor`, `bed_uid`,p.full_name,dob,e.full_name as treating_doctor_name,b.bed_no');
		$this->db->from('admission_record ar');
		$this->db->join('patient p', 'p.uid=ar.patient_uid');
		$this->db->join('employee e', 'e.uid=ar.treating_doctor');		
		$this->db->join('bed_master b', 'b.uid=ar.bed_uid');		
		$this->db->where('ar.uid', $adm_id);
		$query=$this->db->get();
		return $query->row();//passing all result to controller			
	}
	function fetch_patient_kin_info($adm_id)
	{
		$this->db->select('`kin_name`, `kin_relationship`, `mobile`, `mobile2`, `address1`, `address2`, `city`, `ps`, `pin`, `country`');
		$this->db->from('patient_kin');		
		$this->db->where('ipd_admission_uid', $adm_id);
		$query=$this->db->get();
		return $query->row();//passing all result to controller			
	}	
	function search_services($from_date,$to_date,$patient_admission_no)
	{
		$this->db->select('uid, `patient_uid`, `date_of_service`, `service_uid`, `gross_amount`');
		$this->db->from('billing_ipd ');
		$this->db->where('date_of_service>=', $from_date);
		$this->db->where('date_of_service<=', $to_date);
		$this->db->where('admission_no', $patient_admission_no);
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	function fetch_all_admitted_patient_list($no_of_record=0)
	{
		$this->db->select('`ar.uid`, `patient_uid`, `ar.adm_date`, `ar.adm_time`, `sponsor`, `source`, `billing_category`, `treating_doctor`, `reffer_doctor`, `bed_uid`, `entry_by`, `ar.entry_date_time`,full_name as patient_name,bed_no,ward_uid,misc_name');
		$this->db->from('admission_record ar');
		$this->db->join('patient p', 'p.uid=ar.patient_uid');
		$this->db->join('bed_master b', 'b.uid=ar.bed_uid');		
		$this->db->join('misc_master mm', 'mm.uid=b.ward_uid');		
		//$this->db->where('ar.uid', $adm_id);
		$this->db->order_by('adm_date', 'DESC');
		
		if($no_of_record!=0)
			$this->db->limit($no_of_record); 		
		
		$query=$this->db->get();
		return $query->result();//passing all result to controller			
	}
	function fetch_admitted_patient_by_pidAdmissionBed($search_by,$search_data)
	{
		$this->db->select('`ar.uid`, `patient_uid`, `ar.adm_date`, `ar.adm_time`, `sponsor`, `source`, `billing_category`, `treating_doctor`, `reffer_doctor`, `bed_uid`, `entry_by`, `ar.entry_date_time`,full_name as patient_name,bed_no,ward_uid,misc_name');
		$this->db->from('admission_record ar');
		$this->db->join('patient p', 'p.uid=ar.patient_uid');
		$this->db->join('bed_master b', 'b.uid=ar.bed_uid');
		$this->db->join('misc_master mm', 'mm.uid=b.ward_uid');

		if($search_by=='pid')
			$this->db->where('ar.patient_uid', $search_data);
		if($search_by=='admno')
			$this->db->where('ar.uid', $search_data);
		if($search_by=='bedno')
		{
			$this->db->where('b.bed_no', $search_data);
			$this->db->where('b.vaccant_flag', 1);//occupied
		}			
		
		$this->db->order_by('adm_date', 'DESC');		
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	function fetch_admitted_patient_by_dateBed($from_date,$to_date,$bed_id)
	{
		$this->db->select('`ar.uid`, `patient_uid`, `ar.adm_date`, `ar.adm_time`, `sponsor`, `source`, `billing_category`, `treating_doctor`, `reffer_doctor`, `bed_uid`, `entry_by`, `ar.entry_date_time`,full_name as patient_name,bed_no,ward_uid,misc_name');
		$this->db->from('admission_record ar');
		$this->db->join('patient p', 'p.uid=ar.patient_uid');
		$this->db->join('bed_master b', 'b.uid=ar.bed_uid');
		$this->db->join('misc_master mm', 'mm.uid=b.ward_uid');
		$this->db->where('ar.adm_date>=', $from_date);
		$this->db->where('ar.adm_date<=', $to_date);
		$this->db->where('ar.bed_uid', $bed_id);
		
		$this->db->order_by('adm_date', 'DESC');		
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	function fetch_patient_services_summery($from_date,$to_date,$patient_admission_no)	
	{
		$this->db->select('`service_uid` ,count(quantity) as total_quantity,sum(gross_amount) as total_gross_amount');
		$this->db->from('billing_ipd ');
		if($from_date!="" && $from_date!="1970-01-01")
			$this->db->where('date_of_service>=', $from_date);
		if($to_date!="" && $to_date!="1970-01-01")
			$this->db->where('date_of_service<=', $to_date);
		$this->db->where('admission_no', $patient_admission_no);
		$this->db->group_by("service_uid");
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	function fetch_patient_transaction_summery($from_date,$to_date,$patient_admission_no)	
	{
		$this->db->select('uid,`admission_no`,patient_uid,voucher_date,payment_mode,net_amount');
		$this->db->from('bill_receipt');
		if($from_date!="" && $from_date!="1970-01-01")
			$this->db->where('voucher_date>=', $from_date);
		if($to_date!="" && $to_date!="1970-01-01")
			$this->db->where('voucher_date<=', $to_date);
		$this->db->where('admission_no', $patient_admission_no);
		$this->db->order_by('voucher_date', 'ASC');
		$query=$this->db->get();
		return $query->result();//passing all result to controller		
	}
	public function fetch_patient_receipt_details($receipt_no)
	{
		
		$this->db->select("r.receipt_prefix,r.uid,admission_no,patient_uid,voucher_date,voucher_time,payment_mode,net_amount,card_instrument_no,toward,remarks,e.full_name as employee_name");
		$this->db->from('bill_receipt r');
		$this->db->join('employee e', 'r.employee_uid=e.uid');		
		$this->db->where('r.uid',$receipt_no);
		$query = $this->db->get();
		return $query->row();		
	}
	function fetch_sub_services($service_id,$category)
	{
		$this->db->select('uid,item_name');
		$this->db->from('charges');
		$this->db->where('service_uid',$service_id);
		$this->db->where('charge_category', $category);
		$this->db->order_by('item_name', 'ASC');
		$query=$this->db->get();
		return $query->result();
	}
	public function fetch_service_id_by_admission_no($admission_no)
	{

		$this->db->select("distinct(service_uid)");
		$this->db->from('billing_ipd');
		$this->db->where('admission_no',$admission_no);
		$this->db->order_by('service_uid', 'ASC');
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_patient_service_details($admission_no,$service_id)	
	{
		if($service_id==101)//consultation
		{
			//$qry="SELECT service_uid,item_id,doctor_id,service_amount,bill_date FROM  billing  where bill_no=$bill_no";
			$qry="SELECT service_uid,item_id,quantity,doctor_id,service_amount,discount_amount,gross_amount,bill_date,full_name,mobile FROM  billing_ipd t1,employee t2  where admission_no=$admission_no and service_uid=$service_id and t1.doctor_id=t2.uid  order by service_uid";
		}
		if($service_id==102 || $service_id==105 || $service_id==106 || $service_id==107 || $service_id==108 || $service_id==109 || $service_id==110 || $service_id==112 || $service_id==113 || $service_id==114 || $service_id==115)//for registration record
		{
			$qry="SELECT t1.service_uid,item_id,service_amount,discount_amount,gross_amount,quantity,bill_date,c.item_name FROM  billing_ipd t1,charges c where admission_no=$admission_no and c.uid=t1.item_id and t1.service_uid=$service_id";
		}
		if($service_id==103 || $service_id==104)//other than procedure
		{
			//$qry="SELECT service_uid,item_id,doctor_id,service_amount,bill_date FROM  billing  where bill_no=$bill_no";
			$qry="SELECT service_uid,item_id,doctor_id,service_amount,discount_amount,gross_amount,quantity,bill_date,full_name,t3.test_name FROM  billing_ipd t1,employee t2,investigation t3  where admission_no=$admission_no and service_uid=$service_id and t1.item_id=t3.uid and t1.doctor_id=t2.uid  order by service_uid";
		}		
		
		$query=$this->db->query($qry);
		return $query->result();//passing all result to controller			
	}
	public function fetch_patient_service_total_amount($admission_no,$service_id)	
	{
		$qry="SELECT sum(service_amount) as service_total_amount,sum(discount_amount) as discount_total_amount,sum(gross_amount) as gross_total_amount,count(service_uid) as service_qty FROM  billing_ipd where admission_no=$admission_no and service_uid=$service_id";
		$query=$this->db->query($qry);
		return $query->row();//passing all result to controller			
	}
	public function fetch_patient_payment_details($admission_no)
	{
		$this->db->select("payment_mode,net_amount,receipt_prefix,uid,card_instrument_no,instrument_date,voucher_date");
		$this->db->from('bill_receipt');
		$this->db->where('admission_no',$admission_no);
		$query = $this->db->get();
		return $query->result();		
	}
	public function fetch_bill_info_ip($admission_no)
	{
		$this->db->select("uid,bill_prefix,bill_date,gross_amount,discount_amount,net_amount");
		$this->db->from('billing_master');
		$this->db->where('admission_no',$admission_no);
		$query = $this->db->get();
		return $query->row();		
	}
}
?>