<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php

class Research_fetch_model extends CI_Model
{
	public function fetch_clinic_list($no_of_record=0)	
	{
		if($no_of_record==0)//all medicine
			$this->db->select('t1.uid,clinic_name,address,registration,phone');
		else
			$this->db->select('t1.uid,clinic_name,address,registration,phone');
		$this->db->from('clinic t1');
		$this->db->where('category', 1);
		$this->db->limit($no_of_record);
		$this->db->order_by('clinic_name','DESC');
		$query = $this->db->get();
		return $query->result();//passing all result to controller		
	}
	public function fetch_diagnosis_name()	
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$db2->select('DIAG_ID,DIAG_NAME');
		$db2->from('diagnosis_mast');
		$db2->order_by('DIAG_NAME','ASC');
		$query = $db2->get();

		$options = array();
		$options ['-1'] = "-- Select Name --";
		foreach($query->result_array() as $row)
		{
		   $options [$row['DIAG_ID']] = $row['DIAG_NAME'];
		}
		return $options;		
	}
	public function fetch_all_medicine_name()	
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$db2->select('med_id,med_name');
		$db2->from('med_master');
		$db2->order_by('med_name','ASC');
		$query = $db2->get();

		$options = array();
		$options ['-1'] = "-- Select Name --";
		foreach($query->result_array() as $row)
		{
		   $options [$row['med_id']] = $row['med_name'];
		}
		return $options;		
	}	
	public function fetch_all_investigation_param_name()	
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$db2->select('param_id,param_name');
		$db2->from('test_param');
		$db2->order_by('param_name','ASC');
		$query = $db2->get();

		$options = array();
		$options ['-1'] = "-- Select Name --";
		foreach($query->result_array() as $row)
		{
		   $options [$row['param_id']] = $row['param_name'];
		}
		return $options;		
	}
	public function get_query_data($diagnosis_uid)
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$qry="SELECT `patientUid`,`patientName`,`patientSex` FROM `patient_mast` WHERE `patientUid` in (SELECT distinct(`patientUID`) FROM `visit_diagnosis` WHERE `diag_id` = $diagnosis_uid ) ";
		$query=$db2->query($qry);
		return $query->result();//passing all result to controller		
		
	}
	public function get_query_data_with_medicine($medicine_uid)	
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$qry="SELECT `patient_uid`,`patient_name`,`patient_sex` FROM `temp_query_tbl1` WHERE `patient_uid` in (SELECT distinct(`patientUID`) FROM `visit_medicine` WHERE `medicineID` in ($medicine_uid) )";
		$query=$db2->query($qry);
		return $query->result();//passing all result to controller		
	}
	public function get_query_data_with_investigation($investigation_param,$investigation_value,$operator)	
	{
		$db2 = $this->load->database('drpscaredb', TRUE);		
		$qry="SELECT distinct(tmp.patient_uid),`patient_name`,`patient_sex` FROM temp_query_tbl1 tmp,visit_investigation vi WHERE tmp.patient_uid=vi.patient_UID and tmp.data_set=2 and parameter_id=$investigation_param and parameter_value $operator $investigation_value";//investigation_value contains with operator
		$query=$db2->query($qry);
		return $query->result();//passing all result to controller		
	}
	public function fetch_all_medicine_group()
	{
		$this->db->select('distinct(group_id)');
		$this->db->from('group_medicine');
		$this->db->order_by('group_id','ASC');
		$query = $this->db->get();
		return $query->result();//passing all result to controller			
	}
	public function fetch_medicine_details_from_group($group_id)
	{
		$this->db->select('group_id,medicine_id,strength,dose,days');
		$this->db->from('group_medicine');
		$this->db->where('group_id',$group_id);
		$query = $this->db->get();
		return $query->result();//passing all result to controller			
	}
}