<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed'); ?>
<?php
	include(BASE_DIR."assets/fpdf/fpdf.php");
		$pdf= new FPDF('P',"mm",'A4');
		$pdf->AliasNbPages();
		$pdf->SetAutoPageBreak(true, 15);
		$pdf->AddPage();
		if($_SESSION['print_with_header_flag']==1)
		{
			$pdf->Image(BASE_DIR.'assets/images/logo.png',10,10,18,18);
		}
		if($_SESSION['print_with_header_flag']==0)
		{
			//$pdf->Image(BASE_DIR.'assets/images/gk_logo.png',10,10,18,18);
		}		
		$pdf->ln(2);
		$pdf->SetFont("Arial","B");
		$pdf->SetTextColor(29,122,202);
		$pdf->SetFontSize(13);
		$pdf->text(78,37,"INVOICE CUM RECEIPT",0,1);
		
		$pdf->SetFontSize(11);//address print
		$pdf->SetTextColor(0,0,0);
		$pdf->SetFont("Arial");
		$pdf->SetFontSize(9);
		$pdf->text(140,14,$clinic_details->address);
		$pdf->text(140,18,$clinic_details->address2);
		$pdf->text(140,22,$clinic_details->city.",".$clinic_details->district.",".$clinic_details->pin);
		$pdf->text(140,26,$clinic_details->phone);

		$pdf->SetTextColor(0,0,0);
		$pdf->SetFont("Arial");
		$pdf->SetFontSize(10);

		$pdf->text(16,45,"PUHID");
		$pdf->text(40,45,":");
		$pdf->text(45,45,$patient_personal_invoice_record->patient_uid);

		$pdf->text(16,50,"Patient Name");
		$pdf->text(40,50,":");
		$pdf->text(45,50,$patient_personal_invoice_record->salutation." ".$patient_personal_invoice_record->patient_full_name);

		$pdf->text(16,55,"Age/Sex");
		$pdf->text(40,55,":");
		
		//current age calculate
		$dateOfBirth = date('Y-m-d',strtotime($patient_personal_invoice_record->dob));
		$today = date("Y-m-d");
		$diff = date_diff(date_create($dateOfBirth), date_create($today));
		$cur_age=$diff->format('%y');
					
		if($patient_personal_invoice_record->sex==1)
			$gender="Female";
		else if($patient_personal_invoice_record->sex==2)
			$gender="Male";
		else
			$gender="Others";
		
		$sexage=$cur_age." Years / ".$gender;
		$pdf->text(45,55,$sexage);

		$pdf->text(16,60,"Mobile No");
		$pdf->text(40,60,":");
		$pdf->text(45,60,$patient_personal_invoice_record->mobile);

		$pdf->text(16,65,"Address");
		$pdf->text(40,65,":");
		//$pdf->text(45,65,$patient_personal_invoice_record->address1.",".$patient_personal_invoice_record->address2.",".$patient_personal_invoice_record->city);
		$pdf->text(45,65,$patient_personal_invoice_record->city.",".$patient_personal_invoice_record->pin);
		//$pdf->text(16,70,"Reffered by");
		//$pdf->text(40,70,":");
		//$pdf->text(45,70,$patient_personal_invoice_record->full_name);	


		if(isset($lab_no_data))
		{
		$pdf->text(135,70,"Lab No");
		$pdf->text(165,70,":");
		$pdf->text(170,70,$lab_no_data['lab_no']);
		}


		$pdf->text(135,45,"Invoice No");
		$pdf->text(165,45,":");
		$pdf->text(170,45,$patient_personal_invoice_record->bill_no);
		//$pdf->text(170,45,"1234/123/1");

		$pdf->text(135,50,"Invoice Date/Time");
		$pdf->text(165,50,":");
		$pdf->text(170,50,date("d-m-Y",strtotime($patient_personal_invoice_record->bill_date))."/".date("H:i"));
		//$pdf->text(170,50,"20/04/2020");

		//$pdf->text(135,55,"GST");
		//$pdf->text(165,55,":");
		//$pdf->text(170,55,$billTime);
		//$pdf->text(170,55,$clinic_details->gst);
		
		//$pdf->text(135,60,"CIN");
		//$pdf->text(165,60,":");
		//$pdf->text(170,55,$billTime);
		//$pdf->text(170,60,$clinic_details->cin);		
		
	/*
		$pdf->text(140,60,"Visit No");
		$pdf->text(165,60,":");
	*/	

		$pdf->text(10,75,"------------------------------------------------------------------------------------------------------------------------------------------------------------");
		//$pdf->text(16,80,"Srl. No.");
		$pdf->text(20,80,"Description");
		//$pdf->text(80,80,"Doctor");
		$pdf->text(95,80,"Date");
		$pdf->text(120,80,"Gross");
		$pdf->text(145,80,"Discount");
		$pdf->text(170,80,"Net Amount( Rs.)");		
		$pdf->text(10,85,"------------------------------------------------------------------------------------------------------------------------------------------------------------");
		
		$srl=1;
		$varRow=90;
		$total_bill_amount=0.00;
		
		$row_flag=0;
		
		foreach($service_given as $row)
		{
			
			if($srl<=15)//max 15 records will be print in the description section
			{

				if($row->service_uid==102)
				{
					$varRow+=5;
					$service_name="Administrative";
					$pdf->SetFont("Arial","B");
					$pdf->text(16,$varRow,$service_name);
					$row_flag++;
					$pdf->SetFont("Arial");					
					foreach($administrative_details as $admnRow)
					{
						$varRow+=5;
						$pdf->text(20,$varRow,$srl);
						$pdf->text(24,$varRow,$admnRow->item_name);//doctor name						
					/*	$pdf->text(140,$varRow,date("d-m-Y",strtotime($admnRow->bill_date)));
						$pdf->text(175,$varRow,$admnRow->service_amount);*/				
						$total_bill_amount+=$admnRow->service_amount;
						$pdf->text(95,$varRow,date("d-m-y",strtotime($row->bill_date)));
						$pdf->SetXY(52, $varRow-1);
						$pdf->Cell(0,0,$admnRow->service_amount,0,1,'C');
						$pdf->SetXY(105, $varRow-1);
						$pdf->Cell(0,0,$admnRow->discount_amount,0,1,'C');
						$pdf->SetXY(170, $varRow-1);
						$pdf->Cell(0,0,$admnRow->gross_amount,0,1,'C');							
					}
				}
				else if($row->service_uid==105)
				{
					$varRow+=5;
					$service_name="Dialysis";
					$pdf->SetFont("Arial","B");
					$pdf->text(16,$varRow,$service_name);
					$row_flag++;
					$pdf->SetFont("Arial");					
					foreach($dialysis_details as $row)
					{
						$varRow+=5;
						$pdf->text(20,$varRow,$srl);
						$pdf->text(24,$varRow,$row->item_name);//doctor name						
					/*	$pdf->text(140,$varRow,date("d-m-Y",strtotime($row->bill_date)));
						$pdf->text(175,$varRow,$row->service_amount);*/
						$pdf->text(95,$varRow,date("d-m-y",strtotime($row->bill_date)));
						$pdf->SetXY(52, $varRow-1);
						$pdf->Cell(0,0,$row->service_amount,0,1,'C');
						$pdf->SetXY(105, $varRow-1);
						$pdf->Cell(0,0,$row->discount_amount,0,1,'C');
						$pdf->SetXY(170, $varRow-1);
						$pdf->Cell(0,0,$row->gross_amount,0,1,'C');							
						$total_bill_amount+=$row->service_amount;						
					}
				}				
				else if($row->service_uid==106)
				{
					$varRow+=5;
					$service_name="Procedure";
					$pdf->SetFont("Arial","B");
					$pdf->text(16,$varRow,$service_name);
					$row_flag++;
					$pdf->SetFont("Arial");					
					foreach($procedure_details as $row)
					{
						$varRow+=5;
						$pdf->text(20,$varRow,$srl);
						$pdf->text(24,$varRow,$row->item_name);//doctor name						
					/*	$pdf->text(140,$varRow,date("d-m-Y",strtotime($row->bill_date)));
						$pdf->text(175,$varRow,$row->service_amount);*/
						$pdf->text(95,$varRow,date("d-m-y",strtotime($row->bill_date)));
						$pdf->SetXY(52, $varRow-1);
						$pdf->Cell(0,0,$row->service_amount,0,1,'C');
						$pdf->SetXY(105, $varRow-1);
						$pdf->Cell(0,0,$row->discount_amount,0,1,'C');
						$pdf->SetXY(170, $varRow-1);
						$pdf->Cell(0,0,$row->gross_amount,0,1,'C');						
						$total_bill_amount+=$row->service_amount;
					}
				}
				else if($row->service_uid==107)
				{
					$varRow+=5;
					$service_name="OT services";
					$pdf->SetFont("Arial","B");
					$pdf->text(16,$varRow,$service_name);
					$row_flag++;
					$pdf->SetFont("Arial");					
					foreach($ot_details as $row)
					{
						$varRow+=5;
						$pdf->text(20,$varRow,$srl);
						$pdf->text(24,$varRow,$row->item_name);//doctor name						
					/*	$pdf->text(140,$varRow,date("d-m-Y",strtotime($row->bill_date)));
						$pdf->text(175,$varRow,$row->service_amount);*/
						$pdf->text(95,$varRow,date("d-m-y",strtotime($row->bill_date)));
						$pdf->SetXY(52, $varRow-1);
						$pdf->Cell(0,0,$row->service_amount,0,1,'C');
						$pdf->SetXY(105, $varRow-1);
						$pdf->Cell(0,0,$row->discount_amount,0,1,'C');
						$pdf->SetXY(170, $varRow-1);
						$pdf->Cell(0,0,$row->gross_amount,0,1,'C');						
						$total_bill_amount+=$row->service_amount;						
					}
				}
				else
				{
					
				}
									
				
				//if($row_flag==0)
				//{	

				//	$temp_service_id=$row->service_uid;
				//}
				// $pdf->SetFont("Arial");
				// if($row_flag>0 && $temp_service_id!=$row->service_uid)
				// {
				//	$srl=1;
				//	$varRow+=5;
				//	$pdf->SetFont("Arial","B");
				//	$pdf->text(16,$varRow,$service_name);
				//	$row_flag++;
				// }
				// $pdf->SetFont("Arial");
				// $varRow+=5;
				/*
				if($row->service_uid==105)//if dialysis
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->procedure_name);
				}				
				if($row->service_uid==106)//if procedure
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->procedure_name);
				}
				if($row->service_uid==107)//if procedure
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->operation_details);
				}
				if($row->service_uid==108)//if hospital services
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->visit_details);
				}
				if($row->service_uid==109)//if Bed charges details
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->remarks);
				}				
				if($row->service_uid==103 || $row->service_uid==104)
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->test_name);//item name
				}
				if($row->service_uid==120)//patient registration
				{
					$pdf->text(20,$varRow,$srl);
					$pdf->text(24,$varRow,$row->item_name);//item name
				}				
				
				$pdf->text(140,$varRow,date("d-m-Y",strtotime($row->bill_date)));
				$pdf->text(175,$varRow,$row->service_amount);				
			*/
				$srl++;
				//$varRow+=5;
				
			
			}//end if
		}//end of foreach


		//$pdf->text(80,80,"Rate");


		//$pdf->text(160,80,"Total");

		$pdf->text(10,175,"------------------------------------------------------------------------------------------------------------------------------------------------------------");

		//getting payment details
		$rw=1;
		$varRow=201;
		$total_net=0;
		$tot_discount=0;
		$pdf->SetFontSize(8);
		foreach($patient_payment_details as $row)
		{
			if($rw<=5)//maximum 5row will print in payment mode section
			{
				if($row->payment_mode==1){$payMode="Cash";}
				if($row->payment_mode==2){$payMode="Debit Card";}
				if($row->payment_mode==3){$payMode="Credit Card";}
				if($row->payment_mode==4){$payMode="Cheque";}
				if($row->payment_mode==5){$payMode="Wallet/UPI";}
				if($row->payment_mode==6){$payMode="Advance";}
				
				$pdf->text(16,$varRow,$rw);
				$pdf->text(24,$varRow,$payMode);
				$pdf->text(65,$varRow,$row->net_amount);
				
				$total_net+=$row->net_amount;
				$tot_discount+=$row->discount;
				
				$pdf->text(85,$varRow,$row->card_instrument_no);
				
				//$dayDate=substr($paymentInstrumentDate,8);//Date format stored as 0000-00-00, cut last 2 digit
				//if($dayDate!="00")
				if($row->instrument_date!="")
				{
					$pdf->text(120,$varRow,date("d-m-Y",strtotime($row->instrument_date)));//print when actual date is available in db
				}
				$rw++;
				$varRow+=5;
			}//end if
		}//end foreach
		$pdf->SetFontSize(10);
		$pdf->text(16,190,"Payment Details -");
		
		$pdf->text(16,195,"srl.");
		$pdf->text(24,195,"Mode");
		$pdf->text(45,195,"Receipt No");

		$pdf->text(65,195,"Amount");
		$pdf->text(85,195,"Instrument/Card No");
		$pdf->text(120,195,"Date");
		
		$pdf->text(75,179,"Gross");
		$pdf->text(85,179,":");
		$pdf->text(88,179,$patient_billing_master_details->gross_amount);
		
		$item_discount=(($patient_billing_master_details->gross_amount)-($patient_billing_master_details->net_amount))-($patient_billing_master_details->discount_amount);
		$pdf->text(105,179,"Item(s) Discount");
		$pdf->text(132,179,":");
		$pdf->text(135,179,$item_discount);
		
		$net=$patient_billing_master_details->gross_amount-$item_discount;
		$pdf->text(159,179,"Net Amount");
		$pdf->text(183,179,":");
		$pdf->text(188,179,$net);		
		/*
		$pdf->text(149,190,"Gross bill Amount");
		$pdf->text(183,190,":");
		$pdf->text(188,190,$total_bill_amount);*/
		
		$pdf->text(149,195,"Discount");
		$pdf->text(183,195,":");
		$pdf->text(188,195,$patient_billing_master_details->discount_amount);		
		
		$pdf->text(149,200,"Payable Amount");
		$pdf->text(183,200,":");
		$pdf->text(188,200,$net-($patient_billing_master_details->discount_amount));
		
		$pdf->text(149,205,"Amount Paid");
		$pdf->text(183,205,":");
		$pdf->text(188,205,$total_net);
		
		$pdf->text(149,210,"Balance to Pay");
		$pdf->text(183,210,":");
		$pdf->text(188,210,"0");
		
		$pdf->Line(140, 188, 140, 220);
		
		
		//getting username from user id
	/*	$sql="select `fullname` from user_control where `userid`=?";
		$ustmt=$mysqli->prepare($sql);
		$ustmt->bind_param("i",$userId);
		$ustmt->execute();
		$ustmt->store_result();
		$ustmt->bind_result($generatedUserName);
		$ustmt->fetch();	
		*/
		$pdf->text(16,266,"_______________");
		$pdf->text(18,272,"Signature");
		$pdf->text(16,278,"Generated By : ");
		$pdf->text(41,278,$_SESSION['fullname']);
		$pdf->text(140,278,"Generated On : ");
		$pdf->text(165,278,date('d-m-y'));
		//$pdf->text(165,278,date('d-m-y h:i:sa'));
		$pdf->PageNo();
		$pdf->Output("I","form.pdf");
		//unset print bill id
		//unset($_SESSION['printableBillId']);

?>