<!doctype html>
<html lang="en">
	<head>
		<!-- Required meta tags -->
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
		<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
		<link rel="shortcut icon" type="image/png" href="<?=images_url?>favicon.png"/>
		<title><?=PROJECT_NAME?></title>
		<link href="https://fonts.googleapis.com/css?family=Nunito+Sans:300,400,600,700,800&display=swap" rel="stylesheet">
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css">

		<script src="https://kit.fontawesome.com/d980747999.js"></script>
		<!-- Custom styles for this template -->
		<!-- <link href="<?=css_url?>animate.css" rel="stylesheet"> -->
		<!-- CSS | Theme Color -->
		<link href="<?=css_url?>style.css" rel="stylesheet">
		<link href="<?=css_url?>media.css" rel="stylesheet">
		<!--  <link rel="stylesheet" type="text/css" href="<?=css_url?>flatmenu.css" media="all"/> -->
	</head>
	<body>
		<div id="wrap">
			<div id="main" class="clear-top">
				<?php include("header.php"); ?>
				<div class="home_banner">
					<img src="<?=images_url?>banner.jpg" width="1349" class="w-100" height="655" alt=""> 
				</div>
				<section class="section welcome_section pt-2 pb-5 clearfix" id="welcome">
					<div class="container">
						<div class="row">
							<div class="col-md-4 pt-4">
								<div class="form-label-group">
									<label>Select Location</label>
									<?php
										$select_option['-1']="--Select--";
										$clinic_location_wd_optn=$select_option+$clinic_location;
										$js = 'class="form-control" id="clinic" onchange="load_departments()"';
										echo form_dropdown('clinic',$clinic_location_wd_optn,'0',$js);
									?>
								</div>
							</div>
							<div class="col-md-4 pt-4">     
								<div class="form-label-group">
									<label>Select Department</label>
									<?php
									$departmentsName["0"]="--Select--";
									$js = 'class="form-control" id="departmentsID" onchange="load_doctors()"';
									echo form_dropdown('departmentsID',$departmentsName,'0',$js);
									?>
								</div>
							</div>
							<div class="col-md-4 pt-4">
								<label>Select Doctor</label>
								<?php
									$doctorsName["0"]="--Select--";
									$js = 'class="form-control" id="doctorsID" onchange="get_selected_doctor_details()"';
									echo form_dropdown('doctorsID',$doctorsName,'0',$js);
								?>  
							</div>

						</div>
		  
		  
						<div class="row">
							<div class="col-md-12 pt-4 text-center">
								<div class="row" id="doctor_list_box_div">         
										<?php
										foreach($doctor_list as $record)
										{
											?>
										  <div class="col-md-4">
												<div class="single-choose mb-40">
												  <div class="choose-head">
													<div class="choose-icon mb-25 select_dr_img"> <img src="<?=base_url()?>docicon/<?=$record->photo_url?>" width="100" height="100" alt=""></div>
													<h3><a href="#">Dr. <?=$record->full_name?> </a></h3>
													 <h4><?=$record->qualification?> </h4>
													 <h5><?=$record->designation?><br/></h5>
													<a class="btn custom_btn mt-3" href="<?=base_url()?>Patient/signin?drc=<?=base64_encode($record->doctor_uid)?>">Schedule</a>
												  </div>
												</div>
											</div>			
												<?php			
											}
											?>
								</div>
							</div>
						</div>
					</div>
				</section>
			</div>
		</div>
		<?php include("footer.php"); ?>

		<!-- Bootstrap core JavaScript
			================================================== --> 
		<!-- Placed at the end of the document so the pages load faster --> 

		<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script> 
		<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script> 
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script> 
		<script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/js/bootstrap-select.min.js" ></script> 
		<script>


			function load_departments()
			{
				var clinic_id=$("#clinic").val();
			//alert(clinic_id);
				$.post("<?=base_url()?>Common/load_departments",{'clinic_id':clinic_id},function(data){
						$("#departmentsID").html(data);
					});
					
					
			}
			function load_doctors()
			{
				var clinic_id=$("#clinic").val();
				var department_id=$("#departmentsID").val();
				if(department_id!=-1)
				{
					$.ajax({
					  type: "POST",
					  url: '<?=base_url()?>Common/get_doctors',
					  data: {'clinic_id':clinic_id,'department_id':department_id},
					  success: function(data)
								{	
									$("#doctorsID").html(data);
								}
					});
				}	
				$.ajax({
				  type: "POST",
				  url: '<?=base_url()?>Patient/get_doctors_widget_view',
				  data: {'clinic_id':clinic_id,'department_id':department_id},
				  success: function(data)
							{	
								$("#doctor_list_box_div").html(data);
							}
				});		
			}
			function get_selected_doctor_details()
			{
				var doctor_id=$("#doctorsID").val();
				$.ajax({
				  type: "POST",
				  url: '<?=base_url()?>Patient/get_selected_doctor_detail',
				  data: {'doctor_id':doctor_id},
				  success: function(data)
							{	
								$("#doctor_list_box_div").html(data);
							}
				});	
			}

		</script>
	</body>
</html>