<!doctype html>
<html lang="en">
	<head>
		<!-- Required meta tags -->
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
		<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
		<link rel="shortcut icon" type="image/png" href="<?=images_url?>favicon.png"/>
		<title><?=PROJECT_NAME?></title>
		<link href="https://fonts.googleapis.com/css?family=Nunito+Sans:300,400,600,700,800&display=swap" rel="stylesheet">
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css">
		<script src="https://kit.fontawesome.com/d980747999.js"></script>
		<!-- Custom styles for this template -->
		<!-- <link href="<?=css_url?>animate.css" rel="stylesheet"> -->
		<!-- CSS | Theme Color -->
		<link href="<?=css_url?>style.css" rel="stylesheet">
		<link href="<?=css_url?>media.css" rel="stylesheet">
		<!--  <link rel="stylesheet" type="text/css" href="<?=css_url?>flatmenu.css" media="all"/> -->

		<link rel="stylesheet" href="<?=css_url?>bootstrap-datetimepicker.min.css" type="text/css" media="all" />
		<link href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.min.css" rel="stylesheet"/>
		<style type="text/css">
		.box{
				display: none;
			}
			.age
			{
				display:block;
			}
		</style>
	</head>

<body>
	<div id="wrap">
		<div id="main" class="clear-top">
			<?php include("header.php"); ?>
			<section class="section welcome_section pt-3 pb-3 clearfix">
				<div class="container">
					<div class="row">
						<div class="col-md-8  mx-auto">
							<div class="card card-signin my-5">
								<div class="card-body">
									<h5 class="card-title text-center">Registration</h5>
									<form method="post" action="<?=base_url()?>Patient/registration">
										<span class="text-danger"><?php echo $this->session->flashdata("error"); ?></span>
										<div class="row">
											<div class="col-md-4">
												<div class="form-label-group">
													<label >Full Name</label>
													<input  class="form-control custom_form" placeholder="Enter" id="patient_name" name="patient_name" required autofocus>
													<?php echo form_error('patient_name'); ?>
												</div>
											</div>
											<div class="col-md-4">
												<div class="form-label-group">
													<label >Gender</label>
													<select class="form-control custom_form" id="gender" name="gender">
														<option value="2">Male</option>
														<option value="1">Female</option>
														<option value="3">Transgender</option>
													</select>
												</div>
											</div>
											<div class="col-md-4">
												<div class="form-label-group">
													<label style="width:auto; display:inline-block;"><input  type="radio" name="1" value="age" checked> Age</label>
													<label style="width:auto; display:inline-block;">
													<input type="radio" name="1" value="dob"> D.O.B</label>
			
													<div class="age box">
														<input class="form-control custom_form" type="text" id="age" name="age" placeholder="Age as on 1st JAN of this year" >
													</div>
													<div class="dob box">
														<div class="input-group date id_4">
															<input type="text" id="dob" name="dob"  class="form-control" />
															<div class="input-group-addon input-group-append">
																<div class="input-group-text"> 
																	<i class="glyphicon glyphicon-calendar fa fa-calendar"></i> 
																</div>
															</div>
														</div>			
													</div>
					
												</div>
											</div>
				  
											<div class="col-md-6">
												<div class="form-label-group">
													<label >Mobile Number <span style="font-size:10px;">(An OTP will be send to this number for login)</span></label>
													<input  class="form-control custom_form" id="mobile" name="mobile" placeholder="Enter"  autofocus>
													<?php echo form_error('mobile'); ?>
												</div>
											  
											</div>
											<div class="col-md-6">
												<div class="form-label-group">
													<label >Email</label>
													<input  class="form-control custom_form" id="email_id" name="email_id" placeholder="Enter"  autofocus>
												</div>
											</div>
				  
											<div class="col-md-4">
												<div class="form-label-group">
													<label >City</label>
													<input  class="form-control custom_form" id="city" name="city" placeholder="Enter"  autofocus>
												</div>              
											</div>
											<div class="col-md-4">
												<div class="form-label-group">
													<label >Pin Code</label>
													<input  class="form-control custom_form" id="pin" name="pin" placeholder="Enter"  autofocus>
												</div>              
											</div>
											<div class="col-md-4">
												<div class="form-label-group">
													<label >Select Country</label>
														<?php
															$js = 'class="form-control" id="country_code" onChange="loadDistrict(this.value);"';
															echo form_dropdown('country_code',$country,'76',$js);
														?>
												</div>              
											</div>
				  
											<div class="col-md-12 text-right pt-2">
												<button class="btn custom_btn  text-uppercase" style="display:inline-block; width:auto;" type="submit">Register</button>
											</div>
				 						</div>
									</form>
								</div>
							</div>
						</div>
  					</div>
				</div>
			</section>
		</div>
	</div>
	<?php include("footer.php"); ?>

	<!-- Bootstrap core JavaScript
		================================================== --> 
	<!-- Placed at the end of the document so the pages load faster --> 

	<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script> 
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script> 
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script> 
	<script type="text/javascript" src="<?=js_url?>flatmenu-responsive.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.9.0/moment-with-locales.min.js"></script>
	<script type="text/javascript" src="<?=js_url?>bootstrap-datetimepicker.min.js"></script> 
	<script type="text/javascript" src="<?=js_url?>demo.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
	<script type="text/javascript">
		$(".jumper").on("click", function( e ) {
			
			e.preventDefault();

			$("body, html").animate({ 
				scrollTop: $( $(this).attr('href') ).offset().top 
			}, 600);
			
		});
		
		$(document).ready(function(){
			$('input[type="radio"]').click(function(){
				var inputValue = $(this).attr("value");
				var targetBox = $("." + inputValue);
				$(".box").not(targetBox).hide();
				$(targetBox).show();
			});
		});
		function loadDistrict(state_id)
		{
			$.post("<?=base_url()?>Gateway/load_district",{state_id:state_id},function(data){
				$("#district").html(data);
			});
		}
	</script>
	<?php
	if(isset($_SESSION['success']))
	{
		echo '<script>toastr.success("'.$_SESSION['success'].'","Success");</script>';
	}
	?>
</body>
</html>